dnl file dg87check.m4
dnl 
dnl     Diogene87
dnl     Copyright (C) 2003,2004,2005,2006,2007 - Dominique Parisot
dnl
dnl This program is free software; you can redistribute it and/or modify
dnl it under the terms of the GNU General Public License as published by
dnl the Free Software Foundation; either version 2, or (at your option)
dnl any later version.
dnl
dnl This program is distributed in the hope that it will be useful,
dnl but WITHOUT ANY WARRANTY; without even the implied warranty of
dnl MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
dnl GNU General Public License for more details.
dnl
dnl You should have received a copy of the GNU General Public License
dnl along with this software; see the file COPYING.  If not, write to
dnl the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
dnl Boston, MA 02111-1307 USA
dnl
dnl __________________________________________________________________________
dnl
dnl avaliable functions: 
dnl 
dnl  DG_M4_ERROR([message])
dnl  DG_WAIT(message)
dnl  DG_PRINT(message)
dnl  DG_PRINT_NO_RC(message)
dnl  DG_DIE([message])
dnl  DG_BEGIN(script_name,script_description)
dnl  DG_END
dnl  DG_MSG_CHECKING([number])
dnl  DG_MSG_DONE([number])
dnl  DG_IF
dnl  DG_IF(condition,then[,alors])
dnl
dnl  DG_SHELL_EXEC(shell_command,[var_result[,if_success[,if_abort]]])
dnl  DG_DIOCMD(command)
dnl
dnl  DG_EXEC(dio87d_command,[var_result[,if_success[,if_abort]]])
dnl  DG_EXEC_OR_DIE(command[,error_message)
dnl  DG_EXEC_SILENT(command)
dnl  DG_EXEC_RETRY(command,timeout[,error_message])
dnl  DG_EXEC_WAIT(command, result, timeout, [error_message])
dnl  DG_EXEC_FIND(command, attempted_result, [if_success], [if_abort])
dnl  DG_CHECK_FIELD(command,field,value,[error_msg],[timeout])
dnl
dnl  DG_ABORT_IF_NOT_SUCCESS([message])
dnl  DG_CONTROL_SCRIPT_NAME
dnl  DG_DIO87D_START
dnl  DG_DIO87D_STOP
dnl  DG_MEMORY([number])
dnl  DG_MEMORY_CHECK([number])
dnl  
dnl __________________________________________________________________________
dnl  
changequote([,])dnl
define([DG_IPPORT],[9993])dnl
dnl __________________________________________________________________________
dnl
dnl DG_M4_ERROR([message])
dnl
define([DG_M4_ERROR],[dnl
ifelse([[$1]],,,errprint([$1]
))dnl
m4exit(1)dnl
])dnl
dnl __________________________________________________________________________
dnl
dnl DG_WAIT(message)
dnl
define([DG_WAIT],[dnl
ifelse($1,, [DG_M4_ERROR([$0 : missing argument 1])])dnl
sleep $1 dnl
])dnl
dnl __________________________________________________________________________
dnl
dnl DG_PRINT(message)
dnl
define([DG_PRINT],[dnl
ifelse($1,, [DG_M4_ERROR([$0 : missing argument 1])])dnl
dnl goto begin of next line if necessary
ifdef([msg_checking],[dnl
echo ""dnl
])
echo "$1"dnl
])dnl
dnl __________________________________________________________________________
dnl
dnl DG_PRINT_NO_RC(message)
dnl
define([DG_PRINT_NO_RC],[dnl
ifelse($1,, [DG_M4_ERROR([$0 : missing argument 1])])dnl
printf "$1"dnl
define([DG_RC])
])dnl
dnl
dnl __________________________________________________________________________
dnl
dnl DG_DIE([message])
dnl
define([DG_DIE],[dnl
ifelse($1,,, [DG_PRINT($1);])dnl
exit 1 dnl
])dnl
dnl __________________________________________________________________________
dnl 
dnl DG_BEGIN(script_name,script_description)
dnl
define([DG_BEGIN],[dnl
ifelse($1,, [DG_M4_ERROR([$0 : missing argument 1])])dnl
ifelse($2,, [DG_M4_ERROR([$0 : missing argument 2])])dnl
define([DG_SCRIPT_NAME],[$1])dnl
DG_PRINT([__________________________________________________________________])
DG_PRINT([|])
DG_PRINT([| $1 ($2)])
DG_PRINT([|])
])dnl
dnl __________________________________________________________________________
dnl 
dnl DG_END
dnl
define([DG_END],[dnl
undefine([DG_SCRIPT_NAME])dnl
dnl remove the data directory
i=0
while ls "$DATAPATH" | grep "dio87d.pid" >/dev/null
do
	i=$((i+1))
	sleep 1
	if test $i -eq 10 
	then 
		echo "The PID file is not deleted"
		exit 1
	fi
done
rm -f "$DATAPATH"/*.conf || exit 1
rm -f "$DATAPATH"/*.data || exit 1
rmdir "$DATAPATH" || exit 1
])dnl
dnl
dnl __________________________________________________________________________
dnl
dnl DG_MSG_CHECKING([number])
dnl
define([DG_MSG_CHECKING],[dnl
ifelse($1,, [DG_M4_ERROR([$0 : missing argument 1])])dnl
ifdef([msg_checking],[DG_M4_ERROR([$0 : function already called])])dnl
define([msg_checking])dnl
DG_PRINT_NO_RC([ $1 substr(dnl
[................................................................],dnl
eval(len($1)))])dnl
])dnl
dnl __________________________________________________________________________
dnl
dnl DG_MSG_DONE([number])
dnl
define([DG_MSG_DONE],[dnl
ifdef([msg_checking],,[DG_M4_ERROR([$0 : dg_msg_checking was not called])])dnl
undefine([msg_checking])dnl
DG_PRINT([ done])dnl
])dnl
dnl
dnl __________________________________________________________________________
dnl
dnl DG_IF(condition,then[,else])
dnl
define([DG_IF],[dnl
ifelse($1,, [DG_M4_ERROR([$0 : missing argument 1])])dnl
ifelse($2,, [DG_M4_ERROR([$0 : missing argument 2])])dnl
if [[ $1 ]]; then
$2
ifelse($3,[],,[dnl
else
$3
])dnl
fi
])dnl
dnl __________________________________________________________________________
dnl
dnl DG_WHILE(condition,instruction)
dnl
define([DG_WHILE],[dnl
ifelse($1,, [DG_M4_ERROR([$0 : missing argument 1])])dnl
ifelse($2,, [DG_M4_ERROR([$0 : missing argument 2])])dnl
while $1 ; do 
$2
done
])dnl
dnl __________________________________________________________________________
dnl
dnl DG_SHELL_EXEC(shell_command,[var_result,[,if_success[,if_abort]]])
dnl
define([DG_SHELL_EXEC], [dnl
ifelse($1,, [DG_M4_ERROR([$0 : missing argument 1])])dnl
ifelse($2,, [$1 > /dev/null] ,[$2=`$1`])
ifelse($3,,[dnl
ifelse($4,,,[dnl
DG_IF([$? -ne 0],[$4])dnl
])dnl
],[dnl
DG_IF([$? -eq 0],[$3],[$4])dnl
])dnl
])dnl
dnl __________________________________________________________________________
dnl
dnl DG_DIOCMD(command)
dnl
define([DG_DIOCMD],[dio87c -- $1])dnl
dnl __________________________________________________________________________
dnl
dnl DG_EXEC(dio87d_command,[var_result[,if_success[,if_abort]]])
dnl
define([DG_EXEC], [dnl
ifelse($1,, [DG_M4_ERROR([$0 : missing argument 1])])dnl
DG_SHELL_EXEC(DG_DIOCMD($1),$2,$3,$4)dnl
])dnl
dnl __________________________________________________________________________
dnl
dnl DG_EXEC_OR_DIE(command[,error_message)
dnl
define([DG_EXEC_OR_DIE], [dnl
ifelse($1,, [DG_M4_ERROR([$0 : missing argument 1])])dnl
ifelse($2,[],[dnl
DG_DIOCMD($1) || DG_DIE()dnl
],[dnl
DG_DIOCMD($1) 
DG_ABORT_IF_NOT_SUCCESS($2)
])dnl
])dnl
dnl __________________________________________________________________________
dnl
dnl DG_EXEC_SILENT(command)
dnl
define([DG_EXEC_SILENT], [dnl
ifelse($1,, [DG_M4_ERROR([$0 : missing argument 1])])dnl
DG_DIOCMD($1) >/dev/null 2>&1dnl
])dnl
dnl __________________________________________________________________________
dnl
dnl DG_EXEC_RETRY(command,timeout[,error_message])
dnl
define([DG_EXEC_RETRY],[dnl
ifelse($1,, [DG_M4_ERROR([$0 : missing argument 1])])dnl
ifelse($2,, [DG_M4_ERROR([$0 : missing argument 2])])dnl
ntry=0
DG_WHILE( [! DG_EXEC_SILENT($1)],[dnl
DG_IF([$ntry -ge $2], DG_DIE([Timeout error! $3]))dnl
DG_WAIT(1); ntry=$(($ntry+1))dnl
])dnl
])dnl
dnl __________________________________________________________________________
dnl
dnl DG_EXEC_WAIT(command, result, timeout, [error_message])
dnl
define([DG_EXEC_WAIT],[dnl
ifelse([$1],, [DG_M4_ERROR([$0 : missing argument 1])])dnl
ifelse([$2],, [DG_M4_ERROR([$0 : missing argument 2])])dnl
ifelse([$3],, [DG_M4_ERROR([$0 : missing argument 3])])dnl
define([DG_CMD],[$1])dnl
define([DG_VALUE],[$2])dnl
define([DG_MAX],[$3])dnl
define([DG_ERROR_MSG],[$4])dnl
res=""; n=0
DG_WHILE([test $n -ne DG_MAX],[dnl
	res="$(DG_DIOCMD([DG_CMD]))"
	test "$res" = "DG_VALUE" && return 0 
	sleep 1; n=$(($n+1))dnl
])dnl
DG_PRINT([ERROR:\n\t-command:(DG_CMD)\n\t-result:($res)\n\t-attempted:(DG_VALUE)])
DG_DIE(DG_ERROR_MSG)
])dnl
dnl __________________________________________________________________________
dnl
dnl DG_EXEC_FIND(command, attempted_result, error_msg)
dnl
define([DG_EXEC_FIND],[dnl
ifelse([$1],, [DG_M4_ERROR([$0 : missing argument 1])])dnl
ifelse([$2],, [DG_M4_ERROR([$0 : missing argument 2])])dnl
define([DG_CMD],[$1])dnl
define([DG_ATTEMPTED],[$2])dnl
define([DG_IF_SUCCESS],[$3])dnl
define([DG_IF_ERROR],[$4])dnl
DG_EXEC([DG_CMD],res,,DG_DIE([The command 'DG_CMD' returns an error]))
DG_SHELL_EXEC([echo "$res" | grep "^DG_ATTEMPTED()$"],,
	DG_IF_SUCCESS, DG_IF_ERROR)dnl
])dnl
dnl __________________________________________________________________________
dnl
dnl DG_CHECK_FIELD(command,field,value,[error_msg],[timeout])
dnl
define([DG_CHECK_FIELD],[dnl
ifelse([$1],, [DG_M4_ERROR([$0 : missing argument 1])])dnl
ifelse([$2],, [DG_M4_ERROR([$0 : missing argument 2])])dnl
ifelse([$3],, [DG_M4_ERROR([$0 : missing argument 3])])dnl
define([DG_CMD],[$1])dnl
define([DG_FIELD],[$2])dnl
define([DG_VALUE],[$3])dnl
define([DG_ERROR_MSG],[$4])dnl
define([DG_TIMEOUT],[$5])dnl
ifelse(DG_TIMEOUT,,[dnl
dnl timeout is not specified
DG_EXEC(DG_CMD(),res,,DG_DIE([The command 'DG_CMD()' returns an error]))dnl
DG_SHELL_EXEC([echo "$res" | grep "^DG_FIELD():.DG_VALUE()$"],,,[dnl
DG_PRINT([ERROR: The command (DG_CMD) does not return (DG_FIELD:DG_VALUE)]) dnl
DG_DIE(DG_ERROR_MSG)dnl
])dnl
],[dnl
dnl timeout is specified
n=0
DG_WHILE([true],[dnl
DG_EXEC(DG_CMD(),res,,DG_DIE([The command 'DG_CMD()' returns an error]))dnl
DG_SHELL_EXEC([echo "$res" | grep "^DG_FIELD():.DG_VALUE()$"],res,[break])dnl
n=$(($n + 1))
dnl we can't use DG_IF because DG_TIMEOUT is not replaced by its value
if test $n -ge DG_TIMEOUT ; then
DG_PRINT([ERROR:\n\t-command:(DG_CMD)])
DG_PRINT([\t-attempted:(DG_FIELD:DG_VALUE)\n\t-result:(DG_VALUE)])
DG_DIE(DG_ERROR_MSG)
fi
])dnl while
])dnl ifelse 
])dnl
dnl
dnl __________________________________________________________________________
dnl
dnl The following script is insterted at the begining of each generated
dnl script
dnl
#! /bin/sh
#
#      Diogene87
#      Copyright (C) 2003,2004,2005,2006,2007 - Dominique Parisot
#
if [[ "x$buildpath" = "x" ]] ; then
	buildpath=`pwd`
fi
if [[ "`uname`" = "Linux" -o "`uname`" = "AIX" ]] ; then
	ulimit -c unlimited
	ulimit -n 10
fi

dio87d_dir="$buildpath/../src/dio87d"
dio87c_dir="$buildpath/../src/dio87c"
dio87d_cmd="$dio87d_dir/dio87d"
dio87c_cmd="$dio87c_dir/dio87c"
PATH="$dio87d_dir:$dio87c_dir:$PATH"
export PATH
export DG87_USER="admin"
export DG87_PASSWORD=""
JOBPATH="$buildpath/$srcdir/jobs"
DATAPATH="$buildpath/data"
dayDate=`date +"%Y-%m-%d %H:%M:%S"`
# check data directory
DG_IF([! -d "$DATAPATH" ],[dnl
# create directory
mkdir "$DATAPATH" || exit 1 dnl
],[dnl
# remove previous data files
rm "$DATAPATH"/* -f >/dev/null 2>&1 dnl
])dnl
# create 'dio87d' configuration file
cat > $DATAPATH/dio87d.conf << EOF
IPPORT=DG_IPPORT()
PID_FILE=$DATAPATH/dio87d.pid
DATA_DIR=$DATAPATH
SAVE_TEMPO=300
LOG_LEVEL=NONE
EOF

# create 'dio87c' configuration file
cat > $DATAPATH/dio87c.conf << EOF
DG87_ADDRESS=localhost
DG87_IPPORT=DG_IPPORT()
EOF
dnl
dnl check if a daemon is already running
DG_SHELL_EXEC([ps -e | grep [[d]]io87d],,
	DG_DIE([dio87d is already running]))dnl
dnl __________________________________________________________________________
dnl
dnl DG_ABORT_IF_NOT_SUCCESS([message])
dnl
define([DG_ABORT_IF_NOT_SUCCESS],[dnl
DG_IF([ $? -ne 0], DG_DIE($1))dnl
])dnl
dnl __________________________________________________________________________
dnl
dnl DG_CONTROL_SCRIPT_NAME
dnl
define([DG_CONTROL_SCRIPT_NAME],[dnl
ifelse([$1],, [DG_M4_ERROR([$0 : missing argument 1])])dnl
ifdef([DG_SCRIPT_NAME],,[DG_M4_ERROR([$1 : DG_BEGIN was not called !])])dnl
])dnl
dnl __________________________________________________________________________
dnl
dnl DG_DIO87D_START
dnl
define([DG_DIO87D_START],[dnl
DG_CONTROL_SCRIPT_NAME([$0])dnl
DG_MSG_CHECKING([Start dio87d])
# initialize previous database
rm DATAPATH/dio87d.data >/dev/null 2>&1
"$dio87d_cmd" -C "$DATAPATH/dio87d.conf" -I >/dev/null 2>&1
"$dio87d_cmd" -C "$DATAPATH/dio87d.conf" -d $DAEMON_OPTION
sleep 1
DG_EXEC_SILENT(version)
DG_ABORT_IF_NOT_SUCCESS([Can't communicate with dio87d])
DG_MSG_DONE()dnl
])dnl
dnl __________________________________________________________________________
dnl
dnl DG_DIO87D_STOP
dnl
define([DG_DIO87D_STOP],[dnl
DG_CONTROL_SCRIPT_NAME([$0])
DG_MSG_CHECKING([Stop dio87d])
dnl find the pid of dio87d
DG_SHELL_EXEC([ps -e | grep [[d]]io87d],pid,,
	DG_DIE([dio87d is not executing]))dnl
pid=`echo $pid | awk '{print $[1]}'`
kill -s TERM $pid
DG_WAIT(1)
DG_SHELL_EXEC([ps -e | grep [[d]]io87d],,DG_DIE([dio87d is not stopped]))dnl
DG_MSG_DONE()dnl
])dnl
dnl __________________________________________________________________________
dnl
dnl DG_MEMORY([number])
dnl
define([DG_MEMORY],[dnl
ifelse($1,, [DG_M4_ERROR([$0 : missing argument 1])])dnl
dnl check that counter is not already used
ifdef([def_mem$1],[DG_M4_ERROR([$0 : counter $1 already used])])dnl
define([def_mem$1])dnl
DG_EXEC([memory],mema$1)dnl
DG_IF([$? -ne 0],[dnl
DG_IF(["$mema$1" = "Unknown command 'memory'"], dnl
[mema$1=0], dnl
[DG_DIE([Error of the memory command])] dnl
)dnl
])dnl
])dnl
dnl __________________________________________________________________________
dnl
dnl DG_MEMORY_CHECK([number])
dnl
define([DG_MEMORY_CHECK],[dnl
ifelse($1,, [DG_M4_ERROR([$0 : missing argument 1])])dnl
dnl check that dg_memory was called for this counter
ifdef([def_mem$1],,[DG_M4_ERROR([$0 : DG_MEMORY($1) was not called])])dnl
undefine([def_mem$1])dnl
DG_EXEC([memory],memb$1)dnl
DG_IF([$? -ne 0],[dnl
DG_IF(["$memb$1" = "Unknown command 'memory'"], dnl
[memb$1=0], dnl
[DG_DIE([Error of the memory command])] dnl
)dnl
])dnl
DG_IF([ $mema$1 -ne $memb$1 ], dnl
	DG_DIE([Memory error : $mema$1 -> $memb$1]))dnl
])dnl
dnl __________________________________________________________________________
