DG_BEGIN([tst02], [Test target and queue commands])
DG_DIO87D_START()

dnl ---------------------------------------------------------------------------
DG_MSG_CHECKING([Check target commands])
DG_MEMORY(1)

DG_EXEC_OR_DIE([ta tg1],[Can't create a new target!])
DG_EXEC_OR_DIE([ta tg2],[Can't create a new target!])
DG_EXEC([tc],res,,DG_DIE([Can't get target count!]))
DG_IF([$res -ne 3],DG_DIE([Target count is not 3!]))
DG_EXEC([tl | grep "^localhost$"],,, DG_DIE([Can't find the localhost target!]))
DG_EXEC([tl | grep "^tg1$"],,, DG_DIE([Can't find the target tg1!]))
DG_EXEC([tl | grep "^tg2$"],,, DG_DIE([Can't find the target tg2!]))

dnl try to add another target with the same name
DG_EXEC([ta tg1],,DG_DIE([Can add a second target with the same name!]))
DG_EXEC([tc],res,,DG_DIE([Can't get target count!]))
DG_IF([$res -ne 3],DG_DIE([Target count is not 3!]))

dnl check the tsn command 
DG_EXEC_OR_DIE([tsn tg1 new_tg1],[Can't rename the target!])
DG_EXEC([tl | grep "^new_tg1$"],,, DG_DIE([Can't find the renamed target!]))
DG_EXEC_OR_DIE([tsn new_tg1 tg1],[Can't rename the target!])
DG_EXEC([tsn tg1 tg2],,[Can rename a target with a name which already exists!])
DG_EXEC([tl | grep "^tg1$"],,, DG_DIE([Can't find the target tg1!]))
DG_EXEC([tl | grep "^tg2$"],,, DG_DIE([Can't find the target tg2!]))

dnl check the tsd command 
DG_EXEC_OR_DIE([tsd tg1 new_description],[Can't change the target description!])
DG_EXEC([ti -S_ tg1 | grep "^Description_new_description$"],,, 
	DG_DIE([Target description is not set!]))
DG_EXEC_OR_DIE([tsd tg1 ""],[Can't erase the target description!])
DG_EXEC([ti -S_ tg1 | grep "^Description_$"],,, 
	DG_DIE([Target description is not set!]))

dnl change the open property of a target
DG_EXEC_OR_DIE([tso tg1 false],[Can't change the 'opened' property!])
DG_EXEC([ti -S_ tg1 | grep "^Opened_false$"],,, 
	DG_DIE([The 'opened' property is not set!]))
DG_EXEC_OR_DIE([tso tg1 true],[Can't change the 'opened' property!])
DG_EXEC([ti -S_ tg1 | grep "^Opened_true$"],,, 
	DG_DIE([The 'opened' property is not set!]))

dnl change the IP Port property of a target
DG_EXEC_OR_DIE([tsp tg1 8888],[Can't change the IP Port property!])
DG_EXEC([ti -S_ tg1 | grep "^IP Port_8888$"],,, 
	DG_DIE([The 'IP port' property is not set!]))

DG_EXEC_OR_DIE([tk tg1],[Can't delete a target!])
DG_EXEC_OR_DIE([tk tg2],[Can't delete a target!])
DG_EXEC([tc],res,,DG_DIE([Can't get target count!]))
DG_IF([$res -ne 1],DG_DIE([Target count is not 1!]))

DG_EXEC([tk xxx],,DG_DIE([Can kill a target which does not exist!]))
DG_EXEC([tk localhost],,DG_DIE([Can kill a 'localhost' target!]))
DG_EXEC([tc],res,,DG_DIE([Can't get target count!]))
DG_IF([$res -ne 1],DG_DIE([Target count is not 1!]))
DG_EXEC([tl | grep "^localhost$"],,, DG_DIE([Can't find the localhost target!]))

dnl check character control of the ta command
DG_EXEC_OR_DIE([ta "abAZ09-"], [Can't create a target with valid character!])
DG_EXEC([tl | grep "^abAZ09-$"],,, DG_DIE([Can't find the target!]))
DG_EXEC_OR_DIE([tk "abAZ09-"])
DG_EXEC([ta "target@"],, DG_DIE([Can add a target with invalid character!]))
DG_EXEC([tl | grep "^target@$"],, DG_DIE([The target was created!]))
DG_EXEC([ta ""],,DG_DIE([Can add a target with an empty name!]))

dnl check character control of the tsn command
DG_EXEC_OR_DIE([ta tg1])
DG_EXEC_OR_DIE([tsn tg1 "abAZ09-"], 
	[Can't rename a target with valid character!])
DG_EXEC([tl | grep "^abAZ09-$"],,, DG_DIE([Can't find the target!]))
DG_EXEC_OR_DIE([tsn "abAZ09-" tg1])
DG_EXEC([tsn tg1 "target@"],, 
	DG_DIE([Can rename a target with invalid character!]))
DG_EXEC([tl | grep "^target@$"],, DG_DIE([The target was created!]))
DG_EXEC_OR_DIE([tk tg1])

dnl check the localhost target
DG_EXEC([tl | grep "^localhost$"],,, DG_DIE([Can't find the localhost target!]))
DG_EXEC([tc],res,,DG_DIE([Can't get target count!]))
DG_IF([$res -ne 1],DG_DIE([Target count is not 1!]))
dnl try to kill the localhost target
DG_EXEC([tk localhost],,DG_DIE([Can kill the localhost target!]))
DG_EXEC([tl | grep "^localhost$"],,, 
	DG_DIE([The localhost target has been deleted!]))
dnl try to rename the localhost target
DG_EXEC([tsn localhost new_name],,DG_DIE([Can rename the localhost target!]))
DG_EXEC([tl | grep "^localhost$"],,,
	DG_DIE([The localhost target has been renamed!]))
dnl try to rename the localhost target
DG_EXEC([tsp localhost 8888],,DG_DIE([Can change the localhost IP port!]))
DG_EXEC([ti -S_ localhost | grep "^IP Port_8888$"],,
	DG_DIE([The IP port of localhost has been changed!]))
dnl try to set the hostname
DG_EXEC([tsh localhost new_hostname],,
	DG_DIE([Can change the hostname of localhost!]))
DG_EXEC([ti -S_ localhost | grep "^Host Name_$"],,,
	DG_DIE([The hostname of localhost has been changed!]))


DG_MEMORY_CHECK(1)
DG_MSG_DONE()


dnl ---------------------------------------------------------------------------
DG_MSG_CHECKING([Check queue commands])
DG_MEMORY(1)
DG_EXEC_OR_DIE([ta tg1])
DG_EXEC_OR_DIE([ta tg2])

DG_EXEC_OR_DIE([qa tg1 q1],[Can't create a new queue!])
DG_EXEC_OR_DIE([qa tg1 q2],[Can't create a new queue!])
DG_EXEC_OR_DIE([qa tg2 q3],[Can't create a new queue!])
DG_EXEC_OR_DIE([qa tg2 q4],[Can't create a new queue!])

DG_EXEC([ql tg1 | grep "^batch$"],,, DG_DIE([Can't find the queue batch!]))
DG_EXEC([ql tg1 | grep "^q1$"],,, DG_DIE([Can't find the queue q1!]))
DG_EXEC([ql tg1 | grep "^q2$"],,, DG_DIE([Can't find the queue q2!]))
DG_EXEC([qc tg1],res,,DG_DIE([Can't get queue count!]))
DG_IF([$res -ne 3],DG_DIE([Target count is not 3!]))
DG_EXEC([ql tg2 | grep "^batch$"],,, DG_DIE([Can't find the queue batch!]))
DG_EXEC([ql tg2 | grep "^q3$"],,, DG_DIE([Can't find the queue q3!]))
DG_EXEC([ql tg2 | grep "^q4$"],,, DG_DIE([Can't find the queue q4!]))
DG_EXEC([qc tg2],res,,DG_DIE([Can't get queue count!]))
DG_IF([$res -ne 3],DG_DIE([Target count is not 3!]))

dnl try to add another queue with the same name
DG_EXEC([qa tg1 q1],,DG_DIE([Can add a second queue with the same name!]))
DG_EXEC([qc tg1],res,,DG_DIE([Can't get queue count!]))
DG_IF([$res -ne 3],DG_DIE([Queue count is not 3!]))

dnl check the qsn command 
DG_EXEC_OR_DIE([qsn tg1 q1 new_q1],[Can't rename the queue!])
DG_EXEC([ql tg1 | grep "^new_q1$"],,, DG_DIE([Can't find the renamed queue!]))
DG_EXEC_OR_DIE([qsn tg1 new_q1 q1],[Can't rename the queue!])
DG_EXEC([qsn tg1 q1 q2],,[Can rename a queue with a name which already exists!])
DG_EXEC([ql tg1 | grep "^q1$"],,, DG_DIE([Can't find the queue q1!]))
DG_EXEC([ql tg1 | grep "^q2$"],,, DG_DIE([Can't find the queue q2!]))

dnl check the qsd command 
DG_EXEC_OR_DIE([qsd tg1 q1 new_description],[Can't change queue description!])
DG_EXEC([qi tg1 q1 -S_ | grep "^Description_new_description$"],,,
	DG_DIE([Queue description was not changed!]))
DG_EXEC_OR_DIE([qsd tg1 q1 ""],[Can't erase queue description!])
DG_EXEC([qi tg1 q1 -S_ | grep "^Description_$"],,,
	DG_DIE([Queue description was not changed!]))

dnl change 'opened' property
DG_EXEC_OR_DIE([qso tg1 q1 false],[Can't change the 'opened' property!])
DG_EXEC([qi tg1 q1 -S_ | grep "^Opened_false$"],,,
	DG_DIE([Queue 'opened' property was not changed!]))
DG_EXEC_OR_DIE([qso tg1 q1 true],[Can't change the 'opened' property!])
DG_EXEC([qi tg1 q1 -S_ | grep "^Opened_true$"],,,
	DG_DIE([Queue 'opened' property was not changed!]))

dnl change 'max' property
DG_EXEC_OR_DIE([qsm tg1 q1 99],[Can't change the 'max' property!])
DG_EXEC([qi tg1 q1 -S_ | grep "^Max_99$"],,,
	DG_DIE([Queue 'max' property was not changed!]))
DG_EXEC_OR_DIE([qsm tg1 q1 100],[Can't change the 'max' property!])
DG_EXEC([qi tg1 q1 -S_ | grep "^Max_100$"],,,
	DG_DIE([Queue 'max' property was not changed!]))

dnl delete queue q1
DG_EXEC([qk tg1 q1],,,DG_DIE([Can delete a queue (q1)!]))
DG_EXEC([qc tg1],res,,DG_DIE([Can't get queue count!]))
DG_IF([$res -ne 2],DG_DIE([Queue count is not 2!]))

dnl delete queue q2
DG_EXEC([qk tg1 q2],,,DG_DIE([Can delete a queue (q2)!]))
DG_EXEC([qc tg1],res,,DG_DIE([Can't get queue count!]))
DG_IF([$res -ne 1],DG_DIE([Queue count is not 1!]))

DG_EXEC_OR_DIE([tk tg1])
DG_EXEC_OR_DIE([tk tg2])

dnl check memory when a target that has queues is deleted
DG_MEMORY(2)
DG_EXEC_OR_DIE([ta tg1])
DG_EXEC_OR_DIE([qa tg1 q1])
DG_EXEC_OR_DIE([qa tg1 q2])
DG_EXEC_OR_DIE([qa tg1 q3])
DG_EXEC_OR_DIE([tk tg1])
DG_MEMORY_CHECK(2)

dnl check character control of the qa command
DG_EXEC_OR_DIE([ta tg1])
DG_EXEC_OR_DIE([qa tg1 "abAZ09-"], [Can't create a queue with valid character!])
DG_EXEC([ql tg1 | grep "^abAZ09-$"],,, DG_DIE([Can't find the queue!]))
DG_EXEC_OR_DIE([qk tg1 "abAZ09-"])
DG_EXEC([qa tg1 "queue@"],, DG_DIE([Can add a queue with invalid character!]))
DG_EXEC([ql tg1 | grep "^queue@$"],, DG_DIE([The queue was created !]))
DG_EXEC([qa tg1 ""],,DG_DIE([Can add a queue with an empty name!]))
DG_EXEC_OR_DIE([tk tg1])

dnl check character control of the qsn command
DG_EXEC_OR_DIE([ta tg1])
DG_EXEC_OR_DIE([qa tg1 q1])
DG_EXEC_OR_DIE([qsn tg1 q1 "abAZ09-"], 
	[Can't rename a queue with valid character!])
DG_EXEC([ql tg1 | grep "^abAZ09-$"],,, DG_DIE([Can't find the queue!]))
DG_EXEC_OR_DIE([qsn tg1 "abAZ09-" q1])
DG_EXEC([qsn tg1 q1 "queue@"],, 
	DG_DIE([Can rename a queue with invalid character!]))
DG_EXEC([ql tg1 | grep "^queue@$"],, DG_DIE([The queue was created!]))
DG_EXEC_OR_DIE([tk tg1])


dnl check the batch queue of localhost
DG_EXEC([ql localhost | grep "^batch$"],,, 
	DG_DIE([Can't find the batch queue of localhost!]))
DG_EXEC([qc localhost],res,,DG_DIE([Can't get queue count!]))
DG_IF([$res -ne 1],DG_DIE([Queue count of localhost is not 1!]))
dnl try to kill the batch queue of localhost
DG_EXEC([qk localhost batch],,
	DG_DIE([Can kill the batch queue of localhost!]))
DG_EXEC([ql localhost | grep "^batch$"],,, 
	DG_DIE([The batch queue of localhost has been deleted!]))
dnl try to rename the batch queue of localhost
DG_EXEC([qsn localhost batch new_name],,
	DG_DIE([Can rename the batch queue of localhost!]))
DG_EXEC([ql localhost | grep "^batch$"],,, 
	DG_DIE([The batch queue of localhost has been renamed!]))



DG_MEMORY_CHECK(1)
DG_MSG_DONE()

DG_DIO87D_STOP()
DG_END()

