DG_BEGIN([tst03], [Test referential commands])
DG_DIO87D_START()

dnl------------------------------------------------------------------------
dnl check referential commands
DG_MSG_CHECKING([Test referential commands])
DG_MEMORY(1)

DG_EXEC_OR_DIE([ra ref1],[Can't create a new referential!])
DG_EXEC([rc],res,,DG_DIE([Can't get referential count!]))
DG_IF([$res -ne 1],DG_DIE([Referential count is not 1!]))
DG_EXEC([ra ref1],,DG_DIE([Can add two referentials with the same name!]))
DG_EXEC([rc],res,,DG_DIE([Can't get referential count!]))
DG_IF([$res -ne 1],DG_DIE([Referential count is not 1!]))

DG_EXEC_OR_DIE([ra ref2],[Can't create a second referential!])
DG_EXEC([rc],res,,DG_DIE([Can't get referential count!]))
DG_IF([$res -ne 2],DG_DIE([Referential count is not 2!]))

DG_EXEC([rk ref1],,,DG_DIE([Can't delete a referential!]))
DG_EXEC([rc],res,,DG_DIE([Can't get referential count!]))
DG_IF([$res -ne 1],DG_DIE([Referential count is not 1!]))

DG_EXEC([rk ref1],,DG_DIE([Can delete a referential which doesn't exist!]))

DG_EXEC_OR_DIE([rk ref2],[Can't delete a referential!])
DG_EXEC([rc],res,,DG_DIE([Can't get referential count!]))
DG_IF([$res -ne 0],DG_DIE([Referential count is not 0!]))

DG_MEMORY_CHECK(1)
DG_MSG_DONE()

dnl------------------------------------------------------------------------
dnl check referential task commands
DG_MSG_CHECKING([Test task commands])
DG_MEMORY(1)

DG_EXEC_OR_DIE([ra ref1])
DG_EXEC_OR_DIE([rta ref1 t1],[Can't create a new task!])
DG_EXEC([rtc ref1],res,,DG_DIE([Can't get task count!]))
DG_IF([$res -ne 1],DG_DIE([Task count is not 1!]))
DG_EXEC_OR_DIE([rta ref1 t2],[Can't create a second task!])
DG_EXEC([rtc ref1],res,,DG_DIE([Can't get task count!]))
DG_IF([$res -ne 2],DG_DIE([Task count is not 2!]))

DG_EXEC_OR_DIE([rtsd ref1 t1 new_description],[Can't change task description!])
DG_EXEC([rti ref1 t1 -S_ | grep "^Description_new_description$"],,,
	DG_DIE([Task description was not changed!]))

dnl check the referential name of the task 
DG_EXEC([rti ref1 t1 -S_ | grep "^Referential Name_ref1$"],,,
	DG_DIE([The referential name is not set!]))

dnl check that the 'enabled' property is true by default
DG_EXEC([rti ref1 t1 -S_ | grep "^Enabled_true$"],,,
	DG_DIE([The enabled property is not 'true' by default!]))
DG_EXEC_OR_DIE([rtse ref1 t1 false],[Can't change the 'enabled' property!])
DG_EXEC([rti ref1 t1 -S_ | grep "^Enabled_false$"],,,
	DG_DIE([The 'enabled' property was not changed!]))

dnl check that the 'wait_all_dependencies' property is true by default
DG_EXEC([rti ref1 t1 -S_ | grep "^Wait All Dependencies_true$"],,,
	DG_DIE([The wait_all_dependencies property is not 'true' by default!]))
DG_EXEC_OR_DIE([rtswad ref1 t1 false],
	[Can't change the 'wait_all_dependencies' property!])
DG_EXEC([rti ref1 t1 -S_ | grep "^Wait All Dependencies_false$"],,,
	DG_DIE([The 'wait_all_dependencies' property was not changed!]))

dnl check that the 'on_error_continue' property is true by default
DG_EXEC([rti ref1 t1 -S_ | grep "^On Error Continue_true$"],,,
	DG_DIE([The on_error_continue property is not 'true' by default!]))
DG_EXEC_OR_DIE([rtsoec ref1 t1 false],
	[Can't change the 'on_error_continue' property!])
DG_EXEC([rti ref1 t1 -S_ | grep "^On Error Continue_false$"],,,
	DG_DIE([The 'on_error_continue' property was not changed!]))


DG_EXEC([rta ref1 t1],,DG_DIE([Can add a second task with the same name!]))
DG_EXEC([rtc ref1],res,,DG_DIE([Can't get task count!]))
DG_IF([$res -ne 2],DG_DIE([Task count is not 2!]))

DG_EXEC([rtk ref1 t1],,,DG_DIE([Can't delete a task!]))
DG_EXEC([rtc ref1],res,,DG_DIE([Can't get task count!]))
DG_IF([$res -ne 1],DG_DIE([Task count is not 1!]))

DG_EXEC([rtk ref1 t2],,,DG_DIE([Can't delete the second task!]))
DG_EXEC([rtc ref1],res,,DG_DIE([Can't get task count!]))
DG_IF([$res -ne 0],DG_DIE([Task count is not 0!]))

DG_EXEC([rtk ref1 t1],,DG_DIE([Can delete a task which doesn't exist!]))

DG_EXEC_OR_DIE([rk ref1])
DG_MEMORY_CHECK(1)

dnl check memory when a referential that has tasks is deleted
DG_MEMORY(1)
DG_EXEC_OR_DIE([ra r1])
DG_EXEC_OR_DIE([rta r1 t1])
DG_EXEC_OR_DIE([rta r1 t2])
DG_EXEC_OR_DIE([rta r1 t3])
DG_EXEC_OR_DIE([rk r1])
DG_MEMORY_CHECK(1)
DG_MSG_DONE()

dnl------------------------------------------------------------------------
dnl check referential job commands
DG_MSG_CHECKING([Test job commands])
DG_MEMORY(1)

DG_EXEC_OR_DIE([ra ref1])
DG_EXEC_OR_DIE([rta ref1 t1])
DG_EXEC_OR_DIE([rja ref1 t1 j1],[Can't create a new job!])
DG_EXEC([rjc ref1 t1],res,,DG_DIE([Can't get job count!]))
DG_IF([$res -ne 1],DG_DIE([Job count is not 1!]))
DG_EXEC_OR_DIE([rja ref1 t1 j2],[Can't create a second job!])
DG_EXEC([rjc ref1 t1],res,,DG_DIE([Can't get job count!]))
DG_IF([$res -ne 2],DG_DIE([Job count is not 2!]))

dnl check the referential name and the task name of the job 
DG_EXEC([rji ref1 t1 j1 -S_ | grep "^Referential Name_ref1$"],,,
	DG_DIE([The referential name is not set!]))
DG_EXEC([rji ref1 t1 j1 -S_ | grep "^Task Name_t1$"],,,
	DG_DIE([The task name is not set!]))

dnl check job description
DG_EXEC_OR_DIE([rjsd ref1 t1 j1 new_description],
	[Can't change job description!])
DG_EXEC([rji ref1 t1 j1 -S_ | grep "^Description_new_description$"],,,
	DG_DIE([Job description was not changed!]))
dnl check job path 
DG_EXEC_OR_DIE([rjsp ref1 t1 j1 new_path], [Can't change job path!])
DG_EXEC([rji ref1 t1 j1 -S_ | grep "^Path_new_path$"],,,
	DG_DIE([Job path was not changed!]))
dnl check job argument 
DG_EXEC_OR_DIE([rjsa ref1 t1 j1 new_argument], [Can't change job argument!])
DG_EXEC([rji ref1 t1 j1 -S_ | grep "^Argument_new_argument$"],,,
	DG_DIE([Job argument was not changed!]))
dnl check job temporization 
DG_EXEC_OR_DIE([rjst ref1 t1 j1 66 67], [Can't change job temporization!])
DG_EXEC([rji ref1 t1 j1 -S_ | grep "^Start Tempo_66$"],,,
	DG_DIE([Job start tempo was not changed!]))
DG_EXEC([rji ref1 t1 j1 -S_ | grep "^End Tempo_67$"],,,
	DG_DIE([Job end tempo was not changed!]))

dnl check that the 'wait_all_dependencies' property is true by default
DG_EXEC([rji ref1 t1 j1 -S_ | grep "^Wait All Dependencies_true$"],,,
	DG_DIE([The wait_all_dependencies property is not 'true' by default!]))
DG_EXEC_OR_DIE([rjswad ref1 t1 j1 false],
	[Can't change the 'wait_all_dependencies' property!])
DG_EXEC([rji ref1 t1 j1 -S_ | grep "^Wait All Dependencies_false$"],,,
	DG_DIE([The 'wait_all_dependencies' property was not changed!]))

dnl check that the 'on_error_continue' property is true by default
DG_EXEC([rji ref1 t1 j1 -S_ | grep "^On Error Continue_true$"],,,
	DG_DIE([The on_error_continue property is not 'true' by default!]))
DG_EXEC_OR_DIE([rjsoec ref1 t1 j1 false], 
	[Can't change the 'on_error_continue' property!])
DG_EXEC([rji ref1 t1 j1 -S_ | grep "^On Error Continue_false$"],,,
	DG_DIE([The 'on_error_continue' property was not changed!]))

DG_EXEC([rja ref1 t1 j1],,DG_DIE([Can add a second job with the same name!]))
DG_EXEC([rjc ref1 t1],res,,DG_DIE([Can't get job count!]))
DG_IF([$res -ne 2],DG_DIE([Job count is not 2!]))

DG_EXEC([rjk ref1 t1 j1],,,DG_DIE([Can't delete a job!]))
DG_EXEC([rjc ref1 t1],res,,DG_DIE([Can't get job count!]))
DG_IF([$res -ne 1],DG_DIE([Job count is not 1!]))

DG_EXEC([rjk ref1 t1 j2],,,DG_DIE([Can't delete the second job!]))
DG_EXEC([rjc ref1 t1],res,,DG_DIE([Can't get job count!]))
DG_IF([$res -ne 0],DG_DIE([Job count is not 0!]))

DG_EXEC([rjk ref1 t1 j1],,DG_DIE([Can delete a job which doesn't exist!]))

DG_EXEC_OR_DIE([rtk ref1 t1])
DG_EXEC_OR_DIE([rk ref1])
DG_MEMORY_CHECK(1)

dnl check memory when a task that has jobs is deleted
DG_MEMORY(1)
DG_EXEC_OR_DIE([ra r1])
DG_EXEC_OR_DIE([rta r1 t1])
DG_EXEC_OR_DIE([rja r1 t1 j1])
DG_EXEC_OR_DIE([rja r1 t1 j2])
DG_EXEC_OR_DIE([rja r1 t1 j3])
DG_EXEC_OR_DIE([rtk r1 t1])
DG_EXEC_OR_DIE([rk r1])
DG_MEMORY_CHECK(1)

dnl check memory when a referential that has tasks and jobs is deleted
DG_MEMORY(1)
DG_EXEC_OR_DIE([ra r1])
DG_EXEC_OR_DIE([rta r1 t1])
DG_EXEC_OR_DIE([rja r1 t1 j1])
DG_EXEC_OR_DIE([rja r1 t1 j2])
DG_EXEC_OR_DIE([rja r1 t1 j3])
DG_EXEC_OR_DIE([rta r1 t2])
DG_EXEC_OR_DIE([rja r1 t2 j1])
DG_EXEC_OR_DIE([rta r1 t3])
DG_EXEC_OR_DIE([rja r1 t3 j1])
DG_EXEC_OR_DIE([rk r1])
DG_MEMORY_CHECK(1)

DG_MSG_DONE()

dnl------------------------------------------------------------------------
dnl check referential task commands
DG_MSG_CHECKING([Test link between task and queue])
DG_MEMORY(1)
DG_EXEC_OR_DIE([ra r1])
DG_EXEC_OR_DIE([rta r1 t1])
DG_EXEC_OR_DIE([ta tg1])
DG_EXEC_OR_DIE([qa tg1 q1])
dnl check that a new task is linked to the queue 'batch' 
dnl of the target 'localhost'
DG_EXEC([rti r1 t1 -S_ | grep "^Queue_batch$"],,,
	DG_DIE([By default the 'queue' property is not 'batch'!]))
DG_EXEC([rti r1 t1 -S_ | grep "^Target_localhost$"],,,
	DG_DIE([By default the 'target' property is not 'localhost'!]))
dnl link the task to another queue
DG_EXEC([rtst r1 t1 tg1 q1],,,DG_DIE([Can't link task and queue!]))
dnl check the target and queue property of the task
DG_EXEC([rti r1 t1 -S_ | grep "^Queue_q1$"],,,
	DG_DIE([The 'queue' property was not changed!]))
DG_EXEC([rti r1 t1 -S_ | grep "^Target_tg1$"],,,
	DG_DIE([The 'target' property was not changed!]))
dnl check that the task is in the task list of the queue
DG_EXEC([qrtl tg1 q1 -S_ | grep "^r1_t1$"],,,
	DG_DIE([The task is not in the task list of the queue!]))
DG_EXEC([qrtc tg1 q1],res,,DG_DIE([Can't get the task count!]))
DG_IF([$res -ne 1],DG_DIE([Task count is not 1!]))

dnl unlink the task
DG_EXEC([rtst r1 t1 none],,,DG_DIE([Can't unlink the task!]))
dnl check the target and queue property of the task
DG_EXEC([rti r1 t1 -S_ | grep "^Queue_none$"],,,
	DG_DIE([The 'queue' property is not 'none'!]))
DG_EXEC([rti r1 t1 -S_ | grep "^Target_none$"],,,
	DG_DIE([The 'target' property is not 'none'!]))
dnl check that the task is in the task list of the queue
DG_EXEC([qrtc tg1 q1],res,,DG_DIE([Can't get the task count!]))
DG_IF([$res -ne 0],DG_DIE([Task count is not 0!]))

dnl deleted a task that is linked to a queue
DG_EXEC([rtst r1 t1 tg1 q1],,,DG_DIE([Can't link task and queue!]))
DG_EXEC([qrtc tg1 q1],res,,DG_DIE([Can't get the task count!]))
DG_IF([$res -ne 1],DG_DIE([Task count is not 1!]))
DG_EXEC_OR_DIE([rtk r1 t1])
DG_EXEC([qrtc tg1 q1],res,,DG_DIE([Can't get the task count!]))
DG_IF([$res -ne 0],DG_DIE([Task count is not 0!]))

dnl deleted a queue that is linked to a task 
DG_EXEC_OR_DIE([rta r1 t1])
DG_EXEC([rtst r1 t1 tg1 q1],,,DG_DIE([Can't link task and queue!]))
DG_EXEC([rti r1 t1 -S_ | grep "^Queue_q1$"],,,
	DG_DIE([The 'queue' property was not changed!]))
DG_EXEC([rti r1 t1 -S_ | grep "^Target_tg1$"],,,
	DG_DIE([The 'target' property was not changed!]))
DG_EXEC_OR_DIE([qk tg1 q1])
DG_EXEC([rti r1 t1 -S_ | grep "^Queue_none$"],,,
	DG_DIE([The 'queue' property is not 'none'!]))
DG_EXEC([rti r1 t1 -S_ | grep "^Target_none$"],,,
	DG_DIE([The 'target' property is not 'none'!]))

DG_EXEC_OR_DIE([rk r1])
DG_EXEC_OR_DIE([tk tg1])
DG_MEMORY_CHECK(1)
DG_MSG_DONE()

dnl------------------------------------------------------------------------
dnl check task dependencies commands
DG_MSG_CHECKING([Test task dependencies commands])

DG_MEMORY(1)
DG_EXEC_OR_DIE([ra r1])
DG_EXEC_OR_DIE([rta r1 t1])
DG_EXEC_OR_DIE([rta r1 t2])
DG_EXEC_OR_DIE([rta r1 t3])
DG_EXEC_OR_DIE([rta r1 t4])
DG_EXEC_OR_DIE([rta r1 t5])

dnl try to add a dependence with wrong arguments
DG_EXEC([rtda r1 t1 t2 zzz],,
	DG_DIE([Can add a dependence with a wrong type!]))
DG_EXEC([rtda zzz t1 t2],,
	DG_DIE([Can add a dependence with a unknown referential!]))
DG_EXEC([rtda r1 zzz t2],,
	DG_DIE([Can add a dependence with a unknown upstream task!]))
DG_EXEC([rtda r1 t1 zzz],,
	DG_DIE([Can add a dependence with a unknown downstream task!]))

DG_EXEC_OR_DIE([rtda r1 t1 t2], [Can't add a task dependence])
DG_EXEC_OR_DIE([rtda r1 t2 t3 always], [Can't add an 'always' dependence])
DG_EXEC_OR_DIE([rtda r1 t3 t4 onerror], [Can't add an 'onerror' dependence])
DG_EXEC_OR_DIE([rtda r1 t3 t5 onsuccess], [Can't add an 'onsuccess' dependence])

DG_EXEC([rtdc r1],res,,DG_DIE([Can't get the dependence count!]))
DG_IF([$res -ne 4],DG_DIE([Dependence count is not 4!]))

DG_EXEC([rtdl r1 -tS_ | grep "^t1_t2_always$"],,,
	DG_DIE([Can't find a dependence!]))
DG_EXEC([rtdl r1 -tS_ | grep "^t2_t3_always$"],,,
	DG_DIE([Can't find a dependence!]))
DG_EXEC([rtdl r1 -tS_ | grep "^t3_t4_onerror$"],,,
	DG_DIE([Can't find a dependence!]))
DG_EXEC([rtdl r1 -tS_ | grep "^t3_t5_onsuccess$"],,,
	DG_DIE([Can't find a dependence!]))

dnl try to add a dependence that already exists
DG_EXEC([rtda r1 t1 t2],,
	DG_DIE([Can add a second dependence between the same tasks]))
DG_EXEC([rtda r1 t1 t2 onerror],,
	DG_DIE([Can add an onerror dependence between the same tasks]))
DG_EXEC([rtda r1 t1 t2 onsuccess],,
	DG_DIE([Can add an onsuccess dependence between the same tasks]))

dnl delete a task dependence
DG_EXEC_OR_DIE([rtda r1 t1 t5 always], [Can't add a task dependence])
DG_EXEC([rtdl r1 -tS_ | grep "^t1_t5_always$"],,,
	DG_DIE([Can't find a dependence!]))
DG_EXEC([rtdc r1],res,,DG_DIE([Can't get the dependence count!]))
DG_IF([$res -ne 5],DG_DIE([Dependence count is not 5!]))
DG_EXEC_OR_DIE([rtdk r1 t1 t5 always], [Can't delete a task dependence])
DG_EXEC([rtdl r1 -tS_ | grep "^t1_t5_always$"],,
	DG_DIE([The dependence is not deleted!]))
DG_EXEC([rtdc r1],res,,DG_DIE([Can't get the dependence count!]))
DG_IF([$res -ne 4],DG_DIE([Dependence count is not 4!]))

dnl try to delete a task that has dependencies
DG_EXEC_OR_DIE([rta r1 t6])
DG_EXEC([rtdc r1],res)
DG_EXEC([rtdc r1],res,,DG_DIE([Can't get the dependence count!]))
DG_IF([$res -ne 4],DG_DIE([Dependence count is not 4!]))
DG_EXEC_OR_DIE([rtda r1 t1 t6 always])
DG_EXEC([rtdc r1],res,,DG_DIE([Can't get the dependence count!]))
DG_IF([$res -ne 5],DG_DIE([Dependence count is not 5!]))
DG_EXEC([rtk r1 t1],, DG_DIE([Can delete a task that has dependences! (t1)]))
DG_EXEC([rtdc r1],res,,DG_DIE([Can't get the dependence count!]))
DG_IF([$res -ne 5],DG_DIE([Dependence count is not 5!]))
DG_EXEC([rtk r1 t6],, DG_DIE([Can delete a task that has dependences! (t6)]))
DG_EXEC([rtdc r1],res,,DG_DIE([Can't get the dependence count!]))
DG_IF([$res -ne 5],DG_DIE([Dependence count is not 5!]))
DG_EXEC_OR_DIE([rtdk r1 t1 t6 always], [Can't delete a task dependence])
DG_EXEC([rtdc r1],res,,DG_DIE([Can't get the dependence count!]))
DG_IF([$res -ne 4],DG_DIE([Dependence count is not 4!]))
DG_EXEC_OR_DIE([rtk r1 t6], [Can't delete a task!])

DG_EXEC_OR_DIE([rk r1])
DG_MEMORY_CHECK(1)
DG_MSG_DONE()

dnl------------------------------------------------------------------------
dnl check job dependencies commands
DG_MSG_CHECKING([Test job dependencies commands])

DG_MEMORY(1)
DG_EXEC_OR_DIE([ra r1])
DG_EXEC_OR_DIE([rta r1 t1])
DG_EXEC_OR_DIE([rja r1 t1 j1])
DG_EXEC_OR_DIE([rja r1 t1 j2])
DG_EXEC_OR_DIE([rja r1 t1 j3])
DG_EXEC_OR_DIE([rja r1 t1 j4])
DG_EXEC_OR_DIE([rja r1 t1 j5])

dnl try to add a dependence with wrong arguments
DG_EXEC([rjda r1 t1 j1 j2 zzz],,
	DG_DIE([Can add a dependence with a wrong type!]))
DG_EXEC([rjda zzz t1 j1 j2],,
	DG_DIE([Can add a dependence with a unknown referential!]))
DG_EXEC([rjda r1 zzz j1 j2],,
	DG_DIE([Can add a dependence with a unknown task!]))
DG_EXEC([rjda r1 t1 zzz j2],,
	DG_DIE([Can add a dependence with a unknown upstream job!]))
DG_EXEC([rjda r1 t1 j1 zzz],,
	DG_DIE([Can add a dependence with a unknown downstream job!]))

DG_EXEC_OR_DIE([rjda r1 t1 j1 j2], [Can't add a job dependence])
DG_EXEC_OR_DIE([rjda r1 t1 j2 j3 always], [Can't add an 'always' dependence])
DG_EXEC_OR_DIE([rjda r1 t1 j3 j4 onerror], [Can't add an 'onerror' dependence])
DG_EXEC_OR_DIE([rjda r1 t1 j3 j5 onsuccess], 
	[Can't add an 'onsuccess' dependence])

DG_EXEC([rjdc r1 t1],res,,DG_DIE([Can't get the dependence count!]))
DG_IF([$res -ne 4],DG_DIE([Dependence count is not 4!]))

DG_EXEC([rjdl r1 t1 -tS_ | grep "^j1_j2_always$"],,,
	DG_DIE([Can't find a dependence!]))
DG_EXEC([rjdl r1 t1 -tS_ | grep "^j2_j3_always$"],,,
	DG_DIE([Can't find a dependence!]))
DG_EXEC([rjdl r1 t1 -tS_ | grep "^j3_j4_onerror$"],,,
	DG_DIE([Can't find a dependence!]))
DG_EXEC([rjdl r1 t1 -tS_ | grep "^j3_j5_onsuccess$"],,,
	DG_DIE([Can't find a dependence!]))

dnl try to add a dependence that already exists
DG_EXEC([rjda r1 t1 j1 j2],,
	DG_DIE([Can add a second dependence between the same jobs]))
DG_EXEC([rjda r1 t1 j1 j2 onerror],,
	DG_DIE([Can add an onerror dependence between the same jobs]))
DG_EXEC([rjda r1 t1 j1 j2 onsuccess],,
	DG_DIE([Can add an onsuccess dependence between the same jobs]))

dnl delete a job dependence
DG_EXEC_OR_DIE([rjda r1 t1 j1 j5 always], [Can't add a job dependence])
DG_EXEC([rjdl r1 t1 -tS_ | grep "^j1_j5_always$"],,,
	DG_DIE([Can't find a dependence!]))
DG_EXEC([rjdc r1 t1],res,,DG_DIE([Can't get the dependence count!]))
DG_IF([$res -ne 5],DG_DIE([Dependence count is not 5!]))
DG_EXEC_OR_DIE([rjdk r1 t1 j1 j5 always], [Can't delete a job dependence])
DG_EXEC([rjdl r1 t1 -tS_ | grep "^j1_j5_always$"],,
	DG_DIE([The dependence is not deleted!]))
DG_EXEC([rjdc r1 t1],res,,DG_DIE([Can't get the dependence count!]))
DG_IF([$res -ne 4],DG_DIE([Dependence count is not 4!]))

dnl try to delete a job that has dependencies
DG_EXEC_OR_DIE([rja r1 t1 j6])
DG_EXEC([rjdc r1 t1],res,,DG_DIE([Can't get the dependence count!]))
DG_IF([$res -ne 4],DG_DIE([Dependence count is not 4!]))
DG_EXEC_OR_DIE([rjda r1 t1 j1 j6 always])
DG_EXEC([rjdc r1 t1],res,,DG_DIE([Can't get the dependence count!]))
DG_IF([$res -ne 5],DG_DIE([Dependence count is not 5!]))

DG_EXEC([rjk r1 t1 j6],,, DG_DIE([Can't delete a job that has dependences!]))
DG_EXEC([rjdc r1 t1],res,,DG_DIE([Can't get the dependence count!]))
DG_IF([$res -ne 4],DG_DIE([Dependence count is not 4!]))

DG_EXEC_OR_DIE([rk r1])
DG_MEMORY_CHECK(1)
DG_MSG_DONE()

dnl------------------------------------------------------------------------
dnl check task condition commands
DG_MSG_CHECKING([Test task condition commands])

DG_MEMORY(1)
DG_EXEC_OR_DIE([ra r1])
DG_EXEC_OR_DIE([rta r1 t1])

DG_EXEC([rjca xx t1 manual ready],,
	DG_DIE([Can add a task condition with a unknown referential!]))
DG_EXEC([rjca r1 xx manual ready],,
	DG_DIE([Can add a task condition with a unknown task!]))
DG_EXEC([rjca r1 t1 xxxxxx ready],,
	DG_DIE([Can add a task condition with a wrong type!]))
DG_EXEC([rjca r1 t1 manual],,
	DG_DIE([Can add a manual condition without argument!]))

DG_EXEC_OR_DIE([rtca r1 t1 manual ready], [Can't add a manual condition!])
DG_EXEC_OR_DIE([rtca r1 t1 file path], [Can't add a file condition!])
DG_EXEC_OR_DIE([rtca r1 t1 hmin "20:30" 1], [Can't add a hmin condition!])
DG_EXEC_OR_DIE([rtca r1 t1 hmax "21:30" 2], [Can't add a hmax condition!])
DG_EXEC_OR_DIE([rtca r1 t1 hlate "22:30" 3], [Can't add a hlate condition!])

DG_EXEC([rtcl r1 t1 -S_ | grep "^manual_ready$"],,,
	DG_DIE([Can't find the manual condition!]))
DG_EXEC([rtcl r1 t1 -S_ | grep "^file_path$"],,,
	DG_DIE([Can't find the file condition!]))
DG_EXEC([rtcl r1 t1 -S_ | grep "^hmin_20:30_+1$"],,,
	DG_DIE([Can't find the hmin condition!]))
DG_EXEC([rtcl r1 t1 -S_ | grep "^hmax_21:30_+2$"],,,
	DG_DIE([Can't find the hmax condition!]))
DG_EXEC([rtcl r1 t1 -S_ | grep "^hlate_22:30_+3$"],,,
	DG_DIE([Can't find the hlate condition!]))

DG_EXEC([rtcc r1 t1],res,,DG_DIE([Can't get the condition count!]))
DG_IF([$res -ne 5],DG_DIE([Condition count is not 5!]))

dnl add and remove a manual condition
DG_MEMORY(2)
DG_EXEC_OR_DIE([rtca r1 t1 manual ok])
DG_EXEC([rtcc r1 t1],res,,DG_DIE([Can't get the condition count!]))
DG_IF([$res -ne 6],DG_DIE([Condition count is not 6!]))
DG_EXEC_OR_DIE([rtck r1 t1 manual ok])
DG_EXEC([rtcc r1 t1],res,,DG_DIE([Can't get the condition count!]))
DG_IF([$res -ne 5],DG_DIE([Condition count is not 5!]))
DG_MEMORY_CHECK(2)
dnl add and remove a file condition
DG_MEMORY(2)
DG_EXEC_OR_DIE([rtca r1 t1 file path])
DG_EXEC([rtcc r1 t1],res,,DG_DIE([Can't get the condition count!]))
DG_IF([$res -ne 6],DG_DIE([Condition count is not 6!]))
DG_EXEC_OR_DIE([rtck r1 t1 file path])
DG_EXEC([rtcc r1 t1],res,,DG_DIE([Can't get the condition count!]))
DG_IF([$res -ne 5],DG_DIE([Condition count is not 5!]))
DG_MEMORY_CHECK(2)
dnl add and remove a hmin condition
DG_MEMORY(2)
DG_EXEC_OR_DIE([rtca r1 t1 hmin "18:00" 0])
DG_EXEC([rtcc r1 t1],res,,DG_DIE([Can't get the condition count!]))
DG_IF([$res -ne 6],DG_DIE([Condition count is not 6!]))
DG_EXEC_OR_DIE([rtck r1 t1 hmin "18:00" 0])
DG_EXEC([rtcc r1 t1],res,,DG_DIE([Can't get the condition count!]))
DG_IF([$res -ne 5],DG_DIE([Condition count is not 5!]))
DG_MEMORY_CHECK(2)
dnl add and remove a hmax condition
DG_MEMORY(2)
DG_EXEC_OR_DIE([rtca r1 t1 hmax "18:00" 0])
DG_EXEC([rtcc r1 t1],res,,DG_DIE([Can't get the condition count!]))
DG_IF([$res -ne 6],DG_DIE([Condition count is not 6!]))
DG_EXEC_OR_DIE([rtck r1 t1 hmax "18:00" 0])
DG_EXEC([rtcc r1 t1],res,,DG_DIE([Can't get the condition count!]))
DG_IF([$res -ne 5],DG_DIE([Condition count is not 5!]))
DG_MEMORY_CHECK(2)
dnl add and remove a hlate condition
DG_MEMORY(2)
DG_EXEC_OR_DIE([rtca r1 t1 hlate "18:00" 0])
DG_EXEC([rtcc r1 t1],res,,DG_DIE([Can't get the condition count!]))
DG_IF([$res -ne 6],DG_DIE([Condition count is not 6!]))
DG_EXEC_OR_DIE([rtck r1 t1 hlate "18:00" 0])
DG_EXEC([rtcc r1 t1],res,,DG_DIE([Can't get the condition count!]))
DG_IF([$res -ne 5],DG_DIE([Condition count is not 5!]))
DG_MEMORY_CHECK(2)

DG_EXEC_OR_DIE([rk r1])
DG_MEMORY_CHECK(1)
DG_MSG_DONE()

dnl------------------------------------------------------------------------
dnl check referential copy 
DG_MSG_CHECKING([Test referential copy])

DG_MEMORY(1)
DG_EXEC_OR_DIE([ta tg1])
DG_EXEC_OR_DIE([qa tg1 q1])

DG_EXEC_OR_DIE([ra r1])
DG_EXEC_OR_DIE([rta r1 t1 task1])
DG_EXEC_OR_DIE([rta r1 t2 task2])
DG_EXEC_OR_DIE([rta r1 t3 task3])
DG_EXEC_OR_DIE([rta r1 t4 task4])

DG_EXEC_OR_DIE([rtda r1 t1 t2 onerror])
DG_EXEC_OR_DIE([rtda r1 t1 t3 always])
DG_EXEC_OR_DIE([rtda r1 t3 t4 onsuccess])

DG_EXEC_OR_DIE([rtswad r1 t2 false])
DG_EXEC_OR_DIE([rtswad r1 t3 true])
DG_EXEC_OR_DIE([rtsoec r1 t1 false])
DG_EXEC_OR_DIE([rtsoec r1 t4 true])
DG_EXEC_OR_DIE([rtse r1 t3 false])
DG_EXEC_OR_DIE([rtse r1 t4 true])

DG_EXEC_OR_DIE([rja r1 t1 j1 task1_job1])
DG_EXEC_OR_DIE([rja r1 t1 j2 task1_job2])
DG_EXEC_OR_DIE([rja r1 t1 j3 task1_job3])
DG_EXEC_OR_DIE([rja r1 t1 j4 task1_job4])

DG_EXEC_OR_DIE([rjsp r1 t1 j2 "/bin/ls"])
DG_EXEC_OR_DIE([rjsa r1 t1 j2 "arg"])
DG_EXEC_OR_DIE([rjst r1 t1 j3 55 56])

DG_EXEC_OR_DIE([rjda r1 t1 j1 j2 onerror])
DG_EXEC_OR_DIE([rjda r1 t1 j1 j3 always])
DG_EXEC_OR_DIE([rjda r1 t1 j3 j4 onsuccess])

DG_EXEC_OR_DIE([rjswad r1 t1 j2 false])
DG_EXEC_OR_DIE([rjswad r1 t1 j3 true])
DG_EXEC_OR_DIE([rjsoec r1 t1 j1 false])
DG_EXEC_OR_DIE([rjsoec r1 t1 j4 true])

DG_EXEC_OR_DIE([rja r1 t2 j1 task2_job1])
DG_EXEC_OR_DIE([rja r1 t2 j2 task2_job2])
DG_EXEC_OR_DIE([rjda r1 t2 j1 j2 always])

DG_EXEC_OR_DIE([rtca r1 t1 hmin "11:00" 0])
DG_EXEC_OR_DIE([rtca r1 t1 hmax "12:00" 0])
DG_EXEC_OR_DIE([rtca r1 t2 manual "ok?"])
DG_EXEC_OR_DIE([rtca r1 t4 file "/tmp/fic"])

DG_EXEC_OR_DIE([rtst r1 t1 tg1 q1])
DG_EXEC_OR_DIE([rtst r1 t2 none])

DG_MEMORY(2)
DG_EXEC_OR_DIE([rd r1 r2], [Can't copy a referential])

dnl check task list
DG_EXEC([rtc r2],res,,DG_DIE([Can't get task count!]))
DG_IF([$res -ne 4],DG_DIE([Task count is not 4!]))
DG_EXEC([rtl -dS_ r2 | grep "^t1_task1$"],,, DG_DIE([Can't find task t1!]))
DG_EXEC([rtl -dS_ r2 | grep "^t2_task2$"],,, DG_DIE([Can't find task t2!]))
DG_EXEC([rtl -dS_ r2 | grep "^t3_task3$"],,, DG_DIE([Can't find task t3!]))
DG_EXEC([rtl -dS_ r2 | grep "^t4_task4$"],,, DG_DIE([Can't find task t4!]))

dnl check task dependence list
DG_EXEC([rtdc r2],res,,DG_DIE([Can't get task count!]))
DG_IF([$res -ne 3],DG_DIE([Task dependence count is not 3!]))
DG_EXEC([rtdl r2 -tS_ | grep "^t1_t2_onerror$"],,, 
	DG_DIE([Can't find task dependence between t1 and t2!]))
DG_EXEC([rtdl r2 -tS_ | grep "^t1_t3_always$"],,, 
	DG_DIE([Can't find task dependence between t1 and t3!]))
DG_EXEC([rtdl r2 -tS_ | grep "^t3_t4_onsuccess$"],,, 
	DG_DIE([Can't find task dependence between t3 and t4!]))

DG_EXEC([rti -S_ r2 t2 | grep "^Wait All Dependencies_false$"],,, 
	DG_DIE([The wait_all_dependencies of t2 is not false!]))
DG_EXEC([rti -S_ r2 t3 | grep "^Wait All Dependencies_true$"],,, 
	DG_DIE([The wait_all_dependencies of t3 is not true!]))
DG_EXEC([rti -S_ r2 t1 | grep "^On Error Continue_false$"],,, 
	DG_DIE([The on_error_continue of t1 is not false!]))
DG_EXEC([rti -S_ r2 t4 | grep "^On Error Continue_true$"],,, 
	DG_DIE([The on_error_continue of t4 is not true!]))

DG_EXEC([rti -S_ r2 t3 | grep "^Enabled_false$"],,,
	DG_DIE([The enabled property of the task t3 is not false!]))
DG_EXEC([rti -S_ r2 t4 | grep "^Enabled_true$"],,,
	DG_DIE([The enabled property of the task t4 is not true!]))

dnl check job properties
DG_EXEC([rji -S_ r2 t1 j2 | grep "^Wait All Dependencies_false$"],,, 
	DG_DIE([The wait_all_dependencies of j2 is not false!]))
DG_EXEC([rji -S_ r2 t1 j3 | grep "^Wait All Dependencies_true$"],,, 
	DG_DIE([The wait_all_dependencies of j3 is not true!]))
DG_EXEC([rji -S_ r2 t1 j1 | grep "^On Error Continue_false$"],,, 
	DG_DIE([The on_error_continue of j1 is not false!]))
DG_EXEC([rji -S_ r2 t1 j4 | grep "^On Error Continue_true$"],,, 
	DG_DIE([The on_error_continue of j4 is not true!]))
DG_EXEC([rji -S_ r2 t1 j2 | grep "^Path_/bin/ls$"],,,
	DG_DIE([The job path is not set!]))
DG_EXEC([rji -S_ r2 t1 j2 | grep "^Argument_arg$"],,,
	DG_DIE([The job argument is not set!]))
DG_EXEC([rji -S_ r2 t1 j3 | grep "^Start Tempo_55$"],,,
	DG_DIE([The start tempo of the job j3 is not set!]))
DG_EXEC([rji -S_ r2 t1 j3 | grep "^End Tempo_56$"],,,
	DG_DIE([The end tempo of the job j3 is not set!]))

dnl check job list
DG_EXEC([rjc r2 t1],res,,DG_DIE([Can't get job count!]))
DG_IF([$res -ne 4],DG_DIE([Job count is not 4!]))
DG_EXEC([rjl r2 t1 -dS_ | grep "^j1_task1_job1$"],,, 
	DG_DIE([Can't find job j1!]))
DG_EXEC([rjl r2 t1 -dS_ | grep "^j2_task1_job2$"],,, 
	DG_DIE([Can't find job j2!]))
DG_EXEC([rjl r2 t1 -dS_ | grep "^j3_task1_job3$"],,, 
	DG_DIE([Can't find job j3!]))
DG_EXEC([rjl r2 t1 -dS_ | grep "^j4_task1_job4$"],,, 
	DG_DIE([Can't find job j4!]))


dnl check job dependence list
DG_EXEC([rjdc r2 t1],res,,DG_DIE([Can't get job dependence count!]))
DG_IF([$res -ne 3],DG_DIE([Job dependence count is not 3!]))
DG_EXEC([rjdl r2 t1 -tS_ | grep "^j1_j2_onerror$"],,, 
	DG_DIE([Can't find job dependence between j1 and j2!]))
DG_EXEC([rjdl r2 t1 -tS_ | grep "^j1_j3_always$"],,, 
	DG_DIE([Can't find job dependence between j1 and j3!]))
DG_EXEC([rjdl r2 t1 -tS_ | grep "^j3_j4_onsuccess$"],,, 
	DG_DIE([Can't find job dependence between j3 and j4!]))

dnl check job list of t2
DG_EXEC([rjc r2 t2],res,,DG_DIE([Can't get job count!]))
DG_IF([$res -ne 2],DG_DIE([Job count is not 2!]))
DG_EXEC([rjl r2 t2 -dS_ | grep "^j1_task2_job1$"],,, 
	DG_DIE([Can't find job j1!]))
DG_EXEC([rjl r2 t2 -dS_ | grep "^j2_task2_job2$"],,, 
	DG_DIE([Can't find job j2!]))
DG_EXEC([rjdc r2 t2],res,,DG_DIE([Can't get job dependence count!]))
DG_IF([$res -ne 1],DG_DIE([Job dependence count is not 1!]))
DG_EXEC([rjdl r2 t2 -tS_ | grep "^j1_j2_always$"],,, 
	DG_DIE([Can't find job dependence between j1 and j2!]))

dnl check task conditions
DG_EXEC([rtcc r2 t1],res,,DG_DIE([Can't get condition count!]))
DG_IF([$res -ne 2],DG_DIE([Condition count of task t1 is not 2!]))
DG_EXEC([rtcl -S_ r2 t1 | grep "^hmin_11:00_+0$"],,,
	DG_DIE([Can't find the hmin condition!]))
DG_EXEC([rtcl -S_ r2 t1 | grep "^hmax_12:00_+0$"],,,
	DG_DIE([Can't find the hmax condition!]))
DG_EXEC([rtcl -S_ r2 t2 | grep "^manual_ok?$"],,,
	DG_DIE([Can't find the manual condition!]))
DG_EXEC([rtcl -S_ r2 t4 | grep "^file_/tmp/fic$"],,,
	DG_DIE([Can't find the file condition!]))

DG_EXEC([rti -S_ r2 t1 | grep "^Target_tg1$"],,,
	DG_DIE([The target is not set!]))
DG_EXEC([rti -S_ r2 t1 | grep "^Queue_q1$"],,,
	DG_DIE([The queue is not set!]))
DG_EXEC([rti -S_ r2 t2 | grep "^Target_none$"],,,
	DG_DIE([The target is not set!]))
DG_EXEC([rti -S_ r2 t2 | grep "^Queue_none$"],,,
	DG_DIE([The queue is not set!]))

DG_EXEC_OR_DIE([rk r2])
DG_MEMORY_CHECK(2)

DG_EXEC_OR_DIE([rk r1])
DG_EXEC_OR_DIE([tk tg1])

DG_MEMORY_CHECK(1)
DG_MSG_DONE()

DG_DIO87D_STOP()
DG_END()

