#! /bin/sh
#
#      Diogene87
#      Copyright (C) 2003,2004,2005,2006,2007 - Dominique Parisot
#
if [ "x$buildpath" = "x" ] ; then
	buildpath=`pwd`
fi
if [ "`uname`" = "Linux" ] ; then
	echo "Setting ulimit"
	ulimit -c unlimited
	ulimit -n 10
fi

dio87d_dir="$buildpath/../src/dio87d"
dio87c_dir="$buildpath/../src/dio87c"
dio87d_cmd="$dio87d_dir/dio87d"
dio87c_cmd="$dio87c_dir/dio87c"
PATH="$dio87d_dir:$dio87c_dir:$PATH"
export PATH
export DG87_USER="admin"
export DG87_PASSWORD=""
JOBPATH="$buildpath/$srcdir/jobs"
DATAPATH="$buildpath/data"
dayDate=`date +"%Y-%m-%d %H:%M:%S"`
# check data directory
if [ ! -d "$DATAPATH"  ]; then
# create directory
mkdir "$DATAPATH" || exit 1 
else
# remove previous data files
rm "$DATAPATH"/* -f >/dev/null 2>&1 
fi
# create 'dio87d' configuration file
cat > $DATAPATH/dio87d.conf << EOF
IPPORT=9993
PID_FILE=$DATAPATH/dio87d.pid
DATA_DIR=$DATAPATH
SAVE_TEMPO=300
LOG_LEVEL=NONE
EOF

# create 'dio87c' configuration file
cat > $DATAPATH/dio87c.conf << EOF
DG87_ADDRESS=localhost
DG87_IPPORT=9993
EOF
ps -e | grep [d]io87d > /dev/null 
if [ $? -eq 0 ]; then

echo "dio87d is already running";exit 1 
fi

echo "__________________________________________________________________"

echo "|"

echo "| tst03 (Test referential commands)"

echo "|"

printf " Start dio87d ...................................................."

# initialize previous database
rm DATAPATH/dio87d.data >/dev/null 2>&1
"$dio87d_cmd" -C "$DATAPATH/dio87d.conf" -I >/dev/null 2>&1
"$dio87d_cmd" -C "$DATAPATH/dio87d.conf" -d $DAEMON_OPTION
sleep 1
dio87c -- version >/dev/null 2>&1
if [  $? -ne 0 ]; then
echo ""
echo "Can't communicate with dio87d";exit 1 
fi


echo " done"

printf " Test referential commands ......................................."

mema1=`dio87c -- memory`
if [ $? -ne 0 ]; then
if [ "$mema1" = "Unknown command 'memory'" ]; then
mema1=0
else
echo ""
echo "Error of the memory command";exit 1  
fi

fi


dio87c -- ra ref1 
if [  $? -ne 0 ]; then
echo ""
echo "Can't create a new referential!";exit 1 
fi


res=`dio87c -- rc`
if [ $? -ne 0 ]; then
echo ""
echo "Can't get referential count!";exit 1 
fi

if [ $res -ne 1 ]; then
echo ""
echo "Referential count is not 1!";exit 1 
fi

dio87c -- ra ref1 > /dev/null 
if [ $? -eq 0 ]; then
echo ""
echo "Can add two referentials with the same name!";exit 1 
fi

res=`dio87c -- rc`
if [ $? -ne 0 ]; then
echo ""
echo "Can't get referential count!";exit 1 
fi

if [ $res -ne 1 ]; then
echo ""
echo "Referential count is not 1!";exit 1 
fi


dio87c -- ra ref2 
if [  $? -ne 0 ]; then
echo ""
echo "Can't create a second referential!";exit 1 
fi


res=`dio87c -- rc`
if [ $? -ne 0 ]; then
echo ""
echo "Can't get referential count!";exit 1 
fi

if [ $res -ne 2 ]; then
echo ""
echo "Referential count is not 2!";exit 1 
fi


dio87c -- rk ref1 > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't delete a referential!";exit 1 
fi

res=`dio87c -- rc`
if [ $? -ne 0 ]; then
echo ""
echo "Can't get referential count!";exit 1 
fi

if [ $res -ne 1 ]; then
echo ""
echo "Referential count is not 1!";exit 1 
fi


dio87c -- rk ref1 > /dev/null 
if [ $? -eq 0 ]; then
echo ""
echo "Can delete a referential which doesn't exist!";exit 1 
fi


dio87c -- rk ref2 
if [  $? -ne 0 ]; then
echo ""
echo "Can't delete a referential!";exit 1 
fi


res=`dio87c -- rc`
if [ $? -ne 0 ]; then
echo ""
echo "Can't get referential count!";exit 1 
fi

if [ $res -ne 0 ]; then
echo ""
echo "Referential count is not 0!";exit 1 
fi


memb1=`dio87c -- memory`
if [ $? -ne 0 ]; then
if [ "$memb1" = "Unknown command 'memory'" ]; then
memb1=0
else
echo ""
echo "Error of the memory command";exit 1  
fi

fi
if [  $mema1 -ne $memb1  ]; then
	echo ""
echo "Memory error : $mema1 -> $memb1";exit 1 
fi


echo " done"

printf " Test task commands .............................................."

mema1=`dio87c -- memory`
if [ $? -ne 0 ]; then
if [ "$mema1" = "Unknown command 'memory'" ]; then
mema1=0
else
echo ""
echo "Error of the memory command";exit 1  
fi

fi


dio87c -- ra ref1 || exit 1 
dio87c -- rta ref1 t1 
if [  $? -ne 0 ]; then
echo ""
echo "Can't create a new task!";exit 1 
fi


res=`dio87c -- rtc ref1`
if [ $? -ne 0 ]; then
echo ""
echo "Can't get task count!";exit 1 
fi

if [ $res -ne 1 ]; then
echo ""
echo "Task count is not 1!";exit 1 
fi

dio87c -- rta ref1 t2 
if [  $? -ne 0 ]; then
echo ""
echo "Can't create a second task!";exit 1 
fi


res=`dio87c -- rtc ref1`
if [ $? -ne 0 ]; then
echo ""
echo "Can't get task count!";exit 1 
fi

if [ $res -ne 2 ]; then
echo ""
echo "Task count is not 2!";exit 1 
fi


dio87c -- rtsd ref1 t1 new_description 
if [  $? -ne 0 ]; then
echo ""
echo "Can't change task description!";exit 1 
fi


dio87c -- rti ref1 t1 -S_ | grep "^Description_new_description$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Task description was not changed!";exit 1 
fi


dio87c -- rti ref1 t1 -S_ | grep "^Referential Name_ref1$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "The referential name is not set!";exit 1 
fi


dio87c -- rti ref1 t1 -S_ | grep "^Enabled_true$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "The enabled property is not 'true' by default!";exit 1 
fi

dio87c -- rtse ref1 t1 false 
if [  $? -ne 0 ]; then
echo ""
echo "Can't change the 'enabled' property!";exit 1 
fi


dio87c -- rti ref1 t1 -S_ | grep "^Enabled_false$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "The 'enabled' property was not changed!";exit 1 
fi


dio87c -- rti ref1 t1 -S_ | grep "^Wait All Dependencies_true$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "The wait_all_dependencies property is not 'true' by default!";exit 1 
fi

dio87c -- rtswad ref1 t1 false 
if [  $? -ne 0 ]; then
echo ""
echo "Can't change the 'wait_all_dependencies' property!";exit 1 
fi


dio87c -- rti ref1 t1 -S_ | grep "^Wait All Dependencies_false$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "The 'wait_all_dependencies' property was not changed!";exit 1 
fi


dio87c -- rti ref1 t1 -S_ | grep "^On Error Continue_true$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "The on_error_continue property is not 'true' by default!";exit 1 
fi

dio87c -- rtsoec ref1 t1 false 
if [  $? -ne 0 ]; then
echo ""
echo "Can't change the 'on_error_continue' property!";exit 1 
fi


dio87c -- rti ref1 t1 -S_ | grep "^On Error Continue_false$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "The 'on_error_continue' property was not changed!";exit 1 
fi



dio87c -- rta ref1 t1 > /dev/null 
if [ $? -eq 0 ]; then
echo ""
echo "Can add a second task with the same name!";exit 1 
fi

res=`dio87c -- rtc ref1`
if [ $? -ne 0 ]; then
echo ""
echo "Can't get task count!";exit 1 
fi

if [ $res -ne 2 ]; then
echo ""
echo "Task count is not 2!";exit 1 
fi


dio87c -- rtk ref1 t1 > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't delete a task!";exit 1 
fi

res=`dio87c -- rtc ref1`
if [ $? -ne 0 ]; then
echo ""
echo "Can't get task count!";exit 1 
fi

if [ $res -ne 1 ]; then
echo ""
echo "Task count is not 1!";exit 1 
fi


dio87c -- rtk ref1 t2 > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't delete the second task!";exit 1 
fi

res=`dio87c -- rtc ref1`
if [ $? -ne 0 ]; then
echo ""
echo "Can't get task count!";exit 1 
fi

if [ $res -ne 0 ]; then
echo ""
echo "Task count is not 0!";exit 1 
fi


dio87c -- rtk ref1 t1 > /dev/null 
if [ $? -eq 0 ]; then
echo ""
echo "Can delete a task which doesn't exist!";exit 1 
fi


dio87c -- rk ref1 || exit 1 
memb1=`dio87c -- memory`
if [ $? -ne 0 ]; then
if [ "$memb1" = "Unknown command 'memory'" ]; then
memb1=0
else
echo ""
echo "Error of the memory command";exit 1  
fi

fi
if [  $mema1 -ne $memb1  ]; then
	echo ""
echo "Memory error : $mema1 -> $memb1";exit 1 
fi


mema1=`dio87c -- memory`
if [ $? -ne 0 ]; then
if [ "$mema1" = "Unknown command 'memory'" ]; then
mema1=0
else
echo ""
echo "Error of the memory command";exit 1  
fi

fi

dio87c -- ra r1 || exit 1 
dio87c -- rta r1 t1 || exit 1 
dio87c -- rta r1 t2 || exit 1 
dio87c -- rta r1 t3 || exit 1 
dio87c -- rk r1 || exit 1 
memb1=`dio87c -- memory`
if [ $? -ne 0 ]; then
if [ "$memb1" = "Unknown command 'memory'" ]; then
memb1=0
else
echo ""
echo "Error of the memory command";exit 1  
fi

fi
if [  $mema1 -ne $memb1  ]; then
	echo ""
echo "Memory error : $mema1 -> $memb1";exit 1 
fi


echo " done"

printf " Test job commands ..............................................."

mema1=`dio87c -- memory`
if [ $? -ne 0 ]; then
if [ "$mema1" = "Unknown command 'memory'" ]; then
mema1=0
else
echo ""
echo "Error of the memory command";exit 1  
fi

fi


dio87c -- ra ref1 || exit 1 
dio87c -- rta ref1 t1 || exit 1 
dio87c -- rja ref1 t1 j1 
if [  $? -ne 0 ]; then
echo ""
echo "Can't create a new job!";exit 1 
fi


res=`dio87c -- rjc ref1 t1`
if [ $? -ne 0 ]; then
echo ""
echo "Can't get job count!";exit 1 
fi

if [ $res -ne 1 ]; then
echo ""
echo "Job count is not 1!";exit 1 
fi

dio87c -- rja ref1 t1 j2 
if [  $? -ne 0 ]; then
echo ""
echo "Can't create a second job!";exit 1 
fi


res=`dio87c -- rjc ref1 t1`
if [ $? -ne 0 ]; then
echo ""
echo "Can't get job count!";exit 1 
fi

if [ $res -ne 2 ]; then
echo ""
echo "Job count is not 2!";exit 1 
fi


dio87c -- rji ref1 t1 j1 -S_ | grep "^Referential Name_ref1$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "The referential name is not set!";exit 1 
fi

dio87c -- rji ref1 t1 j1 -S_ | grep "^Task Name_t1$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "The task name is not set!";exit 1 
fi


dio87c -- rjsd ref1 t1 j1 new_description 
if [  $? -ne 0 ]; then
echo ""
echo "Can't change job description!";exit 1 
fi


dio87c -- rji ref1 t1 j1 -S_ | grep "^Description_new_description$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Job description was not changed!";exit 1 
fi

dio87c -- rjsp ref1 t1 j1 new_path 
if [  $? -ne 0 ]; then
echo ""
echo "Can't change job path!";exit 1 
fi


dio87c -- rji ref1 t1 j1 -S_ | grep "^Path_new_path$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Job path was not changed!";exit 1 
fi

dio87c -- rjsa ref1 t1 j1 new_argument 
if [  $? -ne 0 ]; then
echo ""
echo "Can't change job argument!";exit 1 
fi


dio87c -- rji ref1 t1 j1 -S_ | grep "^Argument_new_argument$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Job argument was not changed!";exit 1 
fi

dio87c -- rjst ref1 t1 j1 66 67 
if [  $? -ne 0 ]; then
echo ""
echo "Can't change job temporization!";exit 1 
fi


dio87c -- rji ref1 t1 j1 -S_ | grep "^Start Tempo_66$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Job start tempo was not changed!";exit 1 
fi

dio87c -- rji ref1 t1 j1 -S_ | grep "^End Tempo_67$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Job end tempo was not changed!";exit 1 
fi


dio87c -- rji ref1 t1 j1 -S_ | grep "^Wait All Dependencies_true$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "The wait_all_dependencies property is not 'true' by default!";exit 1 
fi

dio87c -- rjswad ref1 t1 j1 false 
if [  $? -ne 0 ]; then
echo ""
echo "Can't change the 'wait_all_dependencies' property!";exit 1 
fi


dio87c -- rji ref1 t1 j1 -S_ | grep "^Wait All Dependencies_false$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "The 'wait_all_dependencies' property was not changed!";exit 1 
fi


dio87c -- rji ref1 t1 j1 -S_ | grep "^On Error Continue_true$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "The on_error_continue property is not 'true' by default!";exit 1 
fi

dio87c -- rjsoec ref1 t1 j1 false 
if [  $? -ne 0 ]; then
echo ""
echo "Can't change the 'on_error_continue' property!";exit 1 
fi


dio87c -- rji ref1 t1 j1 -S_ | grep "^On Error Continue_false$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "The 'on_error_continue' property was not changed!";exit 1 
fi


dio87c -- rja ref1 t1 j1 > /dev/null 
if [ $? -eq 0 ]; then
echo ""
echo "Can add a second job with the same name!";exit 1 
fi

res=`dio87c -- rjc ref1 t1`
if [ $? -ne 0 ]; then
echo ""
echo "Can't get job count!";exit 1 
fi

if [ $res -ne 2 ]; then
echo ""
echo "Job count is not 2!";exit 1 
fi


dio87c -- rjk ref1 t1 j1 > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't delete a job!";exit 1 
fi

res=`dio87c -- rjc ref1 t1`
if [ $? -ne 0 ]; then
echo ""
echo "Can't get job count!";exit 1 
fi

if [ $res -ne 1 ]; then
echo ""
echo "Job count is not 1!";exit 1 
fi


dio87c -- rjk ref1 t1 j2 > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't delete the second job!";exit 1 
fi

res=`dio87c -- rjc ref1 t1`
if [ $? -ne 0 ]; then
echo ""
echo "Can't get job count!";exit 1 
fi

if [ $res -ne 0 ]; then
echo ""
echo "Job count is not 0!";exit 1 
fi


dio87c -- rjk ref1 t1 j1 > /dev/null 
if [ $? -eq 0 ]; then
echo ""
echo "Can delete a job which doesn't exist!";exit 1 
fi


dio87c -- rtk ref1 t1 || exit 1 
dio87c -- rk ref1 || exit 1 
memb1=`dio87c -- memory`
if [ $? -ne 0 ]; then
if [ "$memb1" = "Unknown command 'memory'" ]; then
memb1=0
else
echo ""
echo "Error of the memory command";exit 1  
fi

fi
if [  $mema1 -ne $memb1  ]; then
	echo ""
echo "Memory error : $mema1 -> $memb1";exit 1 
fi


mema1=`dio87c -- memory`
if [ $? -ne 0 ]; then
if [ "$mema1" = "Unknown command 'memory'" ]; then
mema1=0
else
echo ""
echo "Error of the memory command";exit 1  
fi

fi

dio87c -- ra r1 || exit 1 
dio87c -- rta r1 t1 || exit 1 
dio87c -- rja r1 t1 j1 || exit 1 
dio87c -- rja r1 t1 j2 || exit 1 
dio87c -- rja r1 t1 j3 || exit 1 
dio87c -- rtk r1 t1 || exit 1 
dio87c -- rk r1 || exit 1 
memb1=`dio87c -- memory`
if [ $? -ne 0 ]; then
if [ "$memb1" = "Unknown command 'memory'" ]; then
memb1=0
else
echo ""
echo "Error of the memory command";exit 1  
fi

fi
if [  $mema1 -ne $memb1  ]; then
	echo ""
echo "Memory error : $mema1 -> $memb1";exit 1 
fi


mema1=`dio87c -- memory`
if [ $? -ne 0 ]; then
if [ "$mema1" = "Unknown command 'memory'" ]; then
mema1=0
else
echo ""
echo "Error of the memory command";exit 1  
fi

fi

dio87c -- ra r1 || exit 1 
dio87c -- rta r1 t1 || exit 1 
dio87c -- rja r1 t1 j1 || exit 1 
dio87c -- rja r1 t1 j2 || exit 1 
dio87c -- rja r1 t1 j3 || exit 1 
dio87c -- rta r1 t2 || exit 1 
dio87c -- rja r1 t2 j1 || exit 1 
dio87c -- rta r1 t3 || exit 1 
dio87c -- rja r1 t3 j1 || exit 1 
dio87c -- rk r1 || exit 1 
memb1=`dio87c -- memory`
if [ $? -ne 0 ]; then
if [ "$memb1" = "Unknown command 'memory'" ]; then
memb1=0
else
echo ""
echo "Error of the memory command";exit 1  
fi

fi
if [  $mema1 -ne $memb1  ]; then
	echo ""
echo "Memory error : $mema1 -> $memb1";exit 1 
fi



echo " done"

printf " Test link between task and queue ................................"

mema1=`dio87c -- memory`
if [ $? -ne 0 ]; then
if [ "$mema1" = "Unknown command 'memory'" ]; then
mema1=0
else
echo ""
echo "Error of the memory command";exit 1  
fi

fi

dio87c -- ra r1 || exit 1 
dio87c -- rta r1 t1 || exit 1 
dio87c -- ta tg1 || exit 1 
dio87c -- qa tg1 q1 || exit 1 
dio87c -- rti r1 t1 -S_ | grep "^Queue_batch$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "By default the 'queue' property is not 'batch'!";exit 1 
fi

dio87c -- rti r1 t1 -S_ | grep "^Target_localhost$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "By default the 'target' property is not 'localhost'!";exit 1 
fi

dio87c -- rtst r1 t1 tg1 q1 > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't link task and queue!";exit 1 
fi

dio87c -- rti r1 t1 -S_ | grep "^Queue_q1$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "The 'queue' property was not changed!";exit 1 
fi

dio87c -- rti r1 t1 -S_ | grep "^Target_tg1$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "The 'target' property was not changed!";exit 1 
fi

dio87c -- qrtl tg1 q1 -S_ | grep "^r1_t1$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "The task is not in the task list of the queue!";exit 1 
fi

res=`dio87c -- qrtc tg1 q1`
if [ $? -ne 0 ]; then
echo ""
echo "Can't get the task count!";exit 1 
fi

if [ $res -ne 1 ]; then
echo ""
echo "Task count is not 1!";exit 1 
fi


dio87c -- rtst r1 t1 none > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't unlink the task!";exit 1 
fi

dio87c -- rti r1 t1 -S_ | grep "^Queue_none$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "The 'queue' property is not 'none'!";exit 1 
fi

dio87c -- rti r1 t1 -S_ | grep "^Target_none$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "The 'target' property is not 'none'!";exit 1 
fi

res=`dio87c -- qrtc tg1 q1`
if [ $? -ne 0 ]; then
echo ""
echo "Can't get the task count!";exit 1 
fi

if [ $res -ne 0 ]; then
echo ""
echo "Task count is not 0!";exit 1 
fi


dio87c -- rtst r1 t1 tg1 q1 > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't link task and queue!";exit 1 
fi

res=`dio87c -- qrtc tg1 q1`
if [ $? -ne 0 ]; then
echo ""
echo "Can't get the task count!";exit 1 
fi

if [ $res -ne 1 ]; then
echo ""
echo "Task count is not 1!";exit 1 
fi

dio87c -- rtk r1 t1 || exit 1 
res=`dio87c -- qrtc tg1 q1`
if [ $? -ne 0 ]; then
echo ""
echo "Can't get the task count!";exit 1 
fi

if [ $res -ne 0 ]; then
echo ""
echo "Task count is not 0!";exit 1 
fi


dio87c -- rta r1 t1 || exit 1 
dio87c -- rtst r1 t1 tg1 q1 > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't link task and queue!";exit 1 
fi

dio87c -- rti r1 t1 -S_ | grep "^Queue_q1$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "The 'queue' property was not changed!";exit 1 
fi

dio87c -- rti r1 t1 -S_ | grep "^Target_tg1$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "The 'target' property was not changed!";exit 1 
fi

dio87c -- qk tg1 q1 || exit 1 
dio87c -- rti r1 t1 -S_ | grep "^Queue_none$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "The 'queue' property is not 'none'!";exit 1 
fi

dio87c -- rti r1 t1 -S_ | grep "^Target_none$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "The 'target' property is not 'none'!";exit 1 
fi


dio87c -- rk r1 || exit 1 
dio87c -- tk tg1 || exit 1 
memb1=`dio87c -- memory`
if [ $? -ne 0 ]; then
if [ "$memb1" = "Unknown command 'memory'" ]; then
memb1=0
else
echo ""
echo "Error of the memory command";exit 1  
fi

fi
if [  $mema1 -ne $memb1  ]; then
	echo ""
echo "Memory error : $mema1 -> $memb1";exit 1 
fi


echo " done"

printf " Test task dependencies commands ................................."


mema1=`dio87c -- memory`
if [ $? -ne 0 ]; then
if [ "$mema1" = "Unknown command 'memory'" ]; then
mema1=0
else
echo ""
echo "Error of the memory command";exit 1  
fi

fi

dio87c -- ra r1 || exit 1 
dio87c -- rta r1 t1 || exit 1 
dio87c -- rta r1 t2 || exit 1 
dio87c -- rta r1 t3 || exit 1 
dio87c -- rta r1 t4 || exit 1 
dio87c -- rta r1 t5 || exit 1 

dio87c -- rtda r1 t1 t2 zzz > /dev/null 
if [ $? -eq 0 ]; then
echo ""
echo "Can add a dependence with a wrong type!";exit 1 
fi

dio87c -- rtda zzz t1 t2 > /dev/null 
if [ $? -eq 0 ]; then
echo ""
echo "Can add a dependence with a unknown referential!";exit 1 
fi

dio87c -- rtda r1 zzz t2 > /dev/null 
if [ $? -eq 0 ]; then
echo ""
echo "Can add a dependence with a unknown upstream task!";exit 1 
fi

dio87c -- rtda r1 t1 zzz > /dev/null 
if [ $? -eq 0 ]; then
echo ""
echo "Can add a dependence with a unknown downstream task!";exit 1 
fi


dio87c -- rtda r1 t1 t2 
if [  $? -ne 0 ]; then
echo ""
echo "Can't add a task dependence";exit 1 
fi


dio87c -- rtda r1 t2 t3 always 
if [  $? -ne 0 ]; then
echo ""
echo "Can't add an 'always' dependence";exit 1 
fi


dio87c -- rtda r1 t3 t4 onerror 
if [  $? -ne 0 ]; then
echo ""
echo "Can't add an 'onerror' dependence";exit 1 
fi


dio87c -- rtda r1 t3 t5 onsuccess 
if [  $? -ne 0 ]; then
echo ""
echo "Can't add an 'onsuccess' dependence";exit 1 
fi



res=`dio87c -- rtdc r1`
if [ $? -ne 0 ]; then
echo ""
echo "Can't get the dependence count!";exit 1 
fi

if [ $res -ne 4 ]; then
echo ""
echo "Dependence count is not 4!";exit 1 
fi


dio87c -- rtdl r1 -tS_ | grep "^t1_t2_always$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't find a dependence!";exit 1 
fi

dio87c -- rtdl r1 -tS_ | grep "^t2_t3_always$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't find a dependence!";exit 1 
fi

dio87c -- rtdl r1 -tS_ | grep "^t3_t4_onerror$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't find a dependence!";exit 1 
fi

dio87c -- rtdl r1 -tS_ | grep "^t3_t5_onsuccess$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't find a dependence!";exit 1 
fi


dio87c -- rtda r1 t1 t2 > /dev/null 
if [ $? -eq 0 ]; then
echo ""
echo "Can add a second dependence between the same tasks";exit 1 
fi

dio87c -- rtda r1 t1 t2 onerror > /dev/null 
if [ $? -eq 0 ]; then
echo ""
echo "Can add an onerror dependence between the same tasks";exit 1 
fi

dio87c -- rtda r1 t1 t2 onsuccess > /dev/null 
if [ $? -eq 0 ]; then
echo ""
echo "Can add an onsuccess dependence between the same tasks";exit 1 
fi


dio87c -- rtda r1 t1 t5 always 
if [  $? -ne 0 ]; then
echo ""
echo "Can't add a task dependence";exit 1 
fi


dio87c -- rtdl r1 -tS_ | grep "^t1_t5_always$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't find a dependence!";exit 1 
fi

res=`dio87c -- rtdc r1`
if [ $? -ne 0 ]; then
echo ""
echo "Can't get the dependence count!";exit 1 
fi

if [ $res -ne 5 ]; then
echo ""
echo "Dependence count is not 5!";exit 1 
fi

dio87c -- rtdk r1 t1 t5 always 
if [  $? -ne 0 ]; then
echo ""
echo "Can't delete a task dependence";exit 1 
fi


dio87c -- rtdl r1 -tS_ | grep "^t1_t5_always$" > /dev/null 
if [ $? -eq 0 ]; then
echo ""
echo "The dependence is not deleted!";exit 1 
fi

res=`dio87c -- rtdc r1`
if [ $? -ne 0 ]; then
echo ""
echo "Can't get the dependence count!";exit 1 
fi

if [ $res -ne 4 ]; then
echo ""
echo "Dependence count is not 4!";exit 1 
fi


dio87c -- rta r1 t6 || exit 1 
res=`dio87c -- rtdc r1`

res=`dio87c -- rtdc r1`
if [ $? -ne 0 ]; then
echo ""
echo "Can't get the dependence count!";exit 1 
fi

if [ $res -ne 4 ]; then
echo ""
echo "Dependence count is not 4!";exit 1 
fi

dio87c -- rtda r1 t1 t6 always || exit 1 
res=`dio87c -- rtdc r1`
if [ $? -ne 0 ]; then
echo ""
echo "Can't get the dependence count!";exit 1 
fi

if [ $res -ne 5 ]; then
echo ""
echo "Dependence count is not 5!";exit 1 
fi

dio87c -- rtk r1 t1 > /dev/null 
if [ $? -eq 0 ]; then
echo ""
echo "Can delete a task that has dependences! (t1)";exit 1 
fi

res=`dio87c -- rtdc r1`
if [ $? -ne 0 ]; then
echo ""
echo "Can't get the dependence count!";exit 1 
fi

if [ $res -ne 5 ]; then
echo ""
echo "Dependence count is not 5!";exit 1 
fi

dio87c -- rtk r1 t6 > /dev/null 
if [ $? -eq 0 ]; then
echo ""
echo "Can delete a task that has dependences! (t6)";exit 1 
fi

res=`dio87c -- rtdc r1`
if [ $? -ne 0 ]; then
echo ""
echo "Can't get the dependence count!";exit 1 
fi

if [ $res -ne 5 ]; then
echo ""
echo "Dependence count is not 5!";exit 1 
fi

dio87c -- rtdk r1 t1 t6 always 
if [  $? -ne 0 ]; then
echo ""
echo "Can't delete a task dependence";exit 1 
fi


res=`dio87c -- rtdc r1`
if [ $? -ne 0 ]; then
echo ""
echo "Can't get the dependence count!";exit 1 
fi

if [ $res -ne 4 ]; then
echo ""
echo "Dependence count is not 4!";exit 1 
fi

dio87c -- rtk r1 t6 
if [  $? -ne 0 ]; then
echo ""
echo "Can't delete a task!";exit 1 
fi



dio87c -- rk r1 || exit 1 
memb1=`dio87c -- memory`
if [ $? -ne 0 ]; then
if [ "$memb1" = "Unknown command 'memory'" ]; then
memb1=0
else
echo ""
echo "Error of the memory command";exit 1  
fi

fi
if [  $mema1 -ne $memb1  ]; then
	echo ""
echo "Memory error : $mema1 -> $memb1";exit 1 
fi


echo " done"

printf " Test job dependencies commands .................................."


mema1=`dio87c -- memory`
if [ $? -ne 0 ]; then
if [ "$mema1" = "Unknown command 'memory'" ]; then
mema1=0
else
echo ""
echo "Error of the memory command";exit 1  
fi

fi

dio87c -- ra r1 || exit 1 
dio87c -- rta r1 t1 || exit 1 
dio87c -- rja r1 t1 j1 || exit 1 
dio87c -- rja r1 t1 j2 || exit 1 
dio87c -- rja r1 t1 j3 || exit 1 
dio87c -- rja r1 t1 j4 || exit 1 
dio87c -- rja r1 t1 j5 || exit 1 

dio87c -- rjda r1 t1 j1 j2 zzz > /dev/null 
if [ $? -eq 0 ]; then
echo ""
echo "Can add a dependence with a wrong type!";exit 1 
fi

dio87c -- rjda zzz t1 j1 j2 > /dev/null 
if [ $? -eq 0 ]; then
echo ""
echo "Can add a dependence with a unknown referential!";exit 1 
fi

dio87c -- rjda r1 zzz j1 j2 > /dev/null 
if [ $? -eq 0 ]; then
echo ""
echo "Can add a dependence with a unknown task!";exit 1 
fi

dio87c -- rjda r1 t1 zzz j2 > /dev/null 
if [ $? -eq 0 ]; then
echo ""
echo "Can add a dependence with a unknown upstream job!";exit 1 
fi

dio87c -- rjda r1 t1 j1 zzz > /dev/null 
if [ $? -eq 0 ]; then
echo ""
echo "Can add a dependence with a unknown downstream job!";exit 1 
fi


dio87c -- rjda r1 t1 j1 j2 
if [  $? -ne 0 ]; then
echo ""
echo "Can't add a job dependence";exit 1 
fi


dio87c -- rjda r1 t1 j2 j3 always 
if [  $? -ne 0 ]; then
echo ""
echo "Can't add an 'always' dependence";exit 1 
fi


dio87c -- rjda r1 t1 j3 j4 onerror 
if [  $? -ne 0 ]; then
echo ""
echo "Can't add an 'onerror' dependence";exit 1 
fi


dio87c -- rjda r1 t1 j3 j5 onsuccess 
if [  $? -ne 0 ]; then
echo ""
echo "Can't add an 'onsuccess' dependence";exit 1 
fi



res=`dio87c -- rjdc r1 t1`
if [ $? -ne 0 ]; then
echo ""
echo "Can't get the dependence count!";exit 1 
fi

if [ $res -ne 4 ]; then
echo ""
echo "Dependence count is not 4!";exit 1 
fi


dio87c -- rjdl r1 t1 -tS_ | grep "^j1_j2_always$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't find a dependence!";exit 1 
fi

dio87c -- rjdl r1 t1 -tS_ | grep "^j2_j3_always$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't find a dependence!";exit 1 
fi

dio87c -- rjdl r1 t1 -tS_ | grep "^j3_j4_onerror$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't find a dependence!";exit 1 
fi

dio87c -- rjdl r1 t1 -tS_ | grep "^j3_j5_onsuccess$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't find a dependence!";exit 1 
fi


dio87c -- rjda r1 t1 j1 j2 > /dev/null 
if [ $? -eq 0 ]; then
echo ""
echo "Can add a second dependence between the same jobs";exit 1 
fi

dio87c -- rjda r1 t1 j1 j2 onerror > /dev/null 
if [ $? -eq 0 ]; then
echo ""
echo "Can add an onerror dependence between the same jobs";exit 1 
fi

dio87c -- rjda r1 t1 j1 j2 onsuccess > /dev/null 
if [ $? -eq 0 ]; then
echo ""
echo "Can add an onsuccess dependence between the same jobs";exit 1 
fi


dio87c -- rjda r1 t1 j1 j5 always 
if [  $? -ne 0 ]; then
echo ""
echo "Can't add a job dependence";exit 1 
fi


dio87c -- rjdl r1 t1 -tS_ | grep "^j1_j5_always$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't find a dependence!";exit 1 
fi

res=`dio87c -- rjdc r1 t1`
if [ $? -ne 0 ]; then
echo ""
echo "Can't get the dependence count!";exit 1 
fi

if [ $res -ne 5 ]; then
echo ""
echo "Dependence count is not 5!";exit 1 
fi

dio87c -- rjdk r1 t1 j1 j5 always 
if [  $? -ne 0 ]; then
echo ""
echo "Can't delete a job dependence";exit 1 
fi


dio87c -- rjdl r1 t1 -tS_ | grep "^j1_j5_always$" > /dev/null 
if [ $? -eq 0 ]; then
echo ""
echo "The dependence is not deleted!";exit 1 
fi

res=`dio87c -- rjdc r1 t1`
if [ $? -ne 0 ]; then
echo ""
echo "Can't get the dependence count!";exit 1 
fi

if [ $res -ne 4 ]; then
echo ""
echo "Dependence count is not 4!";exit 1 
fi


dio87c -- rja r1 t1 j6 || exit 1 
res=`dio87c -- rjdc r1 t1`
if [ $? -ne 0 ]; then
echo ""
echo "Can't get the dependence count!";exit 1 
fi

if [ $res -ne 4 ]; then
echo ""
echo "Dependence count is not 4!";exit 1 
fi

dio87c -- rjda r1 t1 j1 j6 always || exit 1 
res=`dio87c -- rjdc r1 t1`
if [ $? -ne 0 ]; then
echo ""
echo "Can't get the dependence count!";exit 1 
fi

if [ $res -ne 5 ]; then
echo ""
echo "Dependence count is not 5!";exit 1 
fi


dio87c -- rjk r1 t1 j6 > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't delete a job that has dependences!";exit 1 
fi

res=`dio87c -- rjdc r1 t1`
if [ $? -ne 0 ]; then
echo ""
echo "Can't get the dependence count!";exit 1 
fi

if [ $res -ne 4 ]; then
echo ""
echo "Dependence count is not 4!";exit 1 
fi


dio87c -- rk r1 || exit 1 
memb1=`dio87c -- memory`
if [ $? -ne 0 ]; then
if [ "$memb1" = "Unknown command 'memory'" ]; then
memb1=0
else
echo ""
echo "Error of the memory command";exit 1  
fi

fi
if [  $mema1 -ne $memb1  ]; then
	echo ""
echo "Memory error : $mema1 -> $memb1";exit 1 
fi


echo " done"

printf " Test task condition commands ...................................."


mema1=`dio87c -- memory`
if [ $? -ne 0 ]; then
if [ "$mema1" = "Unknown command 'memory'" ]; then
mema1=0
else
echo ""
echo "Error of the memory command";exit 1  
fi

fi

dio87c -- ra r1 || exit 1 
dio87c -- rta r1 t1 || exit 1 

dio87c -- rjca xx t1 manual ready > /dev/null 
if [ $? -eq 0 ]; then
echo ""
echo "Can add a task condition with a unknown referential!";exit 1 
fi

dio87c -- rjca r1 xx manual ready > /dev/null 
if [ $? -eq 0 ]; then
echo ""
echo "Can add a task condition with a unknown task!";exit 1 
fi

dio87c -- rjca r1 t1 xxxxxx ready > /dev/null 
if [ $? -eq 0 ]; then
echo ""
echo "Can add a task condition with a wrong type!";exit 1 
fi

dio87c -- rjca r1 t1 manual > /dev/null 
if [ $? -eq 0 ]; then
echo ""
echo "Can add a manual condition without argument!";exit 1 
fi


dio87c -- rtca r1 t1 manual ready 
if [  $? -ne 0 ]; then
echo ""
echo "Can't add a manual condition!";exit 1 
fi


dio87c -- rtca r1 t1 file path 
if [  $? -ne 0 ]; then
echo ""
echo "Can't add a file condition!";exit 1 
fi


dio87c -- rtca r1 t1 hmin "20:30" 1 
if [  $? -ne 0 ]; then
echo ""
echo "Can't add a hmin condition!";exit 1 
fi


dio87c -- rtca r1 t1 hmax "21:30" 2 
if [  $? -ne 0 ]; then
echo ""
echo "Can't add a hmax condition!";exit 1 
fi


dio87c -- rtca r1 t1 hlate "22:30" 3 
if [  $? -ne 0 ]; then
echo ""
echo "Can't add a hlate condition!";exit 1 
fi



dio87c -- rtcl r1 t1 -S_ | grep "^manual_ready$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't find the manual condition!";exit 1 
fi

dio87c -- rtcl r1 t1 -S_ | grep "^file_path$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't find the file condition!";exit 1 
fi

dio87c -- rtcl r1 t1 -S_ | grep "^hmin_20:30_+1$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't find the hmin condition!";exit 1 
fi

dio87c -- rtcl r1 t1 -S_ | grep "^hmax_21:30_+2$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't find the hmax condition!";exit 1 
fi

dio87c -- rtcl r1 t1 -S_ | grep "^hlate_22:30_+3$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't find the hlate condition!";exit 1 
fi


res=`dio87c -- rtcc r1 t1`
if [ $? -ne 0 ]; then
echo ""
echo "Can't get the condition count!";exit 1 
fi

if [ $res -ne 5 ]; then
echo ""
echo "Condition count is not 5!";exit 1 
fi


mema2=`dio87c -- memory`
if [ $? -ne 0 ]; then
if [ "$mema2" = "Unknown command 'memory'" ]; then
mema2=0
else
echo ""
echo "Error of the memory command";exit 1  
fi

fi

dio87c -- rtca r1 t1 manual ok || exit 1 
res=`dio87c -- rtcc r1 t1`
if [ $? -ne 0 ]; then
echo ""
echo "Can't get the condition count!";exit 1 
fi

if [ $res -ne 6 ]; then
echo ""
echo "Condition count is not 6!";exit 1 
fi

dio87c -- rtck r1 t1 manual ok || exit 1 
res=`dio87c -- rtcc r1 t1`
if [ $? -ne 0 ]; then
echo ""
echo "Can't get the condition count!";exit 1 
fi

if [ $res -ne 5 ]; then
echo ""
echo "Condition count is not 5!";exit 1 
fi

memb2=`dio87c -- memory`
if [ $? -ne 0 ]; then
if [ "$memb2" = "Unknown command 'memory'" ]; then
memb2=0
else
echo ""
echo "Error of the memory command";exit 1  
fi

fi
if [  $mema2 -ne $memb2  ]; then
	echo ""
echo "Memory error : $mema2 -> $memb2";exit 1 
fi

mema2=`dio87c -- memory`
if [ $? -ne 0 ]; then
if [ "$mema2" = "Unknown command 'memory'" ]; then
mema2=0
else
echo ""
echo "Error of the memory command";exit 1  
fi

fi

dio87c -- rtca r1 t1 file path || exit 1 
res=`dio87c -- rtcc r1 t1`
if [ $? -ne 0 ]; then
echo ""
echo "Can't get the condition count!";exit 1 
fi

if [ $res -ne 6 ]; then
echo ""
echo "Condition count is not 6!";exit 1 
fi

dio87c -- rtck r1 t1 file path || exit 1 
res=`dio87c -- rtcc r1 t1`
if [ $? -ne 0 ]; then
echo ""
echo "Can't get the condition count!";exit 1 
fi

if [ $res -ne 5 ]; then
echo ""
echo "Condition count is not 5!";exit 1 
fi

memb2=`dio87c -- memory`
if [ $? -ne 0 ]; then
if [ "$memb2" = "Unknown command 'memory'" ]; then
memb2=0
else
echo ""
echo "Error of the memory command";exit 1  
fi

fi
if [  $mema2 -ne $memb2  ]; then
	echo ""
echo "Memory error : $mema2 -> $memb2";exit 1 
fi

mema2=`dio87c -- memory`
if [ $? -ne 0 ]; then
if [ "$mema2" = "Unknown command 'memory'" ]; then
mema2=0
else
echo ""
echo "Error of the memory command";exit 1  
fi

fi

dio87c -- rtca r1 t1 hmin "18:00" 0 || exit 1 
res=`dio87c -- rtcc r1 t1`
if [ $? -ne 0 ]; then
echo ""
echo "Can't get the condition count!";exit 1 
fi

if [ $res -ne 6 ]; then
echo ""
echo "Condition count is not 6!";exit 1 
fi

dio87c -- rtck r1 t1 hmin "18:00" 0 || exit 1 
res=`dio87c -- rtcc r1 t1`
if [ $? -ne 0 ]; then
echo ""
echo "Can't get the condition count!";exit 1 
fi

if [ $res -ne 5 ]; then
echo ""
echo "Condition count is not 5!";exit 1 
fi

memb2=`dio87c -- memory`
if [ $? -ne 0 ]; then
if [ "$memb2" = "Unknown command 'memory'" ]; then
memb2=0
else
echo ""
echo "Error of the memory command";exit 1  
fi

fi
if [  $mema2 -ne $memb2  ]; then
	echo ""
echo "Memory error : $mema2 -> $memb2";exit 1 
fi

mema2=`dio87c -- memory`
if [ $? -ne 0 ]; then
if [ "$mema2" = "Unknown command 'memory'" ]; then
mema2=0
else
echo ""
echo "Error of the memory command";exit 1  
fi

fi

dio87c -- rtca r1 t1 hmax "18:00" 0 || exit 1 
res=`dio87c -- rtcc r1 t1`
if [ $? -ne 0 ]; then
echo ""
echo "Can't get the condition count!";exit 1 
fi

if [ $res -ne 6 ]; then
echo ""
echo "Condition count is not 6!";exit 1 
fi

dio87c -- rtck r1 t1 hmax "18:00" 0 || exit 1 
res=`dio87c -- rtcc r1 t1`
if [ $? -ne 0 ]; then
echo ""
echo "Can't get the condition count!";exit 1 
fi

if [ $res -ne 5 ]; then
echo ""
echo "Condition count is not 5!";exit 1 
fi

memb2=`dio87c -- memory`
if [ $? -ne 0 ]; then
if [ "$memb2" = "Unknown command 'memory'" ]; then
memb2=0
else
echo ""
echo "Error of the memory command";exit 1  
fi

fi
if [  $mema2 -ne $memb2  ]; then
	echo ""
echo "Memory error : $mema2 -> $memb2";exit 1 
fi

mema2=`dio87c -- memory`
if [ $? -ne 0 ]; then
if [ "$mema2" = "Unknown command 'memory'" ]; then
mema2=0
else
echo ""
echo "Error of the memory command";exit 1  
fi

fi

dio87c -- rtca r1 t1 hlate "18:00" 0 || exit 1 
res=`dio87c -- rtcc r1 t1`
if [ $? -ne 0 ]; then
echo ""
echo "Can't get the condition count!";exit 1 
fi

if [ $res -ne 6 ]; then
echo ""
echo "Condition count is not 6!";exit 1 
fi

dio87c -- rtck r1 t1 hlate "18:00" 0 || exit 1 
res=`dio87c -- rtcc r1 t1`
if [ $? -ne 0 ]; then
echo ""
echo "Can't get the condition count!";exit 1 
fi

if [ $res -ne 5 ]; then
echo ""
echo "Condition count is not 5!";exit 1 
fi

memb2=`dio87c -- memory`
if [ $? -ne 0 ]; then
if [ "$memb2" = "Unknown command 'memory'" ]; then
memb2=0
else
echo ""
echo "Error of the memory command";exit 1  
fi

fi
if [  $mema2 -ne $memb2  ]; then
	echo ""
echo "Memory error : $mema2 -> $memb2";exit 1 
fi


dio87c -- rk r1 || exit 1 
memb1=`dio87c -- memory`
if [ $? -ne 0 ]; then
if [ "$memb1" = "Unknown command 'memory'" ]; then
memb1=0
else
echo ""
echo "Error of the memory command";exit 1  
fi

fi
if [  $mema1 -ne $memb1  ]; then
	echo ""
echo "Memory error : $mema1 -> $memb1";exit 1 
fi


echo " done"

printf " Test referential copy ..........................................."


mema1=`dio87c -- memory`
if [ $? -ne 0 ]; then
if [ "$mema1" = "Unknown command 'memory'" ]; then
mema1=0
else
echo ""
echo "Error of the memory command";exit 1  
fi

fi

dio87c -- ta tg1 || exit 1 
dio87c -- qa tg1 q1 || exit 1 

dio87c -- ra r1 || exit 1 
dio87c -- rta r1 t1 task1 || exit 1 
dio87c -- rta r1 t2 task2 || exit 1 
dio87c -- rta r1 t3 task3 || exit 1 
dio87c -- rta r1 t4 task4 || exit 1 

dio87c -- rtda r1 t1 t2 onerror || exit 1 
dio87c -- rtda r1 t1 t3 always || exit 1 
dio87c -- rtda r1 t3 t4 onsuccess || exit 1 

dio87c -- rtswad r1 t2 false || exit 1 
dio87c -- rtswad r1 t3 true || exit 1 
dio87c -- rtsoec r1 t1 false || exit 1 
dio87c -- rtsoec r1 t4 true || exit 1 
dio87c -- rtse r1 t3 false || exit 1 
dio87c -- rtse r1 t4 true || exit 1 

dio87c -- rja r1 t1 j1 task1_job1 || exit 1 
dio87c -- rja r1 t1 j2 task1_job2 || exit 1 
dio87c -- rja r1 t1 j3 task1_job3 || exit 1 
dio87c -- rja r1 t1 j4 task1_job4 || exit 1 

dio87c -- rjsp r1 t1 j2 "/bin/ls" || exit 1 
dio87c -- rjsa r1 t1 j2 "arg" || exit 1 
dio87c -- rjst r1 t1 j3 55 56 || exit 1 

dio87c -- rjda r1 t1 j1 j2 onerror || exit 1 
dio87c -- rjda r1 t1 j1 j3 always || exit 1 
dio87c -- rjda r1 t1 j3 j4 onsuccess || exit 1 

dio87c -- rjswad r1 t1 j2 false || exit 1 
dio87c -- rjswad r1 t1 j3 true || exit 1 
dio87c -- rjsoec r1 t1 j1 false || exit 1 
dio87c -- rjsoec r1 t1 j4 true || exit 1 

dio87c -- rja r1 t2 j1 task2_job1 || exit 1 
dio87c -- rja r1 t2 j2 task2_job2 || exit 1 
dio87c -- rjda r1 t2 j1 j2 always || exit 1 

dio87c -- rtca r1 t1 hmin "11:00" 0 || exit 1 
dio87c -- rtca r1 t1 hmax "12:00" 0 || exit 1 
dio87c -- rtca r1 t2 manual "ok?" || exit 1 
dio87c -- rtca r1 t4 file "/tmp/fic" || exit 1 

dio87c -- rtst r1 t1 tg1 q1 || exit 1 
dio87c -- rtst r1 t2 none || exit 1 

mema2=`dio87c -- memory`
if [ $? -ne 0 ]; then
if [ "$mema2" = "Unknown command 'memory'" ]; then
mema2=0
else
echo ""
echo "Error of the memory command";exit 1  
fi

fi

dio87c -- rd r1 r2 
if [  $? -ne 0 ]; then
echo ""
echo "Can't copy a referential";exit 1 
fi



res=`dio87c -- rtc r2`
if [ $? -ne 0 ]; then
echo ""
echo "Can't get task count!";exit 1 
fi

if [ $res -ne 4 ]; then
echo ""
echo "Task count is not 4!";exit 1 
fi

dio87c -- rtl -dS_ r2 | grep "^t1_task1$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't find task t1!";exit 1 
fi

dio87c -- rtl -dS_ r2 | grep "^t2_task2$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't find task t2!";exit 1 
fi

dio87c -- rtl -dS_ r2 | grep "^t3_task3$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't find task t3!";exit 1 
fi

dio87c -- rtl -dS_ r2 | grep "^t4_task4$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't find task t4!";exit 1 
fi


res=`dio87c -- rtdc r2`
if [ $? -ne 0 ]; then
echo ""
echo "Can't get task count!";exit 1 
fi

if [ $res -ne 3 ]; then
echo ""
echo "Task dependence count is not 3!";exit 1 
fi

dio87c -- rtdl r2 -tS_ | grep "^t1_t2_onerror$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't find task dependence between t1 and t2!";exit 1 
fi

dio87c -- rtdl r2 -tS_ | grep "^t1_t3_always$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't find task dependence between t1 and t3!";exit 1 
fi

dio87c -- rtdl r2 -tS_ | grep "^t3_t4_onsuccess$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't find task dependence between t3 and t4!";exit 1 
fi


dio87c -- rti -S_ r2 t2 | grep "^Wait All Dependencies_false$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "The wait_all_dependencies of t2 is not false!";exit 1 
fi

dio87c -- rti -S_ r2 t3 | grep "^Wait All Dependencies_true$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "The wait_all_dependencies of t3 is not true!";exit 1 
fi

dio87c -- rti -S_ r2 t1 | grep "^On Error Continue_false$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "The on_error_continue of t1 is not false!";exit 1 
fi

dio87c -- rti -S_ r2 t4 | grep "^On Error Continue_true$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "The on_error_continue of t4 is not true!";exit 1 
fi


dio87c -- rti -S_ r2 t3 | grep "^Enabled_false$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "The enabled property of the task t3 is not false!";exit 1 
fi

dio87c -- rti -S_ r2 t4 | grep "^Enabled_true$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "The enabled property of the task t4 is not true!";exit 1 
fi


dio87c -- rji -S_ r2 t1 j2 | grep "^Wait All Dependencies_false$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "The wait_all_dependencies of j2 is not false!";exit 1 
fi

dio87c -- rji -S_ r2 t1 j3 | grep "^Wait All Dependencies_true$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "The wait_all_dependencies of j3 is not true!";exit 1 
fi

dio87c -- rji -S_ r2 t1 j1 | grep "^On Error Continue_false$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "The on_error_continue of j1 is not false!";exit 1 
fi

dio87c -- rji -S_ r2 t1 j4 | grep "^On Error Continue_true$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "The on_error_continue of j4 is not true!";exit 1 
fi

dio87c -- rji -S_ r2 t1 j2 | grep "^Path_/bin/ls$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "The job path is not set!";exit 1 
fi

dio87c -- rji -S_ r2 t1 j2 | grep "^Argument_arg$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "The job argument is not set!";exit 1 
fi

dio87c -- rji -S_ r2 t1 j3 | grep "^Start Tempo_55$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "The start tempo of the job j3 is not set!";exit 1 
fi

dio87c -- rji -S_ r2 t1 j3 | grep "^End Tempo_56$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "The end tempo of the job j3 is not set!";exit 1 
fi


res=`dio87c -- rjc r2 t1`
if [ $? -ne 0 ]; then
echo ""
echo "Can't get job count!";exit 1 
fi

if [ $res -ne 4 ]; then
echo ""
echo "Job count is not 4!";exit 1 
fi

dio87c -- rjl r2 t1 -dS_ | grep "^j1_task1_job1$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't find job j1!";exit 1 
fi

dio87c -- rjl r2 t1 -dS_ | grep "^j2_task1_job2$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't find job j2!";exit 1 
fi

dio87c -- rjl r2 t1 -dS_ | grep "^j3_task1_job3$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't find job j3!";exit 1 
fi

dio87c -- rjl r2 t1 -dS_ | grep "^j4_task1_job4$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't find job j4!";exit 1 
fi



res=`dio87c -- rjdc r2 t1`
if [ $? -ne 0 ]; then
echo ""
echo "Can't get job dependence count!";exit 1 
fi

if [ $res -ne 3 ]; then
echo ""
echo "Job dependence count is not 3!";exit 1 
fi

dio87c -- rjdl r2 t1 -tS_ | grep "^j1_j2_onerror$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't find job dependence between j1 and j2!";exit 1 
fi

dio87c -- rjdl r2 t1 -tS_ | grep "^j1_j3_always$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't find job dependence between j1 and j3!";exit 1 
fi

dio87c -- rjdl r2 t1 -tS_ | grep "^j3_j4_onsuccess$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't find job dependence between j3 and j4!";exit 1 
fi


res=`dio87c -- rjc r2 t2`
if [ $? -ne 0 ]; then
echo ""
echo "Can't get job count!";exit 1 
fi

if [ $res -ne 2 ]; then
echo ""
echo "Job count is not 2!";exit 1 
fi

dio87c -- rjl r2 t2 -dS_ | grep "^j1_task2_job1$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't find job j1!";exit 1 
fi

dio87c -- rjl r2 t2 -dS_ | grep "^j2_task2_job2$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't find job j2!";exit 1 
fi

res=`dio87c -- rjdc r2 t2`
if [ $? -ne 0 ]; then
echo ""
echo "Can't get job dependence count!";exit 1 
fi

if [ $res -ne 1 ]; then
echo ""
echo "Job dependence count is not 1!";exit 1 
fi

dio87c -- rjdl r2 t2 -tS_ | grep "^j1_j2_always$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't find job dependence between j1 and j2!";exit 1 
fi


res=`dio87c -- rtcc r2 t1`
if [ $? -ne 0 ]; then
echo ""
echo "Can't get condition count!";exit 1 
fi

if [ $res -ne 2 ]; then
echo ""
echo "Condition count of task t1 is not 2!";exit 1 
fi

dio87c -- rtcl -S_ r2 t1 | grep "^hmin_11:00_+0$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't find the hmin condition!";exit 1 
fi

dio87c -- rtcl -S_ r2 t1 | grep "^hmax_12:00_+0$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't find the hmax condition!";exit 1 
fi

dio87c -- rtcl -S_ r2 t2 | grep "^manual_ok?$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't find the manual condition!";exit 1 
fi

dio87c -- rtcl -S_ r2 t4 | grep "^file_/tmp/fic$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't find the file condition!";exit 1 
fi


dio87c -- rti -S_ r2 t1 | grep "^Target_tg1$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "The target is not set!";exit 1 
fi

dio87c -- rti -S_ r2 t1 | grep "^Queue_q1$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "The queue is not set!";exit 1 
fi

dio87c -- rti -S_ r2 t2 | grep "^Target_none$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "The target is not set!";exit 1 
fi

dio87c -- rti -S_ r2 t2 | grep "^Queue_none$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "The queue is not set!";exit 1 
fi


dio87c -- rk r2 || exit 1 
memb2=`dio87c -- memory`
if [ $? -ne 0 ]; then
if [ "$memb2" = "Unknown command 'memory'" ]; then
memb2=0
else
echo ""
echo "Error of the memory command";exit 1  
fi

fi
if [  $mema2 -ne $memb2  ]; then
	echo ""
echo "Memory error : $mema2 -> $memb2";exit 1 
fi


dio87c -- rk r1 || exit 1 
dio87c -- tk tg1 || exit 1 

memb1=`dio87c -- memory`
if [ $? -ne 0 ]; then
if [ "$memb1" = "Unknown command 'memory'" ]; then
memb1=0
else
echo ""
echo "Error of the memory command";exit 1  
fi

fi
if [  $mema1 -ne $memb1  ]; then
	echo ""
echo "Memory error : $mema1 -> $memb1";exit 1 
fi


echo " done"


printf " Stop dio87d ....................................................."

pid=`ps -e | grep [d]io87d`
if [ $? -ne 0 ]; then
echo ""
echo "dio87d is not executing";exit 1 
fi
pid=`echo $pid | awk '{print $1}'`
kill -s TERM $pid
sleep 1 
ps -e | grep [d]io87d > /dev/null 
if [ $? -eq 0 ]; then
echo ""
echo "dio87d is not stopped";exit 1 
fi

echo " done"
i=0
while ls "$DATAPATH" | grep "dio87d.pid" >/dev/null
do
	i=$((i+1))
	sleep 1
	if test $i -eq 10 
	then 
		echo "The PID file is not deleted"
		exit 1
	fi
done
rm -f "$DATAPATH"/*.conf || exit 1
rm -f "$DATAPATH"/*.data || exit 1
rmdir "$DATAPATH" || exit 1


