DG_BEGIN([tst06], [Check job dependencies])
DG_DIO87D_START()

dnl ---------------------------------------------------------------------------
DG_MSG_CHECKING([Test a task without jobs])
DG_MEMORY(1)
DG_EXEC_OR_DIE([ra r1])
DG_EXEC_OR_DIE([rta r1 t1])
DG_EXEC_OR_DIE([rtoa r1 t1 add always])

DG_EXEC([rp r1 today d1],,,DG_DIE())
DG_EXEC_RETRY([xti -S_ d1 t1 | grep "^State_terminated$"], 
	5, [t1 is not terminated !])

DG_EXEC_OR_DIE([rk r1])
DG_EXEC_OR_DIE([srk r1])
DG_EXEC_OR_DIE([xdk d1])
DG_EXEC_OR_DIE([ldk d1])
DG_MEMORY_CHECK(1)
DG_MSG_DONE()

dnl ---------------------------------------------------------------------------
DG_MSG_CHECKING([Check execution of one job (normal termination)])
DG_MEMORY(1)

DG_EXEC_OR_DIE([ra r1])
DG_EXEC_OR_DIE([rta r1 t1])
DG_EXEC_OR_DIE([rtoa r1 t1 add always])

DG_EXEC_OR_DIE([rja r1 t1 j1])
DG_EXEC_OR_DIE([rjsp r1 t1 j1 /bin/sleep])
DG_EXEC_OR_DIE([rjsa r1 t1 j1 6])

DG_EXEC([rp r1 today d1],,,DG_DIE())

dnl job is running
DG_EXEC_RETRY([xji -S_ d1 t1 j1 | grep "^State_running$"], 
	6, [Job is not running!])
DG_CHECK_FIELD([xti d1 t1],[State],[running], [Task is not running])

dnl job is terminated
DG_EXEC_RETRY([xji -S_ d1 t1 j1 | grep "^State_terminated$"], 
	6, [Job is not terminated !])
DG_CHECK_FIELD([xji d1 t1 j1], [Exit code], [0], [Exit code is not 0!])
DG_CHECK_FIELD([xti d1 t1], [State], [terminated], [Task is not terminated])

DG_EXEC_OR_DIE([rk r1])
DG_EXEC_OR_DIE([srk r1])
DG_EXEC_OR_DIE([xdk d1])
DG_EXEC_OR_DIE([ldk d1])

DG_MEMORY_CHECK(1)
DG_MSG_DONE()

DG_DIO87D_STOP()
DG_END()


