DG_BEGIN([tst07], [Check the property 'opened'])
DG_DIO87D_START()

dnl ---------------------------------------------------------------------------
DG_MSG_CHECKING([Test the target open/close property ])
DG_MEMORY(1)
DG_CHECK_FIELD([ti localhost], [Opened], [true], [By default a target should be opened])
DG_EXEC_OR_DIE([tso localhost false])
DG_CHECK_FIELD([ti localhost], [Opened], [false], [The target is not closed!])
DG_EXEC_OR_DIE([tso localhost true])
DG_CHECK_FIELD([ti localhost], [Opened], [true], [The target is not opened!])

DG_MEMORY_CHECK(1)
DG_MSG_DONE()

DG_EXEC_OR_DIE([tso localhost false])
DG_EXEC_OR_DIE([ra r1])
DG_EXEC_OR_DIE([rta r1 t1])
DG_EXEC_OR_DIE([rtoa r1 t1 add always])
DG_EXEC_OR_DIE([rja r1 t1 j1])
DG_EXEC_OR_DIE([rjsp r1 t1 j1 "/bin/sleep"])
DG_EXEC_OR_DIE([rjsa r1 t1 j1 5])

DG_EXEC([rp r1 today d1],,,DG_DIE())

dnl check that job is not running (the target is closed)
DG_WAIT(2)
DG_CHECK_FIELD([xji d1 t1 j1], [State], [wait_target], 
	[The state of j1 is not 'wait_target'!])
DG_CHECK_FIELD([xti d1 t1], [State], [running], 
	[The state of t1 is not 'running'!])

DG_EXEC_FIND([qxjc localhost batch],[1],,
	DG_DIE([The number of running jobs in the queue is not 1!]))
DG_EXEC_FIND([qxjl -S_ localhost batch],[d1_t1_j1],,
	DG_DIE([Can't find the job j1 in the qxjl result]))

dnl Open the target
DG_EXEC_OR_DIE([tso localhost true])
DG_WAIT(2)

DG_CHECK_FIELD([xji d1 t1 j1], [State], [running], 
	[The state of j1 is not 'running'!])
DG_CHECK_FIELD([xti d1 t1], [State], [running], 
	[The state of t1 is not 'running'!])

DG_EXEC_FIND([qxjc localhost batch],[0],
	DG_DIE([The number of running jobs in the queue is not 0!]))

DG_EXEC_FIND([qxjl -S_ localhost batch],[d1_t1_j1],,
	DG_DIE([The job j1 is not in the result of the qxjl result]))

DG_WAIT(3)

DG_CHECK_FIELD([xji d1 t1 j1], [State], [terminated], 
	[The state of j1 is not 'terminated'!])
DG_CHECK_FIELD([xti d1 t1], [State], [terminated], 
	[The state of t1 is not 'terminated'!])

DG_EXEC_FIND([qxjl -S_ localhost batch],[d1_t1_j1],
	DG_DIE([The job j1 is in the result of the qxjl result]))



DG_EXEC_OR_DIE([rk r1])
DG_DIO87D_STOP()

DG_END()


