#!/bin/sh
#
# file tst56.sh 
# (test the `deleted' state of a job) 
#
#      Diogene87
#	Copyright (C) 2003,2004,2005,2006,2007 - Dominique Parisot
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this software; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
# Boston, MA 02111-1307 USA
#


if [ "$srcdir" = "" ]; then srcdir="."; fi
. $srcdir/functions.sh
checkNoDaemon

echo "Test the 'deleted' state of a job"

startDio87d || exit 1

dio87c ra r1 || exit 1
dio87c rta r1 t1 || exit 1
dio87c rtoa r1 t1 add always || exit 1

dio87c rja r1 t1 j1 || exit 1
dio87c rjsp r1 t1 j1 "wrong_path" || exit 1
dio87c rjsoec r1 t1 j1 false || exit 1

dio87c rja r1 t1 j2 || exit 1
dio87c rjsp r1 t1 j2 "/bin/sleep" || exit 1
dio87c rjsa r1 t1 j2 5 || exit 1

dio87c rjda r1 t1 j1 j2 || exit 1

# create a new day
dio87c rp r1 "$dayDate" d1 >/dev/null || exit 1

waitretry 10 "dio87c -- xjl d1 t1 -sS_ | grep j1" "j1_delete_stopped"
if [ $? -ne 0 ]; then
	echo "The job 'j1' is not delete_stopped !"; exit 1
fi

waitretry 2 "dio87c -- xjl d1 t1 -sS_ | grep j2" "j2_wait_for_dep" 
if [ $? -ne 0 ] ; then
	echo "The job 'j2' is not waiting for dependences"; exit 1
fi

waitretry 2 "dio87c -- xtl d1 -sS_ | grep t1" "t1_abort_stopped" 
if [ $? -ne 0 ] ; then
	echo "The task 't1' is not abort_stopped"; exit 1
fi
stopDio87d || exit 1

