#!/bin/sh
#
# file tst59.sh 
# (test of task restart)
#
#      Diogene87
#	Copyright (C) 2003,2004,2005,2006,2007 - Dominique Parisot
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this software; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
# Boston, MA 02111-1307 USA
#


if [ "$srcdir" = "" ]; then srcdir="."; fi
. $srcdir/functions.sh
checkNoDaemon

echo "Test of task restart"

startDio87d || exit 1

mem1=`dio87c -- memory` || exit 1

dio87c ra r1 || exit 1

dio87c rta r1 t1 || exit 1
dio87c rtoa r1 t1 add always || exit 1
dio87c rja r1 t1 j1 || exit 1

dio87c rjsp r1 t1 j1 "/bin/false" || exit 1

dio87c rtd r1 t1 t2 || exit 1
dio87c rjsp r1 t2 j1 "/bin/true" || exit 1

dio87c rtd r1 t1 t3 || exit 1
dio87c rjsp r1 t3 j1 "/bin/true" || exit 1

dio87c rtd r1 t1 t4 || exit 1
dio87c rjsp r1 t4 j1 "/bin/true" || exit 1

dio87c rtd r1 t1 t5 || exit 1
dio87c rjsp r1 t5 j1 "/bin/true" || exit 1

dio87c rtd r1 t1 t6 || exit 1
dio87c rjsp r1 t6 j1 "/bin/true" || exit 1

dio87c rtd r1 t1 t7 || exit 1
dio87c rjsp r1 t7 j1 "/bin/true" || exit 1

dio87c rtda r1 t1 t2 always || exit 1
dio87c rtda r1 t1 t3 onsuccess || exit 1
dio87c rtda r1 t1 t4 onerror || exit 1

dio87c rtda r1 t2 t5 || exit 1
dio87c rtda r1 t3 t6 || exit 1
dio87c rtda r1 t4 t7 || exit 1

echo " first execution (with abort)"
dio87c rp r1 "$dayDate" d1 >/dev/null || exit 1
waitretry 20 "dio87c -- xtl -sS_ d1 | grep t1" "t1_aborted"

if [ "`dio87c -- xtl -sS_ d1 | grep t1`" != "t1_aborted" ] ; then 
	echo "t1 is not aborted !"; exit 1
fi
if [ "`dio87c -- xtl -sS_ d1 | grep t2`" != "t2_terminated" ] ; then 
	echo "t2 is not terminated !"; exit 1
fi
if [ "`dio87c -- xtl -sS_ d1 | grep t3`" != "t3_canceled" ] ; then 
	echo "t3 is not canceled !"; exit 1
fi
if [ "`dio87c -- xtl -sS_ d1 | grep t4`" != "t4_terminated" ] ; then 
	echo "t4 is not terminated !"; exit 1
fi
if [ "`dio87c -- xtl -sS_ d1 | grep t5`" != "t5_terminated" ] ; then 
	echo "t5 is not terminated !"; exit 1
fi
if [ "`dio87c -- xtl -sS_ d1 | grep t6`" != "t6_canceled" ] ; then 
	echo "t6 is not canceled !"; exit 1
fi
if [ "`dio87c -- xtl -sS_ d1 | grep t7`" != "t7_terminated" ] ; then 
	echo "t7 is not terminated !"; exit 1
fi

if [ "`dio87c -- xtdl -sS_ d1 | grep t1_t2`" != "t1_t2_validated" ] ; then 
	echo "dependence t1-t2 is not validated !"; exit 1
fi
if [ "`dio87c -- xtdl -sS_ d1 | grep t1_t3`" != "t1_t3_canceled" ] ; then 
	echo "dependence t1-t3 is not canceled !"; exit 1
fi
if [ "`dio87c -- xtdl -sS_ d1 | grep t1_t4`" != "t1_t4_validated" ] ; then 
	echo "dependence t1-t4 is not validated !"; exit 1
fi
if [ "`dio87c -- xtdl -sS_ d1 | grep t2_t5`" != "t2_t5_validated" ] ; then 
	echo "dependence t2-j5 is not validated !"; exit 1
fi
if [ "`dio87c -- xtdl -sS_ d1 | grep t3_t6`" != "t3_t6_canceled" ] ; then 
	echo "dependence t3-t6 is not canceled !"; exit 1
fi

if [ "`dio87c -- xtdl -sS_ d1 | grep t4_t7`" != "t4_t7_validated" ] ; then 
	echo "dependence t4-t7 is not validated !"; exit 1
fi

# restart job
echo " update jobs states"
dio87c xjsp d1 t1 j1 "/bin/true" || exit 1
dio87c xju d1 t1 j1 ready_to_run || exit 1
if [ "`dio87c -- xjl -sS_ d1 t1 | grep j1`" != "j1_ready_to_run" ] ; then 
	echo "j1 is not ready_to_run!"; exit 1
fi


dio87c xju d1 t1 j2 wait_for_dep || exit 1
dio87c xju d1 t1 j3 wait_for_dep || exit 1
dio87c xju d1 t1 j4 wait_for_dep || exit 1
dio87c xju d1 t1 j5 wait_for_dep || exit 1
dio87c xju d1 t1 j6 wait_for_dep || exit 1
dio87c xju d1 t1 j7 wait_for_dep || exit 1

if [ "`dio87c -- xjl -sS_ d1 t1 | grep j2`" != "j2_wait_for_dep" ] ; then 
	echo "j2 is not waiting for dependencies !"; exit 1
fi
if [ "`dio87c -- xjl -sS_ d1 t1 | grep j3`" != "j3_wait_for_dep" ] ; then 
	echo "j3 is not waiting for dependencies !"; exit 1
fi
if [ "`dio87c -- xjl -sS_ d1 t1 | grep j4`" != "j4_wait_for_dep" ] ; then 
	echo "j4 is not waiting for dependencies !"; exit 1
fi
if [ "`dio87c -- xjl -sS_ d1 t1 | grep j5`" != "j5_wait_for_dep" ] ; then 
	echo "j5 is not waiting for dependencies !"; exit 1
fi
if [ "`dio87c -- xjl -sS_ d1 t1 | grep j6`" != "j6_wait_for_dep" ] ; then 
	echo "j6 is not waiting for dependencies !"; exit 1
fi
if [ "`dio87c -- xjl -sS_ d1 t1 | grep j7`" != "j7_wait_for_dep" ] ; then 
	echo "j7 is not waiting for dependencies !"; exit 1
fi

if [ "`dio87c -- xjdl -sS_ d1 t1 | grep j2_j5`" != "j2_j5_waiting" ] ; then 
	echo "dependence j2-j5 is not waiting !"; exit 1
fi
if [ "`dio87c -- xjdl -sS_ d1 t1 | grep j3_j6`" != "j3_j6_waiting" ] ; then 
	echo "dependence j3-j6 is not waiting !"; exit 1
fi
if [ "`dio87c -- xjdl -sS_ d1 t1 | grep j4_j7`" != "j4_j7_waiting" ] ; then 
	echo "dependence j4-j7 is not waiting !"; exit 1
fi


# restart task
echo " second execution (restart)"
dio87c xtu d1 t1 running || exit 1
waitretry 9 "dio87c xtl -- -sS_ d1 | grep t1" "t1_terminated"

if [ "`dio87c -- xjl -sS_ d1 t1 | grep j1`" != "j1_terminated" ] ; then 
	echo "j1 is not terminated !"; exit 1
fi
if [ "`dio87c -- xjl -sS_ d1 t1 | grep j2`" != "j2_terminated" ] ; then 
	echo "j2 is not terminated !"; exit 1
fi
if [ "`dio87c -- xjl -sS_ d1 t1 | grep j3`" != "j3_terminated" ] ; then 
	echo "j3 is not terminated !"; exit 1
fi
if [ "`dio87c -- xjl -sS_ d1 t1 | grep j4`" != "j4_canceled" ] ; then 
	echo "j4 is not canceled !"; exit 1
fi
if [ "`dio87c -- xjl -sS_ d1 t1 | grep j5`" != "j5_terminated" ] ; then 
	echo "j5 is not terminated !"; exit 1
fi
if [ "`dio87c -- xjl -sS_ d1 t1 | grep j6`" != "j6_terminated" ] ; then 
	echo "j6 is not terminated !"; exit 1
fi
if [ "`dio87c -- xjl -sS_ d1 t1 | grep j7`" != "j7_canceled" ] ; then 
	echo "j7 is not canceled !"; exit 1
fi

if [ "`dio87c -- xjdl -sS_ d1 t1 | grep j1_j2`" != "j1_j2_validated" ] ; then 
	echo "dependence j1-j2 is not validated !"; exit 1
fi
if [ "`dio87c -- xjdl -sS_ d1 t1 | grep j1_j3`" != "j1_j3_validated" ] ; then 
	echo "dependence j1-j3 is not validated !"; exit 1
fi
if [ "`dio87c -- xjdl -sS_ d1 t1 | grep j1_j4`" != "j1_j4_canceled" ] ; then 
	echo "dependence j1-j4 is not canceled !"; exit 1
fi
if [ "`dio87c -- xjdl -sS_ d1 t1 | grep j2_j5`" != "j2_j5_validated" ] ; then 
	echo "dependence j2-j5 is not validated !"; exit 1
fi
if [ "`dio87c -- xjdl -sS_ d1 t1 | grep j3_j6`" != "j3_j6_validated" ] ; then 
	echo "dependence j3-j6 is not validated !"; exit 1
fi
if [ "`dio87c -- xjdl -sS_ d1 t1 | grep j4_j7`" != "j4_j7_canceled" ] ; then 
	echo "dependence j4-j7 is not canceled !"; exit 1
fi


dio87c rk r1 || exit 1
dio87c srk r1 || exit 1
dio87c xdk d1 || exit 1
dio87c ldk d1 || exit 1

waitMessageSending
mem2=`dio87c -- memory` || exit 1
if [ $mem1 != $mem2 ] ; then
	echo "dio87d : memory error $mem1 -> $mem2"
	exit 1
fi


stopDio87d || exit 1

