DG_BEGIN([tst04], [Check day creation process])
DG_DIO87D_START()


dnl ---------------------------------------------------------------------------
DG_MSG_CHECKING([Check exploitation day creation])
DG_MEMORY(1)

dnl create a disabled day from an empty referential
DG_EXEC_OR_DIE([ra r1])
DG_EXEC([rp -d r1 "$dayDate" d1],,,DG_DIE([Can't create a new day!]))
DG_EXEC([xdc],res,,DG_DIE([Can't get day count!]))
DG_IF([$res -ne 1],DG_DIE([Day count is not 1!]))
DG_EXEC([xdl | grep "^d1$"],,, DG_DIE([Can't find the day d1!]))

DG_CHECK_FIELD([xdi d1], [Start Time], [$dayDate], 
	[The start time is not set!])
DG_CHECK_FIELD([xdi d1], [Referential], [r1],
	[The referential property is not set!])
DG_CHECK_FIELD([xdi d1], [Enabled], [false],
	[The enabled property is not false!])

dnl enable and disable day
DG_EXEC_OR_DIE([xdse d1 true],[Can't enable the exploitation day!])
DG_CHECK_FIELD([xdi d1],[Enabled],[true],
	[The enabled property is not true!])
DG_EXEC_OR_DIE([xdse d1 false],[Can't disable the exploitation day!])
DG_CHECK_FIELD([xdi d1],[Enabled],[false],
	[The enabled property is not false!])

DG_EXEC_OR_DIE([xdk d1])
DG_EXEC([xdc],res,,DG_DIE([Can't get day count!]))
DG_IF([$res -ne 0],DG_DIE([Day count is not 0!]))
DG_EXEC_OR_DIE([ldk d1])
DG_EXEC_OR_DIE([rk r1])
DG_EXEC_OR_DIE([srk r1])

DG_EXEC([xdk d1],,DG_DIE([Can delete a day which does not exist!]))

DG_MEMORY_CHECK(1)
DG_MSG_DONE()

dnl ---------------------------------------------------------------------------
DG_MSG_CHECKING([Check exploitation task creation])
DG_MEMORY(1)

DG_EXEC_OR_DIE([ta tg1])
DG_EXEC_OR_DIE([qa tg1 q1])

DG_EXEC_OR_DIE([ra r1])
DG_EXEC_OR_DIE([rta r1 t1 task1])
DG_EXEC_OR_DIE([rtoa r1 t1 add always])
DG_EXEC_OR_DIE([rtst r1 t1 tg1 q1])

DG_EXEC_OR_DIE([rta r1 t2 task2])
DG_EXEC_OR_DIE([rtoa r1 t2 add always])
DG_EXEC_OR_DIE([rtst r1 t2 none])

DG_EXEC_OR_DIE([rta r1 t3])
DG_EXEC_OR_DIE([rtoa r1 t3 add always])

DG_EXEC_OR_DIE([rta r1 t4])

DG_EXEC_OR_DIE([rtsoec r1 t1 false])
DG_EXEC_OR_DIE([rtsoec r1 t2 true])
DG_EXEC_OR_DIE([rtswad r1 t2 false])
DG_EXEC_OR_DIE([rtswad r1 t3 true])

DG_EXEC([rp -d r1 "$dayDate" d1],,,DG_DIE([Can't create a new day!]))
DG_EXEC([xdc],res,,DG_DIE([Can't get day count!]))
DG_IF([$res -ne 1],DG_DIE([Day count is not 1!]))
DG_EXEC([xdl | grep "^d1$"],,, DG_DIE([Can't find the day d1!]))

DG_EXEC([xtc d1],res,,DG_DIE([Can't get task count!]))
DG_IF([$res -ne 3],DG_DIE([Task count is not 1!]))
DG_EXEC([xtl d1 | grep "^t1$"],,, DG_DIE([Can't find the task t1!]))
DG_EXEC([xtl d1 | grep "^t2$"],,, DG_DIE([Can't find the task t2!]))
DG_EXEC([xtl d1 | grep "^t3$"],,, DG_DIE([Can't find the task t3!]))
DG_EXEC([xtl d1 | grep "^t4$"],, DG_DIE([Task t4 should not be planned!]))

DG_CHECK_FIELD([xti d1 t1], [Day Name], [d1],
	[The day name of the task is not set!])
DG_CHECK_FIELD([xti d1 t1], [Description], [task1],
	[The task description is not set!])

DG_CHECK_FIELD([xti d1 t1],[On Error Continue],[false],
	[The 'on error continue' property is not set!])
DG_CHECK_FIELD([xti d1 t2],[On Error Continue],[true],
	[The 'on error continue' property is not set!])

DG_CHECK_FIELD([xti d1 t2], [Wait All Dependencies], [false],
	[The 'wait all dependencies' property is not set!])
DG_CHECK_FIELD([xti d1 t3], [Wait All Dependencies], [true],
	[The 'wait all dependencies' property is not set!])

DG_CHECK_FIELD([xti d1 t1], [Queue], [q1], [The queue is not set (t1)!])
DG_CHECK_FIELD([xti d1 t1], [Target], [tg1], [The target is not set (t1)!])

DG_CHECK_FIELD([xti d1 t2], [Queue], [none], [The queue is not set (t2)!])
DG_CHECK_FIELD([xti d1 t2], [Target], [none], [The target is not set (t2)!])

DG_CHECK_FIELD([xti d1 t3], [Queue], [batch], 
	[The queue is not set (t3)!])
DG_CHECK_FIELD([xti d1 t3], [Target], [localhost],
	[The target is not set (t3)!])

DG_EXEC([qxtc tg1 q1 | grep "^1$"],,,
	DG_DIE([The task list count of a queue is not 1!]))
DG_EXEC([qxtl tg1 q1 -S_ | grep "^d1_t1$"],,,
	DG_DIE([Can't find a task in the task list of a queue!]))

DG_EXEC_OR_DIE([xdk d1])
DG_EXEC([xdc],res,,DG_DIE([Can't get day count!]))
DG_IF([$res -ne 0],DG_DIE([Day count is not 0!]))
DG_EXEC_OR_DIE([ldk d1])
DG_EXEC_OR_DIE([rk r1])
DG_EXEC_OR_DIE([srk r1])
DG_EXEC_OR_DIE([tk tg1])

DG_MEMORY_CHECK(1)
DG_MSG_DONE()

dnl ---------------------------------------------------------------------------
DG_MSG_CHECKING([Check exploitation job creation])
DG_MEMORY(1)

DG_EXEC_OR_DIE([ra r1])
DG_EXEC_OR_DIE([rta r1 t1])
DG_EXEC_OR_DIE([rtoa r1 t1 add always])

DG_EXEC_OR_DIE([rja r1 t1 j1 job1])
DG_EXEC_OR_DIE([rjsp r1 t1 j1 "/bin/ls"])
DG_EXEC_OR_DIE([rjsa r1 t1 j1 argument1])
DG_EXEC_OR_DIE([rjst r1 t1 j1  25 35])

DG_EXEC_OR_DIE([rja r1 t1 j2 job2])
DG_EXEC_OR_DIE([rjsp r1 t1 j2 "/bin/echo"])
DG_EXEC_OR_DIE([rjsa r1 t1 j2 argument2])

DG_EXEC_OR_DIE([rjsoec r1 t1 j1 true])
DG_EXEC_OR_DIE([rjsoec r1 t1 j2 false])
DG_EXEC_OR_DIE([rjswad r1 t1 j1 false])
DG_EXEC_OR_DIE([rjswad r1 t1 j2 true])

DG_EXEC([rp -d r1 "$dayDate" d1],,,DG_DIE([Can't create a new day!]))
DG_EXEC([xdl | grep "^d1$"],,, DG_DIE([Can't find the day d1!]))
DG_EXEC([xtl d1 | grep "^t1$"],,, DG_DIE([Can't find the task t1!]))

DG_EXEC([xjc d1 t1],res,,DG_DIE([Can't get job count!]))
DG_IF([$res -ne 2],DG_DIE([Day count is not 2!]))
DG_EXEC([xjl d1 t1 | grep "^j1$"],,, DG_DIE([Can't find the job j1!]))
DG_EXEC([xjl d1 t1 | grep "^j2$"],,, DG_DIE([Can't find the job j2!]))

DG_EXEC([xji d1 t1 j1 -S_ | grep "^Day Name_d1$"],,,
	DG_DIE([The day name of the job is not set!]))
DG_EXEC([xji d1 t1 j1 -S_ | grep "^Task Name_t1$"],,,
	DG_DIE([The task name of the job is not set!]))
DG_EXEC([xji d1 t1 j1 -S_ | grep "^Path_/bin/ls$"],,,
	DG_DIE([The job path of j1 is not set!]))
DG_EXEC([xji d1 t1 j1 -S_ | grep "^Argument_argument1$"],,,
	DG_DIE([The job argument of j1 is not set!]))
DG_EXEC([xji d1 t1 j1 -S_ | grep "^Start Tempo_25$"],,,
	DG_DIE([The start tempo of j1 is not set!]))
DG_EXEC([xji d1 t1 j1 -S_ | grep "^End Tempo_35$"],,,
	DG_DIE([The end tempo of j1 is not set!]))

DG_EXEC([xji d1 t1 j1 -S_ | grep "^On Error Continue_true$"],,,
	DG_DIE([The On Error Continue property is not set!]))
DG_EXEC([xji d1 t1 j2 -S_ | grep "^On Error Continue_false$"],,,
	DG_DIE([The On Error Continue property is not set!]))
DG_EXEC([xji d1 t1 j1 -S_ | grep "^Wait All Dependencies_false$"],,,
	DG_DIE([The Wait All Dependencies_false property is not set!]))
DG_EXEC([xji d1 t1 j2 -S_ | grep "^Wait All Dependencies_true$"],,,
	DG_DIE([The Wait All Dependencies_false property is not set!]))

DG_EXEC([xji d1 t1 j2 -S_ | grep "^Path_/bin/echo$"],,,
	DG_DIE([The job path of j2 is not set!]))
DG_EXEC([xji d1 t1 j2 -S_ | grep "^Argument_argument2$"],,,
	DG_DIE([The job argument of j2 is not set!]))

DG_EXEC_OR_DIE([xdk d1])
DG_EXEC_OR_DIE([ldk d1])
DG_EXEC_OR_DIE([rk r1])
DG_EXEC_OR_DIE([srk r1])

DG_MEMORY_CHECK(1)
DG_MSG_DONE()

dnl ---------------------------------------------------------------------------
DG_MSG_CHECKING([Check task dependencies creation])
DG_MEMORY(1)

DG_EXEC_OR_DIE([ra r1])
DG_EXEC_OR_DIE([rta r1 t1])
DG_EXEC_OR_DIE([rtoa r1 t1 add always])
DG_EXEC_OR_DIE([rta r1 t2])
DG_EXEC_OR_DIE([rtoa r1 t2 add always])
DG_EXEC_OR_DIE([rta r1 t3])
DG_EXEC_OR_DIE([rtoa r1 t3 add always])
DG_EXEC_OR_DIE([rta r1 t4])
DG_EXEC_OR_DIE([rtoa r1 t4 add always])

DG_EXEC_OR_DIE([rtda r1 t1 t2 always])
DG_EXEC_OR_DIE([rtda r1 t2 t3 onerror])
DG_EXEC_OR_DIE([rtda r1 t3 t4 onsuccess])

DG_EXEC([rp -d r1 "$dayDate" d1],,,DG_DIE([Can't create a new day!]))
DG_EXEC([xdl | grep "^d1$"],,, DG_DIE([Can't find the day d1!]))

DG_EXEC([xtdc d1 ],res,,DG_DIE([Can't get task dependence count!]))
DG_IF([$res -ne 3],DG_DIE([Task dependence count is not 1!]))

DG_EXEC([xtdl -tS_ d1 | grep "^t1_t2_always$"],,, 
	DG_DIE([Can't find a task dependence (type always)!]))
DG_EXEC([xtdl -tS_ d1 | grep "^t2_t3_onerror$"],,, 
	DG_DIE([Can't find a task dependence (type onerror)!]))
DG_EXEC([xtdl -tS_ d1 | grep "^t3_t4_onsuccess$"],,, 
	DG_DIE([Can't find a task dependence (type onsuccess)!]))

DG_EXEC_OR_DIE([xdk d1])
DG_EXEC_OR_DIE([ldk d1])
DG_EXEC_OR_DIE([rk r1])
DG_EXEC_OR_DIE([srk r1])


DG_MEMORY_CHECK(1)
DG_MSG_DONE()


dnl ---------------------------------------------------------------------------
DG_MSG_CHECKING([Check job dependencies creation])
DG_MEMORY(1)

DG_EXEC_OR_DIE([ra r1])
DG_EXEC_OR_DIE([rta r1 t1])
DG_EXEC_OR_DIE([rtoa r1 t1 add always])
DG_EXEC_OR_DIE([rja r1 t1 j1])
DG_EXEC_OR_DIE([rja r1 t1 j2])
DG_EXEC_OR_DIE([rja r1 t1 j3])
DG_EXEC_OR_DIE([rja r1 t1 j4])
DG_EXEC_OR_DIE([rjda r1 t1 j1 j2 always])
DG_EXEC_OR_DIE([rjda r1 t1 j2 j3 onerror])
DG_EXEC_OR_DIE([rjda r1 t1 j3 j4 onsuccess])

DG_EXEC([rp -d r1 "$dayDate" d1],,,DG_DIE([Can't create a new day!]))
DG_EXEC([xdl | grep "^d1$"],,, DG_DIE([Can't find the day d1!]))

DG_EXEC([xjdc d1 t1],res,,DG_DIE([Can't get job dependence count!]))
DG_IF([$res -ne 3],DG_DIE([Job dependence count is not 1!]))

DG_EXEC([xjdl -tS_ d1 t1 | grep "^j1_j2_always$"],,, 
	DG_DIE([Can't find a job dependence (type always)!]))
DG_EXEC([xjdl -tS_ d1 t1 | grep "^j2_j3_onerror$"],,, 
	DG_DIE([Can't find a job dependence (type onerror)!]))
DG_EXEC([xjdl -tS_ d1 t1 | grep "^j3_j4_onsuccess$"],,, 
	DG_DIE([Can't find a job dependence (type onsuccess)!]))

DG_EXEC_OR_DIE([xdk d1])
DG_EXEC_OR_DIE([ldk d1])
DG_EXEC_OR_DIE([rk r1])
DG_EXEC_OR_DIE([srk r1])

DG_MEMORY_CHECK(1)
DG_MSG_DONE()

dnl ---------------------------------------------------------------------------
DG_MSG_CHECKING([Check task condition creation])
DG_MEMORY(1)

DG_EXEC_OR_DIE([va v1])
DG_EXEC_OR_DIE([ra r1])
DG_EXEC_OR_DIE([rta r1 t1])
DG_EXEC_OR_DIE([rtoa r1 t1 add always])

DG_EXEC_OR_DIE([rtca r1 t1 file "/tmp/file1"])
DG_EXEC_OR_DIE([rtca r1 t1 manual "ready_for_execution"])
DG_EXEC_OR_DIE([rtca r1 t1 hmin "08:00" 0])
DG_EXEC_OR_DIE([rtca r1 t1 hmax "09:00" 0])
DG_EXEC_OR_DIE([rtca r1 t1 hlate "12:00" 0])
DG_EXEC_OR_DIE([rtca r1 t1 if_equal v1 value1])
DG_EXEC_OR_DIE([rtca r1 t1 if_not_equal v1 value2])

DG_EXEC([rp -d r1 "$dayDate" d1],,,DG_DIE([Can't create a new day!]))
DG_EXEC([xdl | grep "^d1$"],,, DG_DIE([Can't find the day d1!]))

DG_EXEC([xtcl -S_ d1 t1 | grep "^file_/tmp/file1$"],,, 
	DG_DIE([Can't find a task condition (file)!]))
DG_EXEC([xtcl -S_ d1 t1 | grep "^manual_ready_for_execution$"],,, 
	DG_DIE([Can't find a task condition (manual)!]))
DG_EXEC([xtcl -S_ d1 t1 | grep "^hmin_08:00_+0$"],,, 
	DG_DIE([Can't find a task condition (hmin)!]))
DG_EXEC([xtcl -S_ d1 t1 | grep "^hmax_09:00_+0$"],,, 
	DG_DIE([Can't find a task condition (hmax)!]))
DG_EXEC([xtcl -S_ d1 t1 | grep "^hlate_12:00_+0$"],,, 
	DG_DIE([Can't find a task condition (hlate)!]))
DG_EXEC([xtcl -S_ d1 t1 | grep "^if_equal_v1_value1$"],,, 
	DG_DIE([Can't find a task condition (if_equal)!]))
DG_EXEC([xtcl -S_ d1 t1 | grep "^if_not_equal_v1_value2$"],,, 
	DG_DIE([Can't find a task condition (if_not_equal)!]))

DG_EXEC_OR_DIE([xdk d1])
DG_EXEC_OR_DIE([ldk d1])
DG_EXEC_OR_DIE([rk r1])
DG_EXEC_OR_DIE([srk r1])
DG_EXEC_OR_DIE([vk v1])

DG_MEMORY_CHECK(1)
DG_MSG_DONE()

DG_DIO87D_STOP()
DG_END()

