#! /bin/sh
#
#      Diogene87
#      Copyright (C) 2003,2004,2005,2006,2007 - Dominique Parisot
#
if [ "x$buildpath" = "x" ] ; then
	buildpath=`pwd`
fi
if [ "`uname`" = "Linux" ] ; then
	echo "Setting ulimit"
	ulimit -c unlimited
	ulimit -n 10
fi

dio87d_dir="$buildpath/../src/dio87d"
dio87c_dir="$buildpath/../src/dio87c"
dio87d_cmd="$dio87d_dir/dio87d"
dio87c_cmd="$dio87c_dir/dio87c"
PATH="$dio87d_dir:$dio87c_dir:$PATH"
export PATH
export DG87_USER="admin"
export DG87_PASSWORD=""
JOBPATH="$buildpath/$srcdir/jobs"
DATAPATH="$buildpath/data"
dayDate=`date +"%Y-%m-%d %H:%M:%S"`
# check data directory
if [ ! -d "$DATAPATH"  ]; then
# create directory
mkdir "$DATAPATH" || exit 1 
else
# remove previous data files
rm "$DATAPATH"/* -f >/dev/null 2>&1 
fi
# create 'dio87d' configuration file
cat > $DATAPATH/dio87d.conf << EOF
IPPORT=9993
PID_FILE=$DATAPATH/dio87d.pid
DATA_DIR=$DATAPATH
SAVE_TEMPO=300
LOG_LEVEL=NONE
EOF

# create 'dio87c' configuration file
cat > $DATAPATH/dio87c.conf << EOF
DG87_ADDRESS=localhost
DG87_IPPORT=9993
EOF
ps -e | grep [d]io87d > /dev/null 
if [ $? -eq 0 ]; then

echo "dio87d is already running";exit 1 
fi

echo "__________________________________________________________________"

echo "|"

echo "| tst04 (Check day creation process)"

echo "|"

printf " Start dio87d ...................................................."

# initialize previous database
rm DATAPATH/dio87d.data >/dev/null 2>&1
"$dio87d_cmd" -C "$DATAPATH/dio87d.conf" -I >/dev/null 2>&1
"$dio87d_cmd" -C "$DATAPATH/dio87d.conf" -d $DAEMON_OPTION
sleep 1
dio87c -- version >/dev/null 2>&1
if [  $? -ne 0 ]; then
echo ""
echo "Can't communicate with dio87d";exit 1 
fi


echo " done"


printf " Check exploitation day creation ................................."

mema1=`dio87c -- memory`
if [ $? -ne 0 ]; then
if [ "$mema1" = "Unknown command 'memory'" ]; then
mema1=0
else
echo ""
echo "Error of the memory command";exit 1  
fi

fi


dio87c -- ra r1 || exit 1 
dio87c -- rp -d r1 "$dayDate" d1 > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't create a new day!";exit 1 
fi

res=`dio87c -- xdc`
if [ $? -ne 0 ]; then
echo ""
echo "Can't get day count!";exit 1 
fi

if [ $res -ne 1 ]; then
echo ""
echo "Day count is not 1!";exit 1 
fi

dio87c -- xdl | grep "^d1$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't find the day d1!";exit 1 
fi


res=`dio87c -- xdi d1`
if [ $? -ne 0 ]; then
echo ""
echo "The command 'xdi d1' returns an error";exit 1 
fi
echo "$res" | grep "^Start Time:.$dayDate$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "ERROR: The command (xdi d1) does not return (Start Time:$dayDate)" echo ""
echo "The start time is not set!";exit 1 
fi

res=`dio87c -- xdi d1`
if [ $? -ne 0 ]; then
echo ""
echo "The command 'xdi d1' returns an error";exit 1 
fi
echo "$res" | grep "^Referential:.r1$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "ERROR: The command (xdi d1) does not return (Referential:r1)" echo ""
echo "The referential property is not set!";exit 1 
fi

res=`dio87c -- xdi d1`
if [ $? -ne 0 ]; then
echo ""
echo "The command 'xdi d1' returns an error";exit 1 
fi
echo "$res" | grep "^Enabled:.false$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "ERROR: The command (xdi d1) does not return (Enabled:false)" echo ""
echo "The enabled property is not false!";exit 1 
fi


dio87c -- xdse d1 true 
if [  $? -ne 0 ]; then
echo ""
echo "Can't enable the exploitation day!";exit 1 
fi


res=`dio87c -- xdi d1`
if [ $? -ne 0 ]; then
echo ""
echo "The command 'xdi d1' returns an error";exit 1 
fi
echo "$res" | grep "^Enabled:.true$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "ERROR: The command (xdi d1) does not return (Enabled:true)" echo ""
echo "The enabled property is not true!";exit 1 
fi

dio87c -- xdse d1 false 
if [  $? -ne 0 ]; then
echo ""
echo "Can't disable the exploitation day!";exit 1 
fi


res=`dio87c -- xdi d1`
if [ $? -ne 0 ]; then
echo ""
echo "The command 'xdi d1' returns an error";exit 1 
fi
echo "$res" | grep "^Enabled:.false$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "ERROR: The command (xdi d1) does not return (Enabled:false)" echo ""
echo "The enabled property is not false!";exit 1 
fi


dio87c -- xdk d1 || exit 1 
res=`dio87c -- xdc`
if [ $? -ne 0 ]; then
echo ""
echo "Can't get day count!";exit 1 
fi

if [ $res -ne 0 ]; then
echo ""
echo "Day count is not 0!";exit 1 
fi

dio87c -- ldk d1 || exit 1 
dio87c -- rk r1 || exit 1 
dio87c -- srk r1 || exit 1 

dio87c -- xdk d1 > /dev/null 
if [ $? -eq 0 ]; then
echo ""
echo "Can delete a day which does not exist!";exit 1 
fi


memb1=`dio87c -- memory`
if [ $? -ne 0 ]; then
if [ "$memb1" = "Unknown command 'memory'" ]; then
memb1=0
else
echo ""
echo "Error of the memory command";exit 1  
fi

fi
if [  $mema1 -ne $memb1  ]; then
	echo ""
echo "Memory error : $mema1 -> $memb1";exit 1 
fi


echo " done"

printf " Check exploitation task creation ................................"

mema1=`dio87c -- memory`
if [ $? -ne 0 ]; then
if [ "$mema1" = "Unknown command 'memory'" ]; then
mema1=0
else
echo ""
echo "Error of the memory command";exit 1  
fi

fi


dio87c -- ta tg1 || exit 1 
dio87c -- qa tg1 q1 || exit 1 

dio87c -- ra r1 || exit 1 
dio87c -- rta r1 t1 task1 || exit 1 
dio87c -- rtoa r1 t1 add always || exit 1 
dio87c -- rtst r1 t1 tg1 q1 || exit 1 

dio87c -- rta r1 t2 task2 || exit 1 
dio87c -- rtoa r1 t2 add always || exit 1 
dio87c -- rtst r1 t2 none || exit 1 

dio87c -- rta r1 t3 || exit 1 
dio87c -- rtoa r1 t3 add always || exit 1 

dio87c -- rta r1 t4 || exit 1 

dio87c -- rtsoec r1 t1 false || exit 1 
dio87c -- rtsoec r1 t2 true || exit 1 
dio87c -- rtswad r1 t2 false || exit 1 
dio87c -- rtswad r1 t3 true || exit 1 

dio87c -- rp -d r1 "$dayDate" d1 > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't create a new day!";exit 1 
fi

res=`dio87c -- xdc`
if [ $? -ne 0 ]; then
echo ""
echo "Can't get day count!";exit 1 
fi

if [ $res -ne 1 ]; then
echo ""
echo "Day count is not 1!";exit 1 
fi

dio87c -- xdl | grep "^d1$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't find the day d1!";exit 1 
fi


res=`dio87c -- xtc d1`
if [ $? -ne 0 ]; then
echo ""
echo "Can't get task count!";exit 1 
fi

if [ $res -ne 3 ]; then
echo ""
echo "Task count is not 1!";exit 1 
fi

dio87c -- xtl d1 | grep "^t1$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't find the task t1!";exit 1 
fi

dio87c -- xtl d1 | grep "^t2$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't find the task t2!";exit 1 
fi

dio87c -- xtl d1 | grep "^t3$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't find the task t3!";exit 1 
fi

dio87c -- xtl d1 | grep "^t4$" > /dev/null 
if [ $? -eq 0 ]; then
echo ""
echo "Task t4 should not be planned!";exit 1 
fi


res=`dio87c -- xti d1 t1`
if [ $? -ne 0 ]; then
echo ""
echo "The command 'xti d1 t1' returns an error";exit 1 
fi
echo "$res" | grep "^Day Name:.d1$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "ERROR: The command (xti d1 t1) does not return (Day Name:d1)" echo ""
echo "The day name of the task is not set!";exit 1 
fi

res=`dio87c -- xti d1 t1`
if [ $? -ne 0 ]; then
echo ""
echo "The command 'xti d1 t1' returns an error";exit 1 
fi
echo "$res" | grep "^Description:.task1$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "ERROR: The command (xti d1 t1) does not return (Description:task1)" echo ""
echo "The task description is not set!";exit 1 
fi


res=`dio87c -- xti d1 t1`
if [ $? -ne 0 ]; then
echo ""
echo "The command 'xti d1 t1' returns an error";exit 1 
fi
echo "$res" | grep "^On Error Continue:.false$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "ERROR: The command (xti d1 t1) does not return (On Error Continue:false)" echo ""
echo "The 'on error continue' property is not set!";exit 1 
fi

res=`dio87c -- xti d1 t2`
if [ $? -ne 0 ]; then
echo ""
echo "The command 'xti d1 t2' returns an error";exit 1 
fi
echo "$res" | grep "^On Error Continue:.true$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "ERROR: The command (xti d1 t2) does not return (On Error Continue:true)" echo ""
echo "The 'on error continue' property is not set!";exit 1 
fi


res=`dio87c -- xti d1 t2`
if [ $? -ne 0 ]; then
echo ""
echo "The command 'xti d1 t2' returns an error";exit 1 
fi
echo "$res" | grep "^Wait All Dependencies:.false$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "ERROR: The command (xti d1 t2) does not return (Wait All Dependencies:false)" echo ""
echo "The 'wait all dependencies' property is not set!";exit 1 
fi

res=`dio87c -- xti d1 t3`
if [ $? -ne 0 ]; then
echo ""
echo "The command 'xti d1 t3' returns an error";exit 1 
fi
echo "$res" | grep "^Wait All Dependencies:.true$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "ERROR: The command (xti d1 t3) does not return (Wait All Dependencies:true)" echo ""
echo "The 'wait all dependencies' property is not set!";exit 1 
fi


res=`dio87c -- xti d1 t1`
if [ $? -ne 0 ]; then
echo ""
echo "The command 'xti d1 t1' returns an error";exit 1 
fi
echo "$res" | grep "^Queue:.q1$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "ERROR: The command (xti d1 t1) does not return (Queue:q1)" echo ""
echo "The queue is not set (t1)!";exit 1 
fi

res=`dio87c -- xti d1 t1`
if [ $? -ne 0 ]; then
echo ""
echo "The command 'xti d1 t1' returns an error";exit 1 
fi
echo "$res" | grep "^Target:.tg1$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "ERROR: The command (xti d1 t1) does not return (Target:tg1)" echo ""
echo "The target is not set (t1)!";exit 1 
fi


res=`dio87c -- xti d1 t2`
if [ $? -ne 0 ]; then
echo ""
echo "The command 'xti d1 t2' returns an error";exit 1 
fi
echo "$res" | grep "^Queue:.none$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "ERROR: The command (xti d1 t2) does not return (Queue:none)" echo ""
echo "The queue is not set (t2)!";exit 1 
fi

res=`dio87c -- xti d1 t2`
if [ $? -ne 0 ]; then
echo ""
echo "The command 'xti d1 t2' returns an error";exit 1 
fi
echo "$res" | grep "^Target:.none$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "ERROR: The command (xti d1 t2) does not return (Target:none)" echo ""
echo "The target is not set (t2)!";exit 1 
fi


res=`dio87c -- xti d1 t3`
if [ $? -ne 0 ]; then
echo ""
echo "The command 'xti d1 t3' returns an error";exit 1 
fi
echo "$res" | grep "^Queue:.batch$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "ERROR: The command (xti d1 t3) does not return (Queue:batch)" echo ""
echo "The queue is not set (t3)!";exit 1 
fi

res=`dio87c -- xti d1 t3`
if [ $? -ne 0 ]; then
echo ""
echo "The command 'xti d1 t3' returns an error";exit 1 
fi
echo "$res" | grep "^Target:.localhost$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "ERROR: The command (xti d1 t3) does not return (Target:localhost)" echo ""
echo "The target is not set (t3)!";exit 1 
fi


dio87c -- qxtc tg1 q1 | grep "^1$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "The task list count of a queue is not 1!";exit 1 
fi

dio87c -- qxtl tg1 q1 -S_ | grep "^d1_t1$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't find a task in the task list of a queue!";exit 1 
fi


dio87c -- xdk d1 || exit 1 
res=`dio87c -- xdc`
if [ $? -ne 0 ]; then
echo ""
echo "Can't get day count!";exit 1 
fi

if [ $res -ne 0 ]; then
echo ""
echo "Day count is not 0!";exit 1 
fi

dio87c -- ldk d1 || exit 1 
dio87c -- rk r1 || exit 1 
dio87c -- srk r1 || exit 1 
dio87c -- tk tg1 || exit 1 

memb1=`dio87c -- memory`
if [ $? -ne 0 ]; then
if [ "$memb1" = "Unknown command 'memory'" ]; then
memb1=0
else
echo ""
echo "Error of the memory command";exit 1  
fi

fi
if [  $mema1 -ne $memb1  ]; then
	echo ""
echo "Memory error : $mema1 -> $memb1";exit 1 
fi


echo " done"

printf " Check exploitation job creation ................................."

mema1=`dio87c -- memory`
if [ $? -ne 0 ]; then
if [ "$mema1" = "Unknown command 'memory'" ]; then
mema1=0
else
echo ""
echo "Error of the memory command";exit 1  
fi

fi


dio87c -- ra r1 || exit 1 
dio87c -- rta r1 t1 || exit 1 
dio87c -- rtoa r1 t1 add always || exit 1 

dio87c -- rja r1 t1 j1 job1 || exit 1 
dio87c -- rjsp r1 t1 j1 "/bin/ls" || exit 1 
dio87c -- rjsa r1 t1 j1 argument1 || exit 1 
dio87c -- rjst r1 t1 j1  25 35 || exit 1 

dio87c -- rja r1 t1 j2 job2 || exit 1 
dio87c -- rjsp r1 t1 j2 "/bin/echo" || exit 1 
dio87c -- rjsa r1 t1 j2 argument2 || exit 1 

dio87c -- rjsoec r1 t1 j1 true || exit 1 
dio87c -- rjsoec r1 t1 j2 false || exit 1 
dio87c -- rjswad r1 t1 j1 false || exit 1 
dio87c -- rjswad r1 t1 j2 true || exit 1 

dio87c -- rp -d r1 "$dayDate" d1 > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't create a new day!";exit 1 
fi

dio87c -- xdl | grep "^d1$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't find the day d1!";exit 1 
fi

dio87c -- xtl d1 | grep "^t1$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't find the task t1!";exit 1 
fi


res=`dio87c -- xjc d1 t1`
if [ $? -ne 0 ]; then
echo ""
echo "Can't get job count!";exit 1 
fi

if [ $res -ne 2 ]; then
echo ""
echo "Day count is not 2!";exit 1 
fi

dio87c -- xjl d1 t1 | grep "^j1$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't find the job j1!";exit 1 
fi

dio87c -- xjl d1 t1 | grep "^j2$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't find the job j2!";exit 1 
fi


dio87c -- xji d1 t1 j1 -S_ | grep "^Day Name_d1$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "The day name of the job is not set!";exit 1 
fi

dio87c -- xji d1 t1 j1 -S_ | grep "^Task Name_t1$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "The task name of the job is not set!";exit 1 
fi

dio87c -- xji d1 t1 j1 -S_ | grep "^Path_/bin/ls$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "The job path of j1 is not set!";exit 1 
fi

dio87c -- xji d1 t1 j1 -S_ | grep "^Argument_argument1$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "The job argument of j1 is not set!";exit 1 
fi

dio87c -- xji d1 t1 j1 -S_ | grep "^Start Tempo_25$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "The start tempo of j1 is not set!";exit 1 
fi

dio87c -- xji d1 t1 j1 -S_ | grep "^End Tempo_35$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "The end tempo of j1 is not set!";exit 1 
fi


dio87c -- xji d1 t1 j1 -S_ | grep "^On Error Continue_true$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "The On Error Continue property is not set!";exit 1 
fi

dio87c -- xji d1 t1 j2 -S_ | grep "^On Error Continue_false$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "The On Error Continue property is not set!";exit 1 
fi

dio87c -- xji d1 t1 j1 -S_ | grep "^Wait All Dependencies_false$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "The Wait All Dependencies_false property is not set!";exit 1 
fi

dio87c -- xji d1 t1 j2 -S_ | grep "^Wait All Dependencies_true$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "The Wait All Dependencies_false property is not set!";exit 1 
fi


dio87c -- xji d1 t1 j2 -S_ | grep "^Path_/bin/echo$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "The job path of j2 is not set!";exit 1 
fi

dio87c -- xji d1 t1 j2 -S_ | grep "^Argument_argument2$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "The job argument of j2 is not set!";exit 1 
fi


dio87c -- xdk d1 || exit 1 
dio87c -- ldk d1 || exit 1 
dio87c -- rk r1 || exit 1 
dio87c -- srk r1 || exit 1 

memb1=`dio87c -- memory`
if [ $? -ne 0 ]; then
if [ "$memb1" = "Unknown command 'memory'" ]; then
memb1=0
else
echo ""
echo "Error of the memory command";exit 1  
fi

fi
if [  $mema1 -ne $memb1  ]; then
	echo ""
echo "Memory error : $mema1 -> $memb1";exit 1 
fi


echo " done"

printf " Check task dependencies creation ................................"

mema1=`dio87c -- memory`
if [ $? -ne 0 ]; then
if [ "$mema1" = "Unknown command 'memory'" ]; then
mema1=0
else
echo ""
echo "Error of the memory command";exit 1  
fi

fi


dio87c -- ra r1 || exit 1 
dio87c -- rta r1 t1 || exit 1 
dio87c -- rtoa r1 t1 add always || exit 1 
dio87c -- rta r1 t2 || exit 1 
dio87c -- rtoa r1 t2 add always || exit 1 
dio87c -- rta r1 t3 || exit 1 
dio87c -- rtoa r1 t3 add always || exit 1 
dio87c -- rta r1 t4 || exit 1 
dio87c -- rtoa r1 t4 add always || exit 1 

dio87c -- rtda r1 t1 t2 always || exit 1 
dio87c -- rtda r1 t2 t3 onerror || exit 1 
dio87c -- rtda r1 t3 t4 onsuccess || exit 1 

dio87c -- rp -d r1 "$dayDate" d1 > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't create a new day!";exit 1 
fi

dio87c -- xdl | grep "^d1$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't find the day d1!";exit 1 
fi


res=`dio87c -- xtdc d1 `
if [ $? -ne 0 ]; then
echo ""
echo "Can't get task dependence count!";exit 1 
fi

if [ $res -ne 3 ]; then
echo ""
echo "Task dependence count is not 1!";exit 1 
fi


dio87c -- xtdl -tS_ d1 | grep "^t1_t2_always$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't find a task dependence (type always)!";exit 1 
fi

dio87c -- xtdl -tS_ d1 | grep "^t2_t3_onerror$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't find a task dependence (type onerror)!";exit 1 
fi

dio87c -- xtdl -tS_ d1 | grep "^t3_t4_onsuccess$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't find a task dependence (type onsuccess)!";exit 1 
fi


dio87c -- xdk d1 || exit 1 
dio87c -- ldk d1 || exit 1 
dio87c -- rk r1 || exit 1 
dio87c -- srk r1 || exit 1 


memb1=`dio87c -- memory`
if [ $? -ne 0 ]; then
if [ "$memb1" = "Unknown command 'memory'" ]; then
memb1=0
else
echo ""
echo "Error of the memory command";exit 1  
fi

fi
if [  $mema1 -ne $memb1  ]; then
	echo ""
echo "Memory error : $mema1 -> $memb1";exit 1 
fi


echo " done"


printf " Check job dependencies creation ................................."

mema1=`dio87c -- memory`
if [ $? -ne 0 ]; then
if [ "$mema1" = "Unknown command 'memory'" ]; then
mema1=0
else
echo ""
echo "Error of the memory command";exit 1  
fi

fi


dio87c -- ra r1 || exit 1 
dio87c -- rta r1 t1 || exit 1 
dio87c -- rtoa r1 t1 add always || exit 1 
dio87c -- rja r1 t1 j1 || exit 1 
dio87c -- rja r1 t1 j2 || exit 1 
dio87c -- rja r1 t1 j3 || exit 1 
dio87c -- rja r1 t1 j4 || exit 1 
dio87c -- rjda r1 t1 j1 j2 always || exit 1 
dio87c -- rjda r1 t1 j2 j3 onerror || exit 1 
dio87c -- rjda r1 t1 j3 j4 onsuccess || exit 1 

dio87c -- rp -d r1 "$dayDate" d1 > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't create a new day!";exit 1 
fi

dio87c -- xdl | grep "^d1$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't find the day d1!";exit 1 
fi


res=`dio87c -- xjdc d1 t1`
if [ $? -ne 0 ]; then
echo ""
echo "Can't get job dependence count!";exit 1 
fi

if [ $res -ne 3 ]; then
echo ""
echo "Job dependence count is not 1!";exit 1 
fi


dio87c -- xjdl -tS_ d1 t1 | grep "^j1_j2_always$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't find a job dependence (type always)!";exit 1 
fi

dio87c -- xjdl -tS_ d1 t1 | grep "^j2_j3_onerror$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't find a job dependence (type onerror)!";exit 1 
fi

dio87c -- xjdl -tS_ d1 t1 | grep "^j3_j4_onsuccess$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't find a job dependence (type onsuccess)!";exit 1 
fi


dio87c -- xdk d1 || exit 1 
dio87c -- ldk d1 || exit 1 
dio87c -- rk r1 || exit 1 
dio87c -- srk r1 || exit 1 

memb1=`dio87c -- memory`
if [ $? -ne 0 ]; then
if [ "$memb1" = "Unknown command 'memory'" ]; then
memb1=0
else
echo ""
echo "Error of the memory command";exit 1  
fi

fi
if [  $mema1 -ne $memb1  ]; then
	echo ""
echo "Memory error : $mema1 -> $memb1";exit 1 
fi


echo " done"

printf " Check task condition creation ..................................."

mema1=`dio87c -- memory`
if [ $? -ne 0 ]; then
if [ "$mema1" = "Unknown command 'memory'" ]; then
mema1=0
else
echo ""
echo "Error of the memory command";exit 1  
fi

fi


dio87c -- va v1 || exit 1 
dio87c -- ra r1 || exit 1 
dio87c -- rta r1 t1 || exit 1 
dio87c -- rtoa r1 t1 add always || exit 1 

dio87c -- rtca r1 t1 file "/tmp/file1" || exit 1 
dio87c -- rtca r1 t1 manual "ready_for_execution" || exit 1 
dio87c -- rtca r1 t1 hmin "08:00" 0 || exit 1 
dio87c -- rtca r1 t1 hmax "09:00" 0 || exit 1 
dio87c -- rtca r1 t1 hlate "12:00" 0 || exit 1 
dio87c -- rtca r1 t1 if_equal v1 value1 || exit 1 
dio87c -- rtca r1 t1 if_not_equal v1 value2 || exit 1 

dio87c -- rp -d r1 "$dayDate" d1 > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't create a new day!";exit 1 
fi

dio87c -- xdl | grep "^d1$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't find the day d1!";exit 1 
fi


dio87c -- xtcl -S_ d1 t1 | grep "^file_/tmp/file1$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't find a task condition (file)!";exit 1 
fi

dio87c -- xtcl -S_ d1 t1 | grep "^manual_ready_for_execution$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't find a task condition (manual)!";exit 1 
fi

dio87c -- xtcl -S_ d1 t1 | grep "^hmin_08:00_+0$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't find a task condition (hmin)!";exit 1 
fi

dio87c -- xtcl -S_ d1 t1 | grep "^hmax_09:00_+0$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't find a task condition (hmax)!";exit 1 
fi

dio87c -- xtcl -S_ d1 t1 | grep "^hlate_12:00_+0$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't find a task condition (hlate)!";exit 1 
fi

dio87c -- xtcl -S_ d1 t1 | grep "^if_equal_v1_value1$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't find a task condition (if_equal)!";exit 1 
fi

dio87c -- xtcl -S_ d1 t1 | grep "^if_not_equal_v1_value2$" > /dev/null 
if [ $? -ne 0 ]; then
echo ""
echo "Can't find a task condition (if_not_equal)!";exit 1 
fi


dio87c -- xdk d1 || exit 1 
dio87c -- ldk d1 || exit 1 
dio87c -- rk r1 || exit 1 
dio87c -- srk r1 || exit 1 
dio87c -- vk v1 || exit 1 

memb1=`dio87c -- memory`
if [ $? -ne 0 ]; then
if [ "$memb1" = "Unknown command 'memory'" ]; then
memb1=0
else
echo ""
echo "Error of the memory command";exit 1  
fi

fi
if [  $mema1 -ne $memb1  ]; then
	echo ""
echo "Memory error : $mema1 -> $memb1";exit 1 
fi


echo " done"


printf " Stop dio87d ....................................................."

pid=`ps -e | grep [d]io87d`
if [ $? -ne 0 ]; then
echo ""
echo "dio87d is not executing";exit 1 
fi
pid=`echo $pid | awk '{print $1}'`
kill -s TERM $pid
sleep 1 
ps -e | grep [d]io87d > /dev/null 
if [ $? -eq 0 ]; then
echo ""
echo "dio87d is not stopped";exit 1 
fi

echo " done"
i=0
while ls "$DATAPATH" | grep "dio87d.pid" >/dev/null
do
	i=$((i+1))
	sleep 1
	if test $i -eq 10 
	then 
		echo "The PID file is not deleted"
		exit 1
	fi
done
rm -f "$DATAPATH"/*.conf || exit 1
rm -f "$DATAPATH"/*.data || exit 1
rmdir "$DATAPATH" || exit 1


