DG_BEGIN([tst05], [Check exploitation job execution])
DG_DIO87D_START()

dnl ---------------------------------------------------------------------------
DG_MSG_CHECKING([Check execution of a task with no job])
DG_MEMORY(1)
DG_EXEC_OR_DIE([ra r1])
DG_EXEC_OR_DIE([rta r1 t1])
DG_EXEC_OR_DIE([rtoa r1 t1 add always])

DG_EXEC([rp r1 today d1],,,DG_DIE())
DG_EXEC_RETRY([xti -S_ d1 t1 | grep "^State_terminated$"], 
	5, [t1 is not terminated !])

DG_EXEC_OR_DIE([rk r1])
DG_EXEC_OR_DIE([srk r1])
DG_EXEC_OR_DIE([xdk d1])
DG_EXEC_OR_DIE([ldk d1])
DG_MEMORY_CHECK(1)
DG_MSG_DONE()

dnl ---------------------------------------------------------------------------
DG_MSG_CHECKING([Check execution of one job (normal termination)])
DG_MEMORY(1)

DG_EXEC_OR_DIE([ra r1])
DG_EXEC_OR_DIE([rta r1 t1])
DG_EXEC_OR_DIE([rtoa r1 t1 add always])

DG_EXEC_OR_DIE([rja r1 t1 j1])
DG_EXEC_OR_DIE([rjsp r1 t1 j1 /bin/sleep])
DG_EXEC_OR_DIE([rjsa r1 t1 j1 6])

DG_EXEC([rp r1 today d1],,,DG_DIE())

dnl job is running
DG_EXEC_RETRY([xji -S_ d1 t1 j1 | grep "^State_running$"], 
	6, [Job is not running!])
DG_CHECK_FIELD([xti d1 t1],[State],[running], [Task is not running])

DG_EXEC([qxjc localhost batch],res,,DG_DIE())
DG_IF([$res -ne 1],DG_DIE([Number of running job in the queue is not one!]))

dnl job is terminated
DG_EXEC_RETRY([xji -S_ d1 t1 j1 | grep "^State_terminated$"], 
	6, [Job is not terminated !])
DG_CHECK_FIELD([xji d1 t1 j1], [Exit code], [0], [Exit code is not 0!])
DG_CHECK_FIELD([xti d1 t1], [State], [terminated], [Task is not terminated])

DG_EXEC([qxjc localhost batch],res,,DG_DIE())
DG_IF([$res -ne 0],DG_DIE([Number of running job in the queue is not zero!]))

DG_EXEC_OR_DIE([rk r1])
DG_EXEC_OR_DIE([srk r1])
DG_EXEC_OR_DIE([xdk d1])
DG_EXEC_OR_DIE([ldk d1])

DG_MEMORY_CHECK(1)
DG_MSG_DONE()

dnl ---------------------------------------------------------------------------
DG_MSG_CHECKING([Check execution of one job (abnormal termination)])
DG_MEMORY(1)

DG_EXEC_OR_DIE([ra r1])
DG_EXEC_OR_DIE([rta r1 t1])
DG_EXEC_OR_DIE([rtoa r1 t1 add always])

DG_EXEC_OR_DIE([rja r1 t1 j1])
DG_EXEC_OR_DIE([rjsp r1 t1 j1 /bin/false])

DG_EXEC([rp r1 today d1],,,DG_DIE())

dnl job is aborted
DG_EXEC_RETRY([xji -S_ d1 t1 j1 | grep "^State_aborted$"], 
	6, [Job is not aborted !])
DG_CHECK_FIELD([xji d1 t1 j1], [Exit code], [1], [Exit code is not 1!])
DG_CHECK_FIELD([xti d1 t1], [State], [aborted], [Task is not aborted])

DG_EXEC([qxjc localhost batch],res,,DG_DIE())
DG_IF([$res -ne 0],DG_DIE([Number of running job in the queue is not zero!]))

DG_EXEC_OR_DIE([rk r1])
DG_EXEC_OR_DIE([srk r1])
DG_EXEC_OR_DIE([xdk d1])
DG_EXEC_OR_DIE([ldk d1])

DG_MEMORY_CHECK(1)
DG_MSG_DONE()

dnl ---------------------------------------------------------------------------
DG_MSG_CHECKING([Check execution of a task with two parallel jobs])
DG_MEMORY(1)

DG_EXEC_OR_DIE([ra r1])
DG_EXEC_OR_DIE([rta r1 t1])
DG_EXEC_OR_DIE([rtoa r1 t1 add always])

DG_EXEC_OR_DIE([rja r1 t1 j1])
DG_EXEC_OR_DIE([rjsp r1 t1 j1 /bin/sleep])
DG_EXEC_OR_DIE([rjsa r1 t1 j1 3])

DG_EXEC_OR_DIE([rja r1 t1 j2])
DG_EXEC_OR_DIE([rjsp r1 t1 j2 /bin/sleep])
DG_EXEC_OR_DIE([rjsa r1 t1 j2 3])

DG_EXEC([rp r1 today d1],,,DG_DIE())

dnl job1 and job 2 are running at the same time
DG_EXEC_RETRY([xji -S_ d1 t1 j1 | grep "^State_running$"], 
	6, [Job1 is not running!])
DG_CHECK_FIELD([xji d1 t1 j1], [State], [running], [Job2 is not running])
DG_CHECK_FIELD([xti d1 t1], [State], [running], [Task is not running])
DG_EXEC([qxjc localhost batch],res,,DG_DIE())
DG_IF([$res -ne 2],DG_DIE([Number of running jobs in the queue is not two!]))

dnl job1 and job2 are terminated at the same time
DG_EXEC_RETRY([xji -S_ d1 t1 j1 | grep "^State_terminated$"], 
	6, [Job1 is not terminated!])
DG_CHECK_FIELD([xji d1 t1 j2], [State], [terminated], [Job2 is not terminated])
DG_CHECK_FIELD([xti d1 t1], [State], [terminated], [Task is not terminated])
DG_EXEC([qxjc localhost batch],res,,DG_DIE())
DG_IF([$res -ne 0],DG_DIE([Number of running job in the queue is not zero!]))

DG_EXEC_OR_DIE([rk r1])
DG_EXEC_OR_DIE([srk r1])
DG_EXEC_OR_DIE([xdk d1])
DG_EXEC_OR_DIE([ldk d1])

DG_MEMORY_CHECK(1)
DG_MSG_DONE()

dnl ---------------------------------------------------------------------------
DG_MSG_CHECKING([Check execution of a task with two serial jobs])
DG_MEMORY(1)

DG_EXEC_OR_DIE([ra r1])
DG_EXEC_OR_DIE([rta r1 t1])
DG_EXEC_OR_DIE([rtoa r1 t1 add always])

DG_EXEC_OR_DIE([rja r1 t1 j1])
DG_EXEC_OR_DIE([rjsp r1 t1 j1 /bin/sleep])
DG_EXEC_OR_DIE([rjsa r1 t1 j1 3])

DG_EXEC_OR_DIE([rja r1 t1 j2])
DG_EXEC_OR_DIE([rjsp r1 t1 j2 /bin/sleep])
DG_EXEC_OR_DIE([rjsa r1 t1 j2 3])

DG_EXEC_OR_DIE([rjda r1 t1 j1 j2])

DG_EXEC([rp r1 today d1],,,DG_DIE())

dnl job1 is running and job2 is waiting
DG_EXEC_RETRY([xji -S_ d1 t1 j1 | grep "^State_running$"], 
	6, [Job1 is not running!])
DG_EXEC_RETRY([xji -S_ d1 t1 j2 | grep "^State_wait_for_dep$"], 
	1, [Job2 is not waiting for dependencies!])
DG_CHECK_FIELD([xti d1 t1], [State], [running], [Task is not running])
DG_EXEC([qxjc localhost batch],res,,DG_DIE())
DG_IF([$res -ne 1],DG_DIE([Number of running job in the queue is not one!]))

dnl job1 is terminated and job1 is running
DG_EXEC_RETRY([xji -S_ d1 t1 j1 | grep "^State_terminated$"], 
	6, [Job1 is not terminated!])
DG_EXEC_RETRY([xji -S_ d1 t1 j2 | grep "^State_running"], 
	1, [Job2 is not running!])
DG_CHECK_FIELD([xti d1 t1], [State], [running], [Task is not running])
DG_EXEC([qxjc localhost batch],res,,DG_DIE())
DG_IF([$res -ne 1],DG_DIE([Number of running job in the queue is not one!]))

dnl job2 is terminated 
DG_EXEC_RETRY([xji -S_ d1 t1 j2 | grep "^State_terminated$"], 
	6, [Job2 is not terminated!])
DG_CHECK_FIELD([xti d1 t1], [State], [terminated], [Task is not terminated])

DG_EXEC([qxjc localhost batch],res,,DG_DIE())
DG_IF([$res -ne 0],DG_DIE([Number of running job in the queue is not zero!]))

DG_EXEC_OR_DIE([rk r1])
DG_EXEC_OR_DIE([srk r1])
DG_EXEC_OR_DIE([xdk d1])
DG_EXEC_OR_DIE([ldk d1])

DG_MEMORY_CHECK(1)
DG_MSG_DONE()

dnl ---------------------------------------------------------------------------
DG_MSG_CHECKING([Check dependence with normal termination])
DG_MEMORY(1)

DG_EXEC_OR_DIE([ra r1])
DG_EXEC_OR_DIE([rta r1 t1])
DG_EXEC_OR_DIE([rtoa r1 t1 add always])

dnl job with normal termination
DG_EXEC_OR_DIE([rja r1 t1 j1])
DG_EXEC_OR_DIE([rjsp r1 t1 j1 /bin/true])

dnl always dependence 
DG_EXEC_OR_DIE([rja r1 t1 j12])
DG_EXEC_OR_DIE([rjsp r1 t1 j12 /bin/true])
DG_EXEC_OR_DIE([rjda r1 t1 j1 j12 always])

dnl onsuccess dependence 
DG_EXEC_OR_DIE([rja r1 t1 j13])
DG_EXEC_OR_DIE([rjsp r1 t1 j13 /bin/true])
DG_EXEC_OR_DIE([rjda r1 t1 j1 j13 onsuccess])

dnl onerror dependence 
DG_EXEC_OR_DIE([rja r1 t1 j14])
DG_EXEC_OR_DIE([rjsp r1 t1 j14 /bin/true])
DG_EXEC_OR_DIE([rjda r1 t1 j1 j14 onerror])

DG_EXEC([rp r1 today d1],,,DG_DIE())

dnl job 1 is terminated 
DG_EXEC_RETRY([xji -S_ d1 t1 j1 | grep "^State_terminated$"], 
	4, [Job1 is not terminated!])
DG_EXEC_RETRY([xti -S_ d1 t1 | grep "^State_terminated$"], 
	4, [The task is not terminated!])

dnl check dependence state
DG_EXEC([xjdl -tsS_ d1 t1 | grep "^j1_j12_always_validated$"],,,
	DG_DIE([The 'always' dependence should be validated!]))
DG_EXEC([xjdl -tsS_ d1 t1 | grep "^j1_j13_onsuccess_validated$"],,,
	DG_DIE([The 'onsuccess' dependence should be validated!]))
DG_EXEC([xjdl -tsS_ d1 t1 | grep "^j1_j14_onerror_canceled$"],,,
	DG_DIE([The 'onerror' dependence should be canceled!]))

dnl check job state
DG_EXEC([xji -S_ d1 t1 j12 | grep "^State_terminated$"],,, 
	DG_DIE([The job after a 'always' dependence should be terminated!]))
DG_EXEC([xji -S_ d1 t1 j13 | grep "^State_terminated$"],,, 
	DG_DIE([The job after a 'onsuccess' dependence should be terminated!]))
DG_EXEC([xji -S_ d1 t1 j14 | grep "^State_canceled$"],,, 
	DG_DIE([The job after a 'onerror' dependence should be canceled!]))

DG_EXEC_OR_DIE([rk r1])
DG_EXEC_OR_DIE([srk r1])
DG_EXEC_OR_DIE([xdk d1])
DG_EXEC_OR_DIE([ldk d1])

DG_MEMORY_CHECK(1)
DG_MSG_DONE()

dnl ---------------------------------------------------------------------------
DG_MSG_CHECKING([Check dependence with abnormal termination])
DG_MEMORY(1)

DG_EXEC_OR_DIE([ra r1])
DG_EXEC_OR_DIE([rta r1 t1])
DG_EXEC_OR_DIE([rtoa r1 t1 add always])

dnl job with abnormal termination
DG_EXEC_OR_DIE([rja r1 t1 j1])
DG_EXEC_OR_DIE([rjsp r1 t1 j1 /bin/false])

dnl always dependence 
DG_EXEC_OR_DIE([rja r1 t1 j12])
DG_EXEC_OR_DIE([rjsp r1 t1 j12 /bin/true])
DG_EXEC_OR_DIE([rjda r1 t1 j1 j12 always])

dnl onsuccess dependence 
DG_EXEC_OR_DIE([rja r1 t1 j13])
DG_EXEC_OR_DIE([rjsp r1 t1 j13 /bin/true])
DG_EXEC_OR_DIE([rjda r1 t1 j1 j13 onsuccess])

dnl onerror dependence 
DG_EXEC_OR_DIE([rja r1 t1 j14])
DG_EXEC_OR_DIE([rjsp r1 t1 j14 /bin/true])
DG_EXEC_OR_DIE([rjda r1 t1 j1 j14 onerror])

DG_EXEC([rp r1 today d1],,,DG_DIE())

dnl job 1 is terminated 
DG_EXEC_RETRY([xji -S_ d1 t1 j1 | grep "^State_aborted$"], 
	4, [Job1 is not aborted!])
DG_EXEC_RETRY([xti -S_ d1 t1 | grep "^State_aborted$"], 
	4, [The task is not aborted!])

dnl check dependence state
DG_EXEC([xjdl -tsS_ d1 t1 | grep "^j1_j12_always_validated$"],,,
	DG_DIE([The 'always' dependence should be validated!]))
DG_EXEC([xjdl -tsS_ d1 t1 | grep "^j1_j13_onsuccess_canceled$"],,,
	DG_DIE([The 'onsuccess' dependence should be canceled!]))
DG_EXEC([xjdl -tsS_ d1 t1 | grep "^j1_j14_onerror_validated$"],,,
	DG_DIE([The 'onerror' dependence should be validated!]))

dnl check job state
DG_EXEC([xji -S_ d1 t1 j12 | grep "^State_terminated$"],,, 
	DG_DIE([The job after a 'always' dependence should be terminated!]))
DG_EXEC([xji -S_ d1 t1 j13 | grep "^State_canceled$"],,, 
	DG_DIE([The job after a 'onsuccess' dependence should be canceled!]))
DG_EXEC([xji -S_ d1 t1 j14 | grep "^State_terminated$"],,, 
	DG_DIE([The job after a 'onerror' dependence should be terminated!]))

DG_EXEC_OR_DIE([rk r1])
DG_EXEC_OR_DIE([srk r1])
DG_EXEC_OR_DIE([xdk d1])
DG_EXEC_OR_DIE([ldk d1])

DG_MEMORY_CHECK(1)
DG_MSG_DONE()


dnl ---------------------------------------------------------------------------
DG_DIO87D_STOP()
DG_END()


