#!/bin/sh
#
# file tst57.sh 
# (test the character validity control)
#
#      Diogene87
#	Copyright (C) 2003,2004,2005,2006,2007 - Dominique Parisot
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this software; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
# Boston, MA 02111-1307 USA
#


if [ "$srcdir" = "" ]; then srcdir="."; fi
. $srcdir/functions.sh
checkNoDaemon

echo "Test the character validity control"

startDio87d || exit 1

dio87c ra r1 || exit 1
dio87c rta r1 t1 || exit 1
dio87c rja r1 t1 j1 || exit 1

# referential job
echo " check path and argument of a referential job"
dio87c rjsp r1 t1 j1 "D" >/dev/null 2>&1 
if [ $? -eq 0 ] ; then
	echo "invalid character not detected by rjsp !"; exit 1
fi
dio87c rjsa r1 t1 j1 "D" >/dev/null 2>&1 
if [ $? -eq 0 ] ; then
	echo "invalid character not detected by rjsa !"; exit 1
fi

# exploitation job
echo " check path and argument of an exploitation job"
dio87c rtoa r1 t1 add always || exit 1
dio87c rp r1 "$dayDate" d1 >/dev/null || exit 1
dio87c xjsp d1 t1 j1 "D" >/dev/null 2>&1 
if [ $? -eq 0 ] ; then
	echo "invalid character not detected by rjsp !"; exit 1
fi
dio87c xjsa d1 t1 j1 "D" >/dev/null 2>&1 
if [ $? -eq 0 ] ; then
	echo "invalid character not detected by rjsa !"; exit 1
fi


# manual and file conditons
echo " check manual and file condition"
dio87c rtca r1 t1 manual "D" >/dev/null 2>&1 
if [ $? -eq 0 ] ; then
	echo "invalid character not detected for manual condition !"; exit 1
fi
dio87c rtca r1 t1 file "D" >/dev/null 2>&1 
if [ $? -eq 0 ] ; then
	echo "invalid character not detected for file condition !"; exit 1
fi

# hostname property of target
echo " check hostname property of targets"
dio87c ta trg1 || exit 1
dio87c tsh trg1 "D" >/dev/null 2>&1 
if [ $? -eq 0 ] ; then
	echo "invalid character not detected for hostname property !"; exit 1
fi
dio87c tk trg1 || exit 1

# variable value 
echo " check variable value"
dio87c va var1 || exit 1
dio87c vsv var1 "D" >/dev/null 2>&1 
if [ $? -eq 0 ] ; then
	echo "invalid character not detected for variable value !"; exit 1
fi
dio87c vk var1 || exit 1

# file monitoring
echo " check file monitoring"
dio87c fa d1 t1 "D" localhost 9993 >/dev/null 2>&1 
if [ $? -eq 0 ] ; then
	echo "invalid character not detected for file name !"; exit 1
fi
dio87c fa d1 t1 "/tmp/filexxxx" "D" 9993 >/dev/null 2>&1 
if [ $? -eq 0 ] ; then
	echo "invalid character not detected for hostname !"; exit 1
fi

# job monitoring
echo " check job monitoring"
dio87c ja d1 t1 j1 "D" "argument" localhost 9993 >/dev/null 2>&1 
if [ $? -eq 0 ] ; then
	echo "invalid character not detected for path !"; exit 1
fi
dio87c ja d1 t1 j1 "/bin/ls" "D" localhost 9993 >/dev/null 2>&1 
if [ $? -eq 0 ] ; then
	echo "invalid character not detected for argument !"; exit 1
fi
dio87c ja d1 t1 j1 "/bin/ls" "argument" "D" 9993 >/dev/null 2>&1 
if [ $? -eq 0 ] ; then
	echo "invalid character not detected for hostname !"; exit 1
fi



stopDio87d || exit 1

